searchNodes=[{"doc":"","ref":"Remedy.Api.html","title":"Remedy.Api","type":"module"},{"doc":"Puts a user in a guild. This endpoint fires the Remedy.Consumer.guild_member_add/0 event. It requires the CREATE_INSTANT_INVITE permission. Additionally, it situationally requires the MANAGE_NICKNAMES , MANAGE_ROLES , MUTE_MEMBERS , and DEAFEN_MEMBERS permissions. If successful, returns {:ok, member} or {:ok} if the user was already a member of the guild. Otherwise, returns a Remedy.Api.error/0 . Options :access_token (string) - the user's oauth2 access token :nick (string) - value to set users nickname to :roles (list of Remedy.Struct.Guild.Role.id/0 ) - array of role ids the member is assigned :mute (boolean) - if the user is muted :deaf (boolean) - if the user is deafened :access_token is always required. Examples Remedy.Api.add_guild_member( 41771983423143937, 18374719829378473, access_token: &quot;6qrZcUqja7812RVdnEKjpzOL4CvHBFG&quot;, nick: &quot;remedy&quot;, roles: [431849301, 913809431] )","ref":"Remedy.Api.html#add_guild_member/3","title":"Remedy.Api.add_guild_member/3","type":"function"},{"doc":"Same as add_guild_member/3 , but raises Remedy.Error.ApiError in case of failure.","ref":"Remedy.Api.html#add_guild_member!/3","title":"Remedy.Api.add_guild_member!/3","type":"function"},{"doc":"Adds a role to a member. Role to add is specified by role_id . User to add role to is specified by guild_id and user_id . An optional reason can be given for the audit log.","ref":"Remedy.Api.html#add_guild_member_role/4","title":"Remedy.Api.add_guild_member_role/4","type":"function"},{"doc":"Pins a message in a channel. This endpoint requires the 'VIEW_CHANNEL', 'READ_MESSAGE_HISTORY', and 'MANAGE_MESSAGES' permissions. It fires the Remedy.Consumer.message_update/0 and Remedy.Consumer.channel_pins_update/0 events. If successful, returns {:ok} . Otherwise, returns a Remedy.Api.error/0 . Examples Remedy.Api.add_pinned_channel_message(43189401384091, 18743893102394)","ref":"Remedy.Api.html#add_pinned_channel_message/2","title":"Remedy.Api.add_pinned_channel_message/2","type":"function"},{"doc":"Same as add_pinned_channel_message/2 , but raises Remedy.Error.ApiError in case of failure.","ref":"Remedy.Api.html#add_pinned_channel_message!/2","title":"Remedy.Api.add_pinned_channel_message!/2","type":"function"},{"doc":"Begins a guild prune to prune members within days . An optional reason can be provided for the guild audit log. This endpoint requires the KICK_MEMBERS permission. It fires multiple Remedy.Consumer.guild_member_remove/0 events. If successful, returns {:ok, %{pruned: pruned}} . Otherwise, returns a Remedy.Api.error/0 . Examples Remedy.Api.begin_guild_prune(81384788765712384, 1) {:ok, %{pruned: 0}}","ref":"Remedy.Api.html#begin_guild_prune/3","title":"Remedy.Api.begin_guild_prune/3","type":"function"},{"doc":"Same as begin_guild_prune/2 , but raises Remedy.Error.ApiError in case of failure.","ref":"Remedy.Api.html#begin_guild_prune!/3","title":"Remedy.Api.begin_guild_prune!/3","type":"function"},{"doc":"Deletes multiple messages from a channel. messages is a list of Remedy.Struct.Message.id that you wish to delete. When given more than 100 messages, this function will chunk the given message list into blocks of 100 and send them off to the API. It will stop deleting on the first error that occurs. Keep in mind that deleting thousands of messages will take a pretty long time and it may be proper to just delete the channel you want to bulk delete in and recreate it. This method can only delete messages sent within the last two weeks. Filter is an optional parameter that specifies whether messages sent over two weeks ago should be filtered out; defaults to true .","ref":"Remedy.Api.html#bulk_delete_messages/3","title":"Remedy.Api.bulk_delete_messages/3","type":"function"},{"doc":"Same as bulk_delete_messages/2 , but raises Remedy.Error.ApiError in case of failure.","ref":"Remedy.Api.html#bulk_delete_messages!/3","title":"Remedy.Api.bulk_delete_messages!/3","type":"function"},{"doc":"Overwrite the existing global application commands. This action will: Create any command that was provided and did not already exist Update any command that was provided and already existed if its configuration changed Delete any command that was not provided but existed on Discord's end Updates will be available in all guilds after 1 hour. Commands that do not already exist will count toward daily application command create limits. Parameters application_id : Application ID for which to overwrite the commands. If not given, this will be fetched from Me . commands : List of command configurations, see the linked API documentation for reference. Return value Updated list of global application commands. See the official reference: https://discord.com/developers/docs/interactions/slash-commands#bulk-overwrite-global-application-commands","ref":"Remedy.Api.html#bulk_overwrite_global_application_commands/2","title":"Remedy.Api.bulk_overwrite_global_application_commands/2","type":"function"},{"doc":"Overwrite the existing guild application commands on the specified guild. This action will: Create any command that was provided and did not already exist Update any command that was provided and already existed if its configuration changed Delete any command that was not provided but existed on Discord's end Parameters application_id : Application ID for which to overwrite the commands. If not given, this will be fetched from Me . guild_id : Guild on which to overwrite the commands. commands : List of command configurations, see the linked API documentation for reference. Return value Updated list of guild application commands. See the official reference: https://discord.com/developers/docs/interactions/slash-commands#bulk-overwrite-guild-application-commands","ref":"Remedy.Api.html#bulk_overwrite_guild_application_commands/3","title":"Remedy.Api.bulk_overwrite_guild_application_commands/3","type":"function"},{"doc":"Creates an invite for a guild channel. An optional reason can be provided for the audit log. This endpoint requires the CREATE_INSTANT_INVITE permission. If successful, returns {:ok, invite} . Otherwise, returns a Remedy.Api.error/0 . Options :max_age (integer) - duration of invite in seconds before expiry, or 0 for never. (default: 86400 ) :max_uses (integer) - max number of uses or 0 for unlimited. (default: 0 ) :temporary (boolean) - Whether the invite should grant temporary membership. (default: false ) :unique (boolean) - used when creating unique one time use invites. (default: false ) Examples Remedy.Api.create_channel_invite(41771983423143933) {:ok, Remedy.Struct.Invite{}} Remedy.Api.create_channel_invite(41771983423143933, max_uses: 20) {:ok, %Remedy.Struct.Invite{}}","ref":"Remedy.Api.html#create_channel_invite/3","title":"Remedy.Api.create_channel_invite/3","type":"function"},{"doc":"Same as create_channel_invite/2 , but raises Remedy.Error.ApiError in case of failure.","ref":"Remedy.Api.html#create_channel_invite!/3","title":"Remedy.Api.create_channel_invite!/3","type":"function"},{"doc":"Create a new DM channel with a user. If successful, returns {:ok, dm_channel} . Otherwise, returns a Remedy.Api.error/0 . Examples Remedy.Api.create_dm(150061853001777154) {:ok, %Remedy.Struct.Channel{type: 1}}","ref":"Remedy.Api.html#create_dm/1","title":"Remedy.Api.create_dm/1","type":"function"},{"doc":"Same as create_dm/1 , but raises Remedy.Error.ApiError in case of failure.","ref":"Remedy.Api.html#create_dm!/1","title":"Remedy.Api.create_dm!/1","type":"function"},{"doc":"Create a followup message for an interaction. Delegates to execute_webhook/3 , see the function for more details.","ref":"Remedy.Api.html#create_followup_message/3","title":"Remedy.Api.create_followup_message/3","type":"function"},{"doc":"Create a new global application command. The new command will be available on all guilds in around an hour. If you want to test commands, use create_guild_application_command/2 instead, as commands will become available instantly there. If an existing command with the same name exists, it will be overwritten. Parameters application_id : Application ID for which to create the command. If not given, this will be fetched from Me . command : Command configuration, see the linked API documentation for reference. Return value The created command. See the official reference: https://discord.com/developers/docs/interactions/slash-commands#create-global-application-command Example Remedy.Api . create_application_command ( %{ name : &quot;edit&quot; , description : &quot;ed, man! man, ed&quot; , options : [ ] } )","ref":"Remedy.Api.html#create_global_application_command/2","title":"Remedy.Api.create_global_application_command/2","type":"function"},{"doc":"Creates a new group DM channel. If successful, returns {:ok, group_dm_channel} . Otherwise, returns a Remedy.Api.error/0 . access_tokens are user oauth2 tokens. nicks is a map that maps a user id to a nickname. Examples Remedy.Api.create_group_dm([&quot;6qrZcUqja7812RVdnEKjpzOL4CvHBFG&quot;], %{41771983423143937 =&gt; &quot;My Nickname&quot;}) {:ok, %Remedy.Struct.Channel{type: 3}}","ref":"Remedy.Api.html#create_group_dm/2","title":"Remedy.Api.create_group_dm/2","type":"function"},{"doc":"Same as create_group_dm/2 , but raises Remedy.Error.ApiError in case of failure.","ref":"Remedy.Api.html#create_group_dm!/2","title":"Remedy.Api.create_group_dm!/2","type":"function"},{"doc":"","ref":"Remedy.Api.html#create_guild_application_command/3","title":"Remedy.Api.create_guild_application_command/3","type":"function"},{"doc":"Bans a user from a guild. User to delete is specified by guild_id and user_id . An optional reason can be specified for the audit log.","ref":"Remedy.Api.html#create_guild_ban/4","title":"Remedy.Api.create_guild_ban/4","type":"function"},{"doc":"Creates a channel for a guild. This endpoint requires the MANAGE_CHANNELS permission. It fires a Remedy.Consumer.channel_create/0 event. If successful, returns {:ok, channel} . Otherwise, returns a Remedy.Api.error/0 . Options :name (string) - channel name (2-100 characters) :type (integer) - the type of channel (See Remedy.Struct.Channel ) :topic (string) - channel topic (0-1024 characters) :bitrate (integer) - the bitrate (in bits) of the voice channel (voice only) :user_limit (integer) - the user limit of the voice channel (voice only) :permission_overwrites (list of Remedy.Struct.Overwrite.t/0 or equivalent map) - the channel's permission overwrites :parent_id ( Remedy.Struct.Channel.id/0 ) - id of the parent category for a channel :nsfw (boolean) - if the channel is nsfw :name is always required. Examples Remedy.Api.create_guild_channel(81384788765712384, name: &quot;elixir-remedy&quot;, topic: &quot;craig's domain&quot;) {:ok, %Remedy.Struct.Channel{guild_id: 81384788765712384}}","ref":"Remedy.Api.html#create_guild_channel/2","title":"Remedy.Api.create_guild_channel/2","type":"function"},{"doc":"Same as create_guild_channel/2 , but raises Remedy.Error.ApiError in case of failure.","ref":"Remedy.Api.html#create_guild_channel!/2","title":"Remedy.Api.create_guild_channel!/2","type":"function"},{"doc":"Creates a new emoji for the given guild. This endpoint requires the MANAGE_EMOJIS permission. It fires a Remedy.Consumer.guild_emojis_update/0 event. An optional reason can be provided for the audit log. If successful, returns {:ok, emoji} . Otherwise, returns Remedy.Api.error/0 . Options :name (string) - name of the emoji :image (base64 data URI) - the 128x128 emoji image. Maximum size of 256kb :roles (list of t:Sunbake.Snowflake.t/0 ) - roles for which this emoji will be whitelisted (default: []) :name and :image are always required. Examples image = &quot;data:image/png;base64,YXl5IGJieSB1IGx1a2luIDQgc3VtIGZ1az8=&quot; Remedy.Api.create_guild_emoji(43189401384091, name: &quot;remedy&quot;, image: image, roles: [])","ref":"Remedy.Api.html#create_guild_emoji/3","title":"Remedy.Api.create_guild_emoji/3","type":"function"},{"doc":"Same as create_guild_emoji/2 , but raises Remedy.Error.ApiError in case of failure.","ref":"Remedy.Api.html#create_guild_emoji!/3","title":"Remedy.Api.create_guild_emoji!/3","type":"function"},{"doc":"Creates a new guild integeration. Guild to create integration with is specified by guild_id . options is a map with the following requires keys: type - Integration type. id - Integeration id.","ref":"Remedy.Api.html#create_guild_integrations/2","title":"Remedy.Api.create_guild_integrations/2","type":"function"},{"doc":"Creates a guild role. An optional reason for the audit log can be provided via reason . This endpoint requires the MANAGE_ROLES permission. It fires a Remedy.Consumer.guild_role_create/0 event. If successful, returns {:ok, role} . Otherwise, returns a Remedy.Api.error/0 . Options :name (string) - name of the role (default: &quot;new role&quot;) :permissions (integer) - bitwise of the enabled/disabled permissions (default: @everyone perms) :color (integer) - RGB color value (default: 0) :hoist (boolean) - whether the role should be displayed separately in the sidebar (default: false) :mentionable (boolean) - whether the role should be mentionable (default: false) Examples Remedy.Api.create_guild_role(41771983423143937, name: &quot;remedy-club&quot;, hoist: true)","ref":"Remedy.Api.html#create_guild_role/3","title":"Remedy.Api.create_guild_role/3","type":"function"},{"doc":"Same as create_guild_role/2 , but raises Remedy.Error.ApiError in case of failure.","ref":"Remedy.Api.html#create_guild_role!/3","title":"Remedy.Api.create_guild_role!/3","type":"function"},{"doc":"Same as create_interaction_response/3 , but directly takes the Remedy.Struct.Interaction.t/0 received from the gateway.","ref":"Remedy.Api.html#create_interaction_response/2","title":"Remedy.Api.create_interaction_response/2","type":"function"},{"doc":"Create a response to an interaction received from the gateway. Parameters id : The interaction ID to which the response should be created. token : The interaction token. response : An InteractionResponse object. See the linked documentation. Example response = %{ type : 4 , data : %{ content : &quot;I copy and pasted this code.&quot; } } Remedy.Api . create_interaction_response ( interaction , response ) As an alternative to passing the interaction ID and token, the original Remedy.Struct.Interaction.t/0 can also be passed directly. See create_interaction_response/1 .","ref":"Remedy.Api.html#create_interaction_response/3","title":"Remedy.Api.create_interaction_response/3","type":"function"},{"doc":"Posts a message to a guild text or DM channel. This endpoint requires the VIEW_CHANNEL and SEND_MESSAGES permissions. It may situationally need the SEND_MESSAGES_TTS permission. It fires the Remedy.Consumer.message_create/0 event. If options is a string, options will be used as the message's content. If successful, returns {:ok, message} . Otherwise, returns a Remedy.Api.error/0 . Options :content (string) - the message contents (up to 2000 characters) :nonce ( t:Sunbake.Snowflake.t/0 ) - a nonce that can be used for optimistic message sending :tts (boolean) - true if this is a TTS message :file ( Path.t/0 | map) - the path of the file being sent, or a map with the following keys if sending a binary from memory :name (string) - the name of the file :body (string) - binary you wish to send :embed ( Remedy.Struct.Embed.t/0 ) - embedded rich content :allowed_mentions - See &quot;Allowed mentions&quot; below :message_reference ( map ) - See &quot;Message references&quot; below At least one of the following is required: :content , :file , :embed . Allowed mentions With this option you can control when content from a message should trigger a ping. Consider using this option when you are going to display user_generated content. Allowed values :all (default) - Ping everything as usual :none - Nobody will be pinged :everyone - Allows to ping @here and @everone :users - Allows to ping users :roles - Allows to ping roles {:users, list} - Allows to ping list of users. Can contain up to 100 ids of users. {:roles, list} - Allows to ping list of roles. Can contain up to 100 ids of roles. list - a list containing the values above. Message reference You can create a reply to another message on guilds using this option, given that you have the VIEW_MESSAGE_HISTORY permission. To do so, include the message_reference field in your call. The complete structure documentation can be found on the Discord Developer Portal , but simply passing message_id will suffice: def my_command ( msg ) do # Reply to the author - ``msg`` is a ``Remedy.Struct.Message`` Remedy.Api . create_message ( msg . channel_id , content : &quot;Hello&quot; , message_reference : %{ message_id : msg . id } ) end Passing a list will merge the settings provided Examples Remedy.Api.create_message(43189401384091, content: &quot;hello world!&quot;) Remedy.Api.create_message(43189401384091, &quot;hello world!&quot;) import Remedy.Struct.Embed embed = %Remedy.Struct.Embed{} |&gt; put_title(&quot;embed&quot;) |&gt; put_description(&quot;new desc&quot;) Remedy.Api.create_message(43189401384091, embed: embed) Remedy.Api.create_message(43189401384091, file: &quot;/path/to/file.txt&quot;) Remedy.Api.create_message(43189401384091, content: &quot;hello world!&quot;, embed: embed, file: &quot;/path/to/file.txt&quot;) Remedy.Api.create_message(43189401384091, content: &quot;Hello @everyone&quot;, allowed_mentions: :none)","ref":"Remedy.Api.html#create_message/2","title":"Remedy.Api.create_message/2","type":"function"},{"doc":"Same as create_message/2 , but raises Remedy.Error.ApiError in case of failure.","ref":"Remedy.Api.html#create_message!/2","title":"Remedy.Api.create_message!/2","type":"function"},{"doc":"Creates a reaction for a message. This endpoint requires the VIEW_CHANNEL and READ_MESSAGE_HISTORY permissions. Additionally, if nobody else has reacted to the message with the emoji , this endpoint requires the ADD_REACTIONS permission. It fires a Remedy.Consumer.message_reaction_add/0 event. If successful, returns {:ok} . Otherwise, returns Remedy.Api.error/0 . Examples # Using a Remedy.Struct.Emoji. emoji = %Remedy.Struct.Emoji{id: 43819043108, name: &quot;foxbot&quot;} Remedy.Api.create_reaction(123123123123, 321321321321, emoji) # Using a base 16 emoji string. Remedy.Api.create_reaction(123123123123, 321321321321, &quot;\\xF0\\x9F\\x98\\x81&quot;) For other emoji string examples, see Remedy.Struct.Emoji.api_name/0 .","ref":"Remedy.Api.html#create_reaction/3","title":"Remedy.Api.create_reaction/3","type":"function"},{"doc":"Same as create_reaction/3 , but raises Remedy.Error.ApiError in case of failure.","ref":"Remedy.Api.html#create_reaction!/3","title":"Remedy.Api.create_reaction!/3","type":"function"},{"doc":"Creates a webhook. Parameters channel_id - Id of the channel to send the message to. args - Map with the following required keys: name - Name of the webhook. avatar - Base64 128x128 jpeg image for the default avatar. reason - An optional reason for the guild audit log.","ref":"Remedy.Api.html#create_webhook/3","title":"Remedy.Api.create_webhook/3","type":"function"},{"doc":"Deletes all reactions from a message. This endpoint requires the VIEW_CHANNEL , READ_MESSAGE_HISTORY , and MANAGE_MESSAGES permissions. It fires a Remedy.Consumer.message_reaction_remove_all/0 event. If successful, returns {:ok} . Otherwise, return Remedy.Api.error/0 .","ref":"Remedy.Api.html#delete_all_reactions/2","title":"Remedy.Api.delete_all_reactions/2","type":"function"},{"doc":"Same as delete_all_reactions/2 , but raises Remedy.Error.ApiError in case of failure.","ref":"Remedy.Api.html#delete_all_reactions!/2","title":"Remedy.Api.delete_all_reactions!/2","type":"function"},{"doc":"Deletes a channel. An optional reason can be provided for the guild audit log. If deleting a Remedy.Struct.Channel.guild_channel/0 , this endpoint requires the MANAGE_CHANNELS permission. It fires a Remedy.Consumer.channel_delete/0 . If a Remedy.Struct.Channel.channel_category/0 is deleted, then a Remedy.Consumer.channel_update/0 event will fire for each channel under the category. If successful, returns {:ok, channel} . Otherwise, returns a Remedy.Api.error/0 . Examples Remedy.Api.delete_channel(421533712753360896) {:ok, %Remedy.Struct.Channel{id: 421533712753360896}}","ref":"Remedy.Api.html#delete_channel/2","title":"Remedy.Api.delete_channel/2","type":"function"},{"doc":"Same as delete_channel/1 , but raises Remedy.Error.ApiError in case of failure.","ref":"Remedy.Api.html#delete_channel!/2","title":"Remedy.Api.delete_channel!/2","type":"function"},{"doc":"Delete a channel permission for a user or role. Role or user overwrite to delete is specified by channel_id and overwrite_id . An optional reason can be given for the audit log.","ref":"Remedy.Api.html#delete_channel_permissions/3","title":"Remedy.Api.delete_channel_permissions/3","type":"function"},{"doc":"Delete an existing global application command. Parameters application_id : Application ID for which to create the command. If not given, this will be fetched from Me . command_id : The current snowflake of the command.","ref":"Remedy.Api.html#delete_global_application_command/2","title":"Remedy.Api.delete_global_application_command/2","type":"function"},{"doc":"Deletes a guild. This endpoint requires that the current user is the owner of the guild. It fires the Remedy.Consumer.guild_delete/0 event. If successful, returns {:ok} . Otherwise, returns a Remedy.Api.error/0 . Examples Remedy.Api.delete_guild(81384788765712384) {:ok}","ref":"Remedy.Api.html#delete_guild/1","title":"Remedy.Api.delete_guild/1","type":"function"},{"doc":"Same as delete_guild/1 , but raises Remedy.Error.ApiError in case of failure.","ref":"Remedy.Api.html#delete_guild!/1","title":"Remedy.Api.delete_guild!/1","type":"function"},{"doc":"","ref":"Remedy.Api.html#delete_guild_application_command/3","title":"Remedy.Api.delete_guild_application_command/3","type":"function"},{"doc":"Deletes the given emoji. An optional reason can be provided for the audit log. This endpoint requires the MANAGE_EMOJIS permission. It fires a Remedy.Consumer.guild_emojis_update/0 event. If successful, returns {:ok} . Otherwise, returns Remedy.Api.error/0 .","ref":"Remedy.Api.html#delete_guild_emoji/3","title":"Remedy.Api.delete_guild_emoji/3","type":"function"},{"doc":"Same as delete_guild_emoji/2 , but raises Remedy.Error.ApiError in case of failure.","ref":"Remedy.Api.html#delete_guild_emoji!/3","title":"Remedy.Api.delete_guild_emoji!/3","type":"function"},{"doc":"Deletes a guild integeration. Integration to delete is specified by guild_id and integeration_id .","ref":"Remedy.Api.html#delete_guild_integrations/2","title":"Remedy.Api.delete_guild_integrations/2","type":"function"},{"doc":"Deletes a role from a guild. An optional reason can be specified for the audit log. This endpoint requires the MANAGE_ROLES permission. It fires a Remedy.Consumer.guild_role_delete/0 event. If successful, returns {:ok} . Otherwise, returns a Remedy.Api.error/0 . Examples Remedy.Api.delete_guild_role(41771983423143937, 392817238471936)","ref":"Remedy.Api.html#delete_guild_role/3","title":"Remedy.Api.delete_guild_role/3","type":"function"},{"doc":"Same as delete_guild_role/2 , but raises Remedy.Error.ApiError in case of failure.","ref":"Remedy.Api.html#delete_guild_role!/3","title":"Remedy.Api.delete_guild_role!/3","type":"function"},{"doc":"Delete a followup message for an interaction. Parameters application_id : Application ID for which to create the command. If not given, this will be fetched from Me . token : Interaction token. message_id : Followup message ID.","ref":"Remedy.Api.html#delete_interaction_followup_message/3","title":"Remedy.Api.delete_interaction_followup_message/3","type":"function"},{"doc":"Deletes an invite by its invite_code . This endpoint requires the MANAGE_CHANNELS permission. If successful, returns {:ok, invite} . Otherwise, returns a Remedy.Api.error/0 . Examples Remedy.Api.delete_invite(&quot;zsjUsC&quot;)","ref":"Remedy.Api.html#delete_invite/1","title":"Remedy.Api.delete_invite/1","type":"function"},{"doc":"Same as delete_invite/1 , but raises Remedy.Error.ApiError in case of failure.","ref":"Remedy.Api.html#delete_invite!/1","title":"Remedy.Api.delete_invite!/1","type":"function"},{"doc":"Same as delete_message/2 , but takes a Remedy.Struct.Message instead of a channel_id and message_id .","ref":"Remedy.Api.html#delete_message/1","title":"Remedy.Api.delete_message/1","type":"function"},{"doc":"Deletes a message. This endpoint requires the 'VIEW_CHANNEL' and 'MANAGE_MESSAGES' permission. It fires the MESSAGE_DELETE event. If successful, returns {:ok} . Otherwise, returns a Remedy.Api.error/0 . Examples Remedy.Api.delete_message(43189401384091, 43189401384091)","ref":"Remedy.Api.html#delete_message/2","title":"Remedy.Api.delete_message/2","type":"function"},{"doc":"Same as delete_message/1 , but raises Remedy.Error.ApiError in case of failure.","ref":"Remedy.Api.html#delete_message!/1","title":"Remedy.Api.delete_message!/1","type":"function"},{"doc":"Same as delete_message/2 , but raises Remedy.Error.ApiError in case of failure.","ref":"Remedy.Api.html#delete_message!/2","title":"Remedy.Api.delete_message!/2","type":"function"},{"doc":"Deletes a reaction the current user has made for the message. This endpoint requires the VIEW_CHANNEL and READ_MESSAGE_HISTORY permissions. It fires a Remedy.Consumer.message_reaction_remove/0 event. If successful, returns {:ok} . Otherwise, returns Remedy.Api.error/0 . See create_reaction/3 for similar examples.","ref":"Remedy.Api.html#delete_own_reaction/3","title":"Remedy.Api.delete_own_reaction/3","type":"function"},{"doc":"Same as delete_own_reaction/3 , but raises Remedy.Error.ApiError in case of failure.","ref":"Remedy.Api.html#delete_own_reaction!/3","title":"Remedy.Api.delete_own_reaction!/3","type":"function"},{"doc":"Unpins a message in a channel. This endpoint requires the 'VIEW_CHANNEL', 'READ_MESSAGE_HISTORY', and 'MANAGE_MESSAGES' permissions. It fires the Remedy.Consumer.message_update/0 and Remedy.Consumer.channel_pins_update/0 events. Returns {:ok} if successful. error otherwise.","ref":"Remedy.Api.html#delete_pinned_channel_message/2","title":"Remedy.Api.delete_pinned_channel_message/2","type":"function"},{"doc":"Same as delete_pinned_channel_message/2 , but raises Remedy.Error.ApiError in case of failure.","ref":"Remedy.Api.html#delete_pinned_channel_message!/2","title":"Remedy.Api.delete_pinned_channel_message!/2","type":"function"},{"doc":"Deletes all reactions of a given emoji from a message. This endpoint requires the MANAGE_MESSAGES permissions. It fires a Remedy.Consumer.message_reaction_remove_emoji/0 event. If successful, returns {:ok} . Otherwise, returns Remedy.Api.error/0 . See create_reaction/3 for similar examples.","ref":"Remedy.Api.html#delete_reaction/3","title":"Remedy.Api.delete_reaction/3","type":"function"},{"doc":"Same as delete_reaction/3 , but raises Remedy.Error.ApiError in case of failure.","ref":"Remedy.Api.html#delete_reaction!/3","title":"Remedy.Api.delete_reaction!/3","type":"function"},{"doc":"Deletes another user's reaction from a message. This endpoint requires the VIEW_CHANNEL , READ_MESSAGE_HISTORY , and MANAGE_MESSAGES permissions. It fires a Remedy.Consumer.message_reaction_remove/0 event. If successful, returns {:ok} . Otherwise, returns Remedy.Api.error/0 . See create_reaction/3 for similar examples.","ref":"Remedy.Api.html#delete_user_reaction/4","title":"Remedy.Api.delete_user_reaction/4","type":"function"},{"doc":"Same as delete_user_reaction/4 , but raises Remedy.Error.ApiError in case of failure.","ref":"Remedy.Api.html#delete_user_reaction!/4","title":"Remedy.Api.delete_user_reaction!/4","type":"function"},{"doc":"Deletes a webhook. Parameters webhook_id - Id of webhook to delete. reason - An optional reason for the guild audit log.","ref":"Remedy.Api.html#delete_webhook/2","title":"Remedy.Api.delete_webhook/2","type":"function"},{"doc":"Edit the permission overwrites for a user or role. Role or user to overwrite is specified by overwrite_id . permission_info is a map with the following keys: type - Required; member if editing a user, role if editing a role. allow - Bitwise value of allowed permissions. deny - Bitwise value of denied permissions. type - member if editing a user, role if editing a role. An optional reason can be provided for the audit log. allow and deny are defaulted to 0 , meaning that even if you don't specify them, they will override their respective former values in an existing overwrite.","ref":"Remedy.Api.html#edit_channel_permissions/4","title":"Remedy.Api.edit_channel_permissions/4","type":"function"},{"doc":"Same as edit_channel_permissions/3 , but raises Remedy.Error.ApiError in case of failure.","ref":"Remedy.Api.html#edit_channel_permissions!/4","title":"Remedy.Api.edit_channel_permissions!/4","type":"function"},{"doc":"Update an existing global application command. The updated command will be available on all guilds in around an hour. Parameters application_id : Application ID for which to edit the command. If not given, this will be fetched from Me . command_id : The current snowflake of the command. command : Command configuration, see the linked API documentation for reference. Return value The updated command. See the official reference: https://discord.com/developers/docs/interactions/slash-commands#edit-global-application-command","ref":"Remedy.Api.html#edit_global_application_command/3","title":"Remedy.Api.edit_global_application_command/3","type":"function"},{"doc":"","ref":"Remedy.Api.html#edit_guild_application_command/4","title":"Remedy.Api.edit_guild_application_command/4","type":"function"},{"doc":"Same as edit_message/3 , but takes a Remedy.Struct.Message instead of a channel_id and message_id .","ref":"Remedy.Api.html#edit_message/2","title":"Remedy.Api.edit_message/2","type":"function"},{"doc":"Edits a previously sent message in a channel. This endpoint requires the VIEW_CHANNEL permission. It fires the Remedy.Consumer.message_update/0 event. If options is a string, options will be used as the message's content. If successful, returns {:ok, message} . Otherwise, returns a Remedy.Api.error/0 . Options :content (string) - the message contents (up to 2000 characters) :embed ( Remedy.Struct.Embed.t/0 ) - embedded rich content Examples Remedy.Api.edit_message(43189401384091, 1894013840914098, content: &quot;hello world!&quot;) Remedy.Api.edit_message(43189401384091, 1894013840914098, &quot;hello world!&quot;) import Remedy.Struct.Embed embed = %Remedy.Struct.Embed{} |&gt; put_title(&quot;embed&quot;) |&gt; put_description(&quot;new desc&quot;) Remedy.Api.edit_message(43189401384091, 1894013840914098, embed: embed) Remedy.Api.edit_message(43189401384091, 1894013840914098, content: &quot;hello world!&quot;, embed: embed)","ref":"Remedy.Api.html#edit_message/3","title":"Remedy.Api.edit_message/3","type":"function"},{"doc":"Same as edit_message/2 , but raises Remedy.Error.ApiError in case of failure.","ref":"Remedy.Api.html#edit_message!/2","title":"Remedy.Api.edit_message!/2","type":"function"},{"doc":"Same as edit_message/3 , but raises Remedy.Error.ApiError in case of failure.","ref":"Remedy.Api.html#edit_message!/3","title":"Remedy.Api.edit_message!/3","type":"function"},{"doc":"Executes a git webhook. Parameters webhook_id - Id of the webhook to execute. webhook_token - Token of the webhook to execute.","ref":"Remedy.Api.html#execute_git_webhook/3","title":"Remedy.Api.execute_git_webhook/3","type":"function"},{"doc":"Executes a slack webhook. Parameters webhook_id - Id of the webhook to execute. webhook_token - Token of the webhook to execute.","ref":"Remedy.Api.html#execute_slack_webhook/3","title":"Remedy.Api.execute_slack_webhook/3","type":"function"},{"doc":"Executes a webhook. ## Parameters webhook_id - Id of the webhook to execute. webhook_token - Token of the webhook to execute. args - Map with the following required keys: content - Message content. file - File to send. embeds - List of embeds to send. username - Overrides the default name of the webhook. avatar_url - Overrides the default avatar of the webhook. tts - Whether the message should be read over text to speech. wait - Whether to return an error or not. Defaults to false . Only one of content , file or embeds should be supplied in the args parameter.","ref":"Remedy.Api.html#execute_webhook/4","title":"Remedy.Api.execute_webhook/4","type":"function"},{"doc":"Gets the bot's OAuth2 application info. Example Remedy.Api . get_application_information { :ok , %{ bot_public : false , bot_require_code_grant : false , description : &quot;Test&quot; , icon : nil , id : &quot;172150183260323840&quot; , name : &quot;Baba O-Riley&quot; , owner : %{ avatar : nil , discriminator : &quot;0042&quot; , id : &quot;172150183260323840&quot; , username : &quot;i own a bot&quot; } , } }","ref":"Remedy.Api.html#get_application_information/0","title":"Remedy.Api.get_application_information/0","type":"function"},{"doc":"Gets a channel. If successful, returns {:ok, channel} . Otherwise, returns a Remedy.Api.error/0 . Examples Remedy.Api.get_channel(381889573426429952) {:ok, %Remedy.Struct.Channel{id: 381889573426429952}}","ref":"Remedy.Api.html#get_channel/1","title":"Remedy.Api.get_channel/1","type":"function"},{"doc":"Same as get_channel/1 , but raises Remedy.Error.ApiError in case of failure.","ref":"Remedy.Api.html#get_channel!/1","title":"Remedy.Api.get_channel!/1","type":"function"},{"doc":"Gets a list of invites for a channel. This endpoint requires the 'VIEW_CHANNEL' and 'MANAGE_CHANNELS' permissions. If successful, returns {:ok, invite} . Otherwise, returns a Remedy.Api.error/0 . Examples Remedy.Api.get_channel_invites(43189401384091) {:ok, [%Remedy.Struct.Invite{} | _]}","ref":"Remedy.Api.html#get_channel_invites/1","title":"Remedy.Api.get_channel_invites/1","type":"function"},{"doc":"Same as get_channel_invites/1 , but raises Remedy.Error.ApiError in case of failure.","ref":"Remedy.Api.html#get_channel_invites!/1","title":"Remedy.Api.get_channel_invites!/1","type":"function"},{"doc":"Retrieves a message from a channel. This endpoint requires the 'VIEW_CHANNEL' and 'READ_MESSAGE_HISTORY' permissions. If successful, returns {:ok, message} . Otherwise, returns a Remedy.Api.error/0 . Examples Remedy.Api.get_channel_message(43189401384091, 198238475613443)","ref":"Remedy.Api.html#get_channel_message/2","title":"Remedy.Api.get_channel_message/2","type":"function"},{"doc":"Same as get_channel_message/2 , but raises Remedy.Error.ApiError in case of failure.","ref":"Remedy.Api.html#get_channel_message!/2","title":"Remedy.Api.get_channel_message!/2","type":"function"},{"doc":"Retrieves a channel's messages around a locator up to a limit . This endpoint requires the 'VIEW_CHANNEL' permission. If the current user is missing the 'READ_MESSAGE_HISTORY' permission, then this function will return no messages. If successful, returns {:ok, messages} . Otherwise, returns a Remedy.Api.error/0 . Examples Remedy.Api.get_channel_messages(43189401384091, 5, {:before, 130230401384})","ref":"Remedy.Api.html#get_channel_messages/3","title":"Remedy.Api.get_channel_messages/3","type":"function"},{"doc":"Same as get_channel_messages/3 , but raises Remedy.Error.ApiError in case of failure.","ref":"Remedy.Api.html#get_channel_messages!/3","title":"Remedy.Api.get_channel_messages!/3","type":"function"},{"doc":"Gets a list of webook for a channel. Parameters channel_id - Channel to get webhooks for.","ref":"Remedy.Api.html#get_channel_webhooks/1","title":"Remedy.Api.get_channel_webhooks/1","type":"function"},{"doc":"Gets info on the current user. If remedy's caching is enabled, it is recommended to use Bot.get/0 instead of this function. This is because sending out an API request is much slower than pulling from our cache. If the request is successful, this function returns {:ok, user} , where user is remedy's Remedy.Struct.User . Otherwise, returns {:error, reason} .","ref":"Remedy.Api.html#get_current_user/0","title":"Remedy.Api.get_current_user/0","type":"function"},{"doc":"Same as get_current_user/0 , but raises Remedy.Error.ApiError in case of failure.","ref":"Remedy.Api.html#get_current_user!/0","title":"Remedy.Api.get_current_user!/0","type":"function"},{"doc":"Gets a list of guilds the user is currently in. This endpoint requires the guilds OAuth2 scope. If successful, returns {:ok, guilds} . Otherwise, returns a Remedy.Api.error/0 . Options :before ( t:Sunbake.Snowflake.t/0 ) - get guilds before this guild ID :after ( t:Sunbake.Snowflake.t/0 ) - get guilds after this guild ID :limit (integer) - max number of guilds to return (1-100) Examples iex&gt; Remedy.Api.get_current_user_guilds(limit: 1) {:ok, [%Remedy.Struct.Guild{}]}","ref":"Remedy.Api.html#get_current_user_guilds/1","title":"Remedy.Api.get_current_user_guilds/1","type":"function"},{"doc":"Same as get_current_user_guilds/1 , but raises Remedy.Error.ApiError in case of failure.","ref":"Remedy.Api.html#get_current_user_guilds!/1","title":"Remedy.Api.get_current_user_guilds!/1","type":"function"},{"doc":"Fetch all global commands. Parameters application_id : Application ID for which to search commands. If not given, this will be fetched from Me . Return value A list of ApplicationCommand s on success. See the official reference: https://discord.com/developers/docs/interactions/slash-commands#applicationcommand Example iex&gt; Remedy.Api . get_global_application_commands { :ok , [ %{ application_id : &quot;455589479713865749&quot; , description : &quot;ed, man! man, ed&quot; , id : &quot;789841753196331029&quot; , name : &quot;edit&quot; } ] }","ref":"Remedy.Api.html#get_global_application_commands/1","title":"Remedy.Api.get_global_application_commands/1","type":"function"},{"doc":"Gets a guild. If successful, returns {:ok, guild} . Otherwise, returns a Remedy.Api.error/0 . Examples Remedy.Api.get_guild(81384788765712384) {:ok, %Remedy.Struct.Guild{id: 81384788765712384}}","ref":"Remedy.Api.html#get_guild/1","title":"Remedy.Api.get_guild/1","type":"function"},{"doc":"Same as get_guild/1 , but raises Remedy.Error.ApiError in case of failure.","ref":"Remedy.Api.html#get_guild!/1","title":"Remedy.Api.get_guild!/1","type":"function"},{"doc":"","ref":"Remedy.Api.html#get_guild_application_commands/2","title":"Remedy.Api.get_guild_application_commands/2","type":"function"},{"doc":"Get the Remedy.Struct.Guild.AuditLog.t/0 for the given guild_id . Options :user_id ( Remedy.Struct.User.id/0 ) - filter the log for a user ID :action_type ( integer/0 ) - filter the log by audit log type, see Audit Log Events :before ( t:Remedy.Struct.Snowflake.t/0 ) - filter the log before a certain entry ID :limit ( pos_integer/0 ) - how many entries are returned (default 50, minimum 1, maximum 100)","ref":"Remedy.Api.html#get_guild_audit_log/2","title":"Remedy.Api.get_guild_audit_log/2","type":"function"},{"doc":"Gets a ban object for the given user from a guild.","ref":"Remedy.Api.html#get_guild_ban/2","title":"Remedy.Api.get_guild_ban/2","type":"function"},{"doc":"Gets a list of users banned from a guild. Guild to get bans for is specified by guild_id .","ref":"Remedy.Api.html#get_guild_bans/1","title":"Remedy.Api.get_guild_bans/1","type":"function"},{"doc":"Gets a list of guild channels. If successful, returns {:ok, channels} . Otherwise, returns a Remedy.Api.error/0 . Examples Remedy.Api.get_guild_channels(81384788765712384) {:ok, [%Remedy.Struct.Channel{guild_id: 81384788765712384} | _]}","ref":"Remedy.Api.html#get_guild_channels/1","title":"Remedy.Api.get_guild_channels/1","type":"function"},{"doc":"Same as get_guild_channels/1 , but raises Remedy.Error.ApiError in case of failure.","ref":"Remedy.Api.html#get_guild_channels!/1","title":"Remedy.Api.get_guild_channels!/1","type":"function"},{"doc":"Gets a guild embed.","ref":"Remedy.Api.html#get_guild_embed/1","title":"Remedy.Api.get_guild_embed/1","type":"function"},{"doc":"Gets an emoji for the given guild and emoji ids. This endpoint requires the MANAGE_EMOJIS permission. If successful, returns {:ok, emoji} . Otherwise, returns Remedy.Api.error/0 .","ref":"Remedy.Api.html#get_guild_emoji/2","title":"Remedy.Api.get_guild_emoji/2","type":"function"},{"doc":"Same as get_guild_emoji/2 , but raises Remedy.Error.ApiError in case of failure.","ref":"Remedy.Api.html#get_guild_emoji!/2","title":"Remedy.Api.get_guild_emoji!/2","type":"function"},{"doc":"Gets a list of guild integerations. Guild to get integrations for is specified by guild_id .","ref":"Remedy.Api.html#get_guild_integrations/1","title":"Remedy.Api.get_guild_integrations/1","type":"function"},{"doc":"Gets a list of invites for a guild. This endpoint requires the MANAGE_GUILD permission. If successful, returns {:ok, invites} . Otherwise, returns a Remedy.Api.error/0 . Examples Remedy.Api.get_guild_invites(81384788765712384) {:ok, [%Remedy.Struct.Invite{} | _]}","ref":"Remedy.Api.html#get_guild_invites/1","title":"Remedy.Api.get_guild_invites/1","type":"function"},{"doc":"Same as get_guild_invites/1 , but raises Remedy.Error.ApiError in case of failure.","ref":"Remedy.Api.html#get_guild_invites!/1","title":"Remedy.Api.get_guild_invites!/1","type":"function"},{"doc":"Gets a guild member. If successful, returns {:ok, member} . Otherwise, returns a Remedy.Api.error/0 . Examples Remedy.Api.get_guild_member(4019283754613, 184937267485)","ref":"Remedy.Api.html#get_guild_member/2","title":"Remedy.Api.get_guild_member/2","type":"function"},{"doc":"Same as get_guild_member/2 , but raises Remedy.Error.ApiError in case of failure.","ref":"Remedy.Api.html#get_guild_member!/2","title":"Remedy.Api.get_guild_member!/2","type":"function"},{"doc":"Gets the number of members that would be removed in a prune given days . This endpoint requires the KICK_MEMBERS permission. If successful, returns {:ok, %{pruned: pruned}} . Otherwise, returns a Remedy.Api.error/0 . Examples Remedy.Api.get_guild_prune_count(81384788765712384, 1) {:ok, %{pruned: 0}}","ref":"Remedy.Api.html#get_guild_prune_count/2","title":"Remedy.Api.get_guild_prune_count/2","type":"function"},{"doc":"Same as get_guild_prune_count/2 , but raises Remedy.Error.ApiError in case of failure.","ref":"Remedy.Api.html#get_guild_prune_count!/2","title":"Remedy.Api.get_guild_prune_count!/2","type":"function"},{"doc":"Gets a guild's roles. If successful, returns {:ok, roles} . Otherwise, returns a Remedy.Api.error/0 . Examples Remedy.Api.get_guild_roles(147362948571673)","ref":"Remedy.Api.html#get_guild_roles/1","title":"Remedy.Api.get_guild_roles/1","type":"function"},{"doc":"Same as get_guild_roles/1 , but raises Remedy.Error.ApiError in case of failure.","ref":"Remedy.Api.html#get_guild_roles!/1","title":"Remedy.Api.get_guild_roles!/1","type":"function"},{"doc":"Gets a list of webooks for a guild. Parameters guild_id - Guild to get webhooks for.","ref":"Remedy.Api.html#get_guild_webhooks/1","title":"Remedy.Api.get_guild_webhooks/1","type":"function"},{"doc":"Gets an invite by its invite_code . If successful, returns {:ok, invite} . Otherwise, returns a Remedy.Api.error/0 . Options :with_counts (boolean) - whether to include member count fields Examples Remedy.Api.get_invite(&quot;zsjUsC&quot;) Remedy.Api.get_invite(&quot;zsjUsC&quot;, with_counts: true)","ref":"Remedy.Api.html#get_invite/2","title":"Remedy.Api.get_invite/2","type":"function"},{"doc":"Same as get_invite/1 , but raises Remedy.Error.ApiError in case of failure.","ref":"Remedy.Api.html#get_invite!/2","title":"Remedy.Api.get_invite!/2","type":"function"},{"doc":"Retrieves all pinned messages from a channel. This endpoint requires the 'VIEW_CHANNEL' and 'READ_MESSAGE_HISTORY' permissions. If successful, returns {:ok, messages} . Otherwise, returns a Remedy.Api.error/0 . Examples Remedy.Api.get_pinned_messages(43189401384091)","ref":"Remedy.Api.html#get_pinned_messages/1","title":"Remedy.Api.get_pinned_messages/1","type":"function"},{"doc":"Same as get_pinned_messages/1 , but raises Remedy.Error.ApiError in case of failure.","ref":"Remedy.Api.html#get_pinned_messages!/1","title":"Remedy.Api.get_pinned_messages!/1","type":"function"},{"doc":"Gets all users who reacted with an emoji. This endpoint requires the VIEW_CHANNEL and READ_MESSAGE_HISTORY permissions. If successful, returns {:ok, users} . Otherwise, returns Remedy.Api.error/0 . See create_reaction/3 for similar examples.","ref":"Remedy.Api.html#get_reactions/3","title":"Remedy.Api.get_reactions/3","type":"function"},{"doc":"Same as get_reactions/3 , but raises Remedy.Error.ApiError in case of failure.","ref":"Remedy.Api.html#get_reactions!/3","title":"Remedy.Api.get_reactions!/3","type":"function"},{"doc":"Returns the token of the bot.","ref":"Remedy.Api.html#get_token/0","title":"Remedy.Api.get_token/0","type":"function"},{"doc":"Gets a user by its Remedy.Struct.User.id/0 . If the request is successful, this function returns {:ok, user} , where user is a Remedy.Struct.User . Otherwise, returns {:error, reason} .","ref":"Remedy.Api.html#get_user/1","title":"Remedy.Api.get_user/1","type":"function"},{"doc":"Same as get_user/1 , but raises Remedy.Error.ApiError in case of failure.","ref":"Remedy.Api.html#get_user!/1","title":"Remedy.Api.get_user!/1","type":"function"},{"doc":"Gets a list of user connections.","ref":"Remedy.Api.html#get_user_connections/0","title":"Remedy.Api.get_user_connections/0","type":"function"},{"doc":"Gets a list of our user's DM channels. If successful, returns {:ok, dm_channels} . Otherwise, returns a Remedy.Api.error/0 . Examples Remedy.Api.get_user_dms() {:ok, [%Remedy.Struct.Channel{type: 1} | _]}","ref":"Remedy.Api.html#get_user_dms/0","title":"Remedy.Api.get_user_dms/0","type":"function"},{"doc":"Same as get_user_dms/0 , but raises Remedy.Error.ApiError in case of failure.","ref":"Remedy.Api.html#get_user_dms!/0","title":"Remedy.Api.get_user_dms!/0","type":"function"},{"doc":"Gets a list of voice regions for the guild. Guild to get voice regions for is specified by guild_id .","ref":"Remedy.Api.html#get_voice_region/1","title":"Remedy.Api.get_voice_region/1","type":"function"},{"doc":"Gets a webhook by id. Parameters webhook_id - Id of the webhook to get.","ref":"Remedy.Api.html#get_webhook/1","title":"Remedy.Api.get_webhook/1","type":"function"},{"doc":"Gets a webhook by id and token. This method is exactly like get_webhook/1 but does not require authentication. Parameters webhook_id - Id of the webhook to get. webhook_token - Token of the webhook to get.","ref":"Remedy.Api.html#get_webhook_with_token/2","title":"Remedy.Api.get_webhook_with_token/2","type":"function"},{"doc":"Leaves a guild. Guild to leave is specified by guild_id .","ref":"Remedy.Api.html#leave_guild/1","title":"Remedy.Api.leave_guild/1","type":"function"},{"doc":"Gets a list of emojis for a given guild. This endpoint requires the MANAGE_EMOJIS permission. If successful, returns {:ok, emojis} . Otherwise, returns Remedy.Api.error/0 .","ref":"Remedy.Api.html#list_guild_emojis/1","title":"Remedy.Api.list_guild_emojis/1","type":"function"},{"doc":"Same as list_guild_emojis/1 , but raises Remedy.Error.ApiError in case of failure.","ref":"Remedy.Api.html#list_guild_emojis!/1","title":"Remedy.Api.list_guild_emojis!/1","type":"function"},{"doc":"Gets a list of a guild's members. If successful, returns {:ok, members} . Otherwise, returns a Remedy.Api.error/0 . Options :limit (integer) - max number of members to return (1-1000) (default: 1) :after ( Remedy.Struct.User.id/0 ) - the highest user id in the previous page (default: 0) Examples Remedy.Api.list_guild_members(41771983423143937, limit: 1)","ref":"Remedy.Api.html#list_guild_members/2","title":"Remedy.Api.list_guild_members/2","type":"function"},{"doc":"Same as list_guild_members/2 , but raises Remedy.Error.ApiError in case of failure.","ref":"Remedy.Api.html#list_guild_members!/2","title":"Remedy.Api.list_guild_members!/2","type":"function"},{"doc":"Gets a list of voice regions.","ref":"Remedy.Api.html#list_voice_regions/0","title":"Remedy.Api.list_voice_regions/0","type":"function"},{"doc":"Modifies a channel's settings. An optional reason can be given for the guild audit log. If a Remedy.Struct.Channel.guild_channel/0 is being modified, this endpoint requires the MANAGE_CHANNEL permission. It fires a Remedy.Consumer.channel_update/0 event. If a Remedy.Struct.Channel.channel_category/0 is being modified, then this endpoint fires multiple Remedy.Consumer.channel_update/0 events. If successful, returns {:ok, channel} . Otherwise, returns a Remedy.Api.error/0 . Options :name (string) - 2-100 character channel name :position (integer) - the position of the channel in the left-hand listing :topic (string) ( Remedy.Struct.Channel.text_channel/0 only) - 0-1024 character channel topic :nsfw (boolean) ( Remedy.Struct.Channel.text_channel/0 only) - if the channel is nsfw :bitrate (integer) ( Remedy.Struct.Channel.voice_channel/0 only) - the bitrate (in bits) of the voice channel; 8000 to 96000 (128000 for VIP servers) :user_limit (integer) ( Remedy.Struct.Channel.voice_channel/0 only) - the user limit of the voice channel; 0 refers to no limit, 1 to 99 refers to a user limit :permission_overwrites (list of Remedy.Struct.Overwrite.t/0 or equivalent map) - channel or category-specific permissions :parent_id ( Remedy.Struct.Channel.id/0 ) ( Remedy.Struct.Channel.guild_channel/0 only) - id of the new parent category for a channel Examples Remedy.Api.modify_channel(41771983423143933, name: &quot;elixir-remedy&quot;, topic: &quot;remedy discussion&quot;) {:ok, %Remedy.Struct.Channel{id: 41771983423143933, name: &quot;elixir-remedy&quot;, topic: &quot;remedy discussion&quot;}} Remedy.Api.modify_channel(41771983423143933) {:ok, %Remedy.Struct.Channel{id: 41771983423143933}}","ref":"Remedy.Api.html#modify_channel/3","title":"Remedy.Api.modify_channel/3","type":"function"},{"doc":"Same as modify_channel/2 , but raises Remedy.Error.ApiError in case of failure.","ref":"Remedy.Api.html#modify_channel!/3","title":"Remedy.Api.modify_channel!/3","type":"function"},{"doc":"Changes the username or avatar of the current user. Options :username (string) - new username :avatar (string) - the user's avatar as avatar data Examples Remedy.Api.modify_current_user(avatar: &quot;data:image/jpeg;base64,YXl5IGJieSB1IGx1a2luIDQgc3VtIGZ1az8=&quot;)","ref":"Remedy.Api.html#modify_current_user/1","title":"Remedy.Api.modify_current_user/1","type":"function"},{"doc":"Same as modify_current_user/1 , but raises Remedy.Error.ApiError in case of failure.","ref":"Remedy.Api.html#modify_current_user!/1","title":"Remedy.Api.modify_current_user!/1","type":"function"},{"doc":"Modifies the nickname of the current user in a guild. If successful, returns {:ok, %{nick: nick}} . Otherwise, returns a Remedy.Api.error/0 . Options :nick (string) - value to set users nickname to Examples Remedy.Api.modify_current_user_nick(41771983423143937, nick: &quot;Remedy&quot;) {:ok, %{nick: &quot;Remedy&quot;}}","ref":"Remedy.Api.html#modify_current_user_nick/2","title":"Remedy.Api.modify_current_user_nick/2","type":"function"},{"doc":"Same as modify_current_user_nick/2 , but raises Remedy.Error.ApiError in case of failure.","ref":"Remedy.Api.html#modify_current_user_nick!/2","title":"Remedy.Api.modify_current_user_nick!/2","type":"function"},{"doc":"Modifies a guild's settings. This endpoint requires the MANAGE_GUILD permission. It fires the Remedy.Consumer.guild_update/0 event. An optional reason can be provided for the audit log. If successful, returns {:ok, guild} . Otherwise, returns a Remedy.Api.error/0 . Options :name (string) - guild name :region (string) - guild voice region id :verification_level (integer) - verification level :default_message_notifications (integer) - default message notification level :explicit_content_filter (integer) - explicit content filter level :afk_channel_id ( t:Sunbake.Snowflake.t/0 ) - id for afk channel :afk_timeout (integer) - afk timeout in seconds :icon (base64 data URI) - 128x128 jpeg image for the guild icon :owner_id ( t:Sunbake.Snowflake.t/0 ) - user id to transfer guild ownership to (must be owner) :splash (base64 data URI) - 128x128 jpeg image for the guild splash (VIP only) :system_channel_id ( t:Sunbake.Snowflake.t/0 ) - the id of the channel to which system messages are sent :rules_channel_id ( t:Sunbake.Snowflake.t/0 ) - the id of the channel that is used for rules in public guilds :public_updates_channel_id ( t:Sunbake.Snowflake.t/0 ) - the id of the channel where admins and moderators receive notices from Discord in public guilds Examples Remedy.Api . modify_guild ( 451824027976073216 , name : &quot;Nose Drum&quot; ) { :ok , % Remedy.Struct.Guild { id : 451824027976073216 , name : &quot;Nose Drum&quot; , ... } }","ref":"Remedy.Api.html#modify_guild/3","title":"Remedy.Api.modify_guild/3","type":"function"},{"doc":"Same as modify_guild/2 , but raises Remedy.Error.ApiError in case of failure.","ref":"Remedy.Api.html#modify_guild!/2","title":"Remedy.Api.modify_guild!/2","type":"function"},{"doc":"Reorders a guild's channels. This endpoint requires the MANAGE_CHANNELS permission. It fires multiple Remedy.Consumer.channel_update/0 events. If successful, returns {:ok, channels} . Otherwise, returns a Remedy.Api.error/0 . positions is a list of maps that each map a channel id with a position. Examples Remedy.Api.modify_guild_channel_positions(279093381723062272, [%{id: 351500354581692420, position: 2}]) {:ok}","ref":"Remedy.Api.html#modify_guild_channel_positions/2","title":"Remedy.Api.modify_guild_channel_positions/2","type":"function"},{"doc":"Same as modify_guild_channel_positions/2 , but raises Remedy.Error.ApiError in case of failure.","ref":"Remedy.Api.html#modify_guild_channel_positions!/2","title":"Remedy.Api.modify_guild_channel_positions!/2","type":"function"},{"doc":"Modifies a guild embed.","ref":"Remedy.Api.html#modify_guild_embed/2","title":"Remedy.Api.modify_guild_embed/2","type":"function"},{"doc":"Modify the given emoji. This endpoint requires the MANAGE_EMOJIS permission. It fires a Remedy.Consumer.guild_emojis_update/0 event. An optional reason can be provided for the audit log. If successful, returns {:ok, emoji} . Otherwise, returns Remedy.Api.error/0 . Options :name (string) - name of the emoji :roles (list of t:Sunbake.Snowflake.t/0 ) - roles to which this emoji will be whitelisted Examples Remedy.Api.modify_guild_emoji(43189401384091, 4314301984301, name: &quot;elixir&quot;, roles: [])","ref":"Remedy.Api.html#modify_guild_emoji/4","title":"Remedy.Api.modify_guild_emoji/4","type":"function"},{"doc":"Same as modify_guild_emoji/3 , but raises Remedy.Error.ApiError in case of failure.","ref":"Remedy.Api.html#modify_guild_emoji!/4","title":"Remedy.Api.modify_guild_emoji!/4","type":"function"},{"doc":"Changes the settings and behaviours for a guild integeration. Integration to modify is specified by guild_id and integeration_id . options is a map with the following keys: expire_behavior - Expiry behavior. expire_grace_period - Period where the integration will ignore elapsed subs. enable_emoticons - Whether emoticons should be synced.","ref":"Remedy.Api.html#modify_guild_integrations/3","title":"Remedy.Api.modify_guild_integrations/3","type":"function"},{"doc":"Modifies a guild member's attributes. This endpoint fires the Remedy.Consumer.guild_member_update/0 event. It situationally requires the MANAGE_NICKNAMES , MANAGE_ROLES , MUTE_MEMBERS , DEAFEN_MEMBERS , and MOVE_MEMBERS permissions. If successful, returns {:ok} . Otherwise, returns a Remedy.Api.error/0 . Options :nick (string) - value to set users nickname to :roles (list of t:Sunbake.Snowflake.t/0 ) - array of role ids the member is assigned :mute (boolean) - if the user is muted :deaf (boolean) - if the user is deafened :channel_id ( t:Sunbake.Snowflake.t/0 ) - id of channel to move user to (if they are connected to voice) Examples Remedy.Api.modify_guild_member(41771983423143937, 637162356451, nick: &quot;Remedy&quot;) {:ok}","ref":"Remedy.Api.html#modify_guild_member/3","title":"Remedy.Api.modify_guild_member/3","type":"function"},{"doc":"Same as modify_guild_member/3 , but raises Remedy.Error.ApiError in case of failure.","ref":"Remedy.Api.html#modify_guild_member!/3","title":"Remedy.Api.modify_guild_member!/3","type":"function"},{"doc":"Modifies a guild role. This endpoint requires the MANAGE_ROLES permission. It fires a Remedy.Consumer.guild_role_update/0 event. An optional reason can be specified for the audit log. If successful, returns {:ok, role} . Otherwise, returns a Remedy.Api.error/0 . Options :name (string) - name of the role :permissions (integer) - bitwise of the enabled/disabled permissions :color (integer) - RGB color value (default: 0) :hoist (boolean) - whether the role should be displayed separately in the sidebar :mentionable (boolean) - whether the role should be mentionable Examples Remedy.Api.modify_guild_role(41771983423143937, 392817238471936, hoist: false, name: &quot;foo-bar&quot;)","ref":"Remedy.Api.html#modify_guild_role/4","title":"Remedy.Api.modify_guild_role/4","type":"function"},{"doc":"Same as modify_guild_role/3 , but raises Remedy.Error.ApiError in case of failure.","ref":"Remedy.Api.html#modify_guild_role!/4","title":"Remedy.Api.modify_guild_role!/4","type":"function"},{"doc":"Reorders a guild's roles. This endpoint requires the MANAGE_ROLES permission. It fires multiple Remedy.Consumer.guild_role_update/0 events. If successful, returns {:ok, roles} . Otherwise, returns a Remedy.Api.error/0 . positions is a list of maps that each map a role id with a position. Examples Remedy.Api.modify_guild_role_positions(41771983423143937, [%{id: 41771983423143936, position: 2}])","ref":"Remedy.Api.html#modify_guild_role_positions/3","title":"Remedy.Api.modify_guild_role_positions/3","type":"function"},{"doc":"Same as modify_guild_role_positions/2 , but raises Remedy.Error.ApiError in case of failure.","ref":"Remedy.Api.html#modify_guild_role_positions!/3","title":"Remedy.Api.modify_guild_role_positions!/3","type":"function"},{"doc":"Modifies a webhook. Parameters webhook_id - Id of the webhook to modify. args - Map with the following optional keys: name - Name of the webhook. avatar - Base64 128x128 jpeg image for the default avatar. reason - An optional reason for the guild audit log.","ref":"Remedy.Api.html#modify_webhook/3","title":"Remedy.Api.modify_webhook/3","type":"function"},{"doc":"Modifies a webhook with a token. This method is exactly like modify_webhook/1 but does not require authentication. Parameters webhook_id - Id of the webhook to modify. webhook_token - Token of the webhook to get. args - Map with the following optional keys: name - Name of the webhook. avatar - Base64 128x128 jpeg image for the default avatar. reason - An optional reason for the guild audit log.","ref":"Remedy.Api.html#modify_webhook_with_token/4","title":"Remedy.Api.modify_webhook_with_token/4","type":"function"},{"doc":"Removes a ban for a user. User to unban is specified by guild_id and user_id . An optional reason can be specified for the audit log.","ref":"Remedy.Api.html#remove_guild_ban/3","title":"Remedy.Api.remove_guild_ban/3","type":"function"},{"doc":"Removes a member from a guild. This event requires the KICK_MEMBERS permission. It fires a Remedy.Consumer.guild_member_remove/0 event. An optional reason can be provided for the audit log with reason . If successful, returns {:ok} . Otherwise, returns a Remedy.Api.error/0 . Examples Remedy.Api.remove_guild_member(1453827904102291, 18739485766253) {:ok}","ref":"Remedy.Api.html#remove_guild_member/3","title":"Remedy.Api.remove_guild_member/3","type":"function"},{"doc":"Same as remove_guild_member/2 , but raises Remedy.Error.ApiError in case of failure.","ref":"Remedy.Api.html#remove_guild_member!/3","title":"Remedy.Api.remove_guild_member!/3","type":"function"},{"doc":"Removes a role from a member. Role to remove is specified by role_id . User to remove role from is specified by guild_id and user_id . An optional reason can be given for the audit log.","ref":"Remedy.Api.html#remove_guild_member_role/4","title":"Remedy.Api.remove_guild_member_role/4","type":"function"},{"doc":"","ref":"Remedy.Api.html#request/1","title":"Remedy.Api.request/1","type":"function"},{"doc":"","ref":"Remedy.Api.html#request/4","title":"Remedy.Api.request/4","type":"function"},{"doc":"","ref":"Remedy.Api.html#request_multipart/4","title":"Remedy.Api.request_multipart/4","type":"function"},{"doc":"Triggers the typing indicator. Triggers the typing indicator in the channel specified by channel_id . The typing indicator lasts for about 8 seconds and then automatically stops. Returns {:ok} if successful. error otherwise.","ref":"Remedy.Api.html#start_typing/1","title":"Remedy.Api.start_typing/1","type":"function"},{"doc":"Same as start_typing/1 , but raises Remedy.Error.ApiError in case of failure.","ref":"Remedy.Api.html#start_typing!/1","title":"Remedy.Api.start_typing!/1","type":"function"},{"doc":"Syncs a guild integration. Integration to sync is specified by guild_id and integeration_id .","ref":"Remedy.Api.html#sync_guild_integrations/2","title":"Remedy.Api.sync_guild_integrations/2","type":"function"},{"doc":"","ref":"Remedy.Api.html#update_shard_status/5","title":"Remedy.Api.update_shard_status/5","type":"function"},{"doc":"","ref":"Remedy.Api.html#update_status/4","title":"Remedy.Api.update_status/4","type":"function"},{"doc":"Joins, moves, or disconnects the bot from a voice channel. The correct shard to send the update to will be inferred from the guild_id . If a corresponding guild_id is not found a cache error will be raised. To disconnect from a channel, channel_id should be set to nil .","ref":"Remedy.Api.html#update_voice_state/4","title":"Remedy.Api.update_voice_state/4","type":"function"},{"doc":"","ref":"Remedy.Api.html#t:emoji/0","title":"Remedy.Api.emoji/0","type":"type"},{"doc":"","ref":"Remedy.Api.html#t:error/0","title":"Remedy.Api.error/0","type":"type"},{"doc":"","ref":"Remedy.Api.html#t:limit/0","title":"Remedy.Api.limit/0","type":"type"},{"doc":"","ref":"Remedy.Api.html#t:locator/0","title":"Remedy.Api.locator/0","type":"type"},{"doc":"","ref":"Remedy.Api.html#t:matrix/0","title":"Remedy.Api.matrix/0","type":"type"},{"doc":"","ref":"Remedy.Api.html#t:options/0","title":"Remedy.Api.options/0","type":"type"},{"doc":"","ref":"Remedy.Api.html#t:status/0","title":"Remedy.Api.status/0","type":"type"},{"doc":"Ratelimit implimentation specific to Discord's API. Only to be used when starting in a rest-only manner.","ref":"Remedy.Api.Ratelimiter.html","title":"Remedy.Api.Ratelimiter","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Remedy.Api.Ratelimiter.html#child_spec/1","title":"Remedy.Api.Ratelimiter.child_spec/1","type":"function"},{"doc":"Empties all buckets, voiding any saved ratelimit values.","ref":"Remedy.Api.Ratelimiter.html#empty_buckets/0","title":"Remedy.Api.Ratelimiter.empty_buckets/0","type":"function"},{"doc":"Retrieves a proper ratelimit endpoint from a given route and url.","ref":"Remedy.Api.Ratelimiter.html#get_endpoint/2","title":"Remedy.Api.Ratelimiter.get_endpoint/2","type":"function"},{"doc":"Callback implementation for GenServer.init/1 .","ref":"Remedy.Api.Ratelimiter.html#init/1","title":"Remedy.Api.Ratelimiter.init/1","type":"function"},{"doc":"Starts the ratelimiter.","ref":"Remedy.Api.Ratelimiter.html#start_link/1","title":"Remedy.Api.Ratelimiter.start_link/1","type":"function"},{"doc":"Return values of start functions.","ref":"Remedy.Api.Ratelimiter.html#t:on_start/0","title":"Remedy.Api.Ratelimiter.on_start/0","type":"type"},{"doc":"Simple cache that stores information for the current user.","ref":"Remedy.Bot.html","title":"Remedy.Bot","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Remedy.Bot.html#child_spec/1","title":"Remedy.Bot.child_spec/1","type":"function"},{"doc":"Returns the current user's state.","ref":"Remedy.Bot.html#get/0","title":"Remedy.Bot.get/0","type":"function"},{"doc":"","ref":"Remedy.Bot.html#start_link/1","title":"Remedy.Bot.start_link/1","type":"function"},{"doc":"Functions for interracting with the cache.","ref":"Remedy.Cache.html","title":"Remedy.Cache","type":"module"},{"doc":"Consumer process for gateway event handling. Consuming Gateway Events To handle events, Remedy uses a GenStage implementation. Remedy defines the producer and producer_consumer in the GenStage design. To consume the events you must create at least one consumer process. It is generally recommended that you spawn a consumer per core. To find this number you can use System.schedulers_online/0 . Remedy uses a ConsumerSupervisor to dispatch events, meaning your handlers will each be ran in their own seperate task. Example An example consumer can be found here .","ref":"Remedy.Consumer.html","title":"Remedy.Consumer","type":"behaviour"},{"doc":"Callback used to handle events. Event event is a tuple describing the event. The tuple will include information in the following format: {event_name, {event_payload(s)}, WSState.t} For example, a message create will look like this {:MESSAGE_CREATE, {Remedy.Struct.Message.t}, WSState.t} In some cases there will be multiple payloads when something is updated, so as to include the new and the old versions. In the event of there being two payloads, the old payload will always be first, followed by the new payload. {:USER_UPDATE, {old_user :: Remedy.Struct.User.t, new_user :: Remedy.Struct.User.t}, WSState.t()} For a full listing of events, please see Remedy.Consumer.event/0 .","ref":"Remedy.Consumer.html#c:handle_event/1","title":"Remedy.Consumer.handle_event/1","type":"callback"},{"doc":"Starts a consumer process. mod is the name of the module where you define your event callbacks, which should probably be the current module which you can get with __MODULE__ . opts is a list of general process options. See Remedy.Consumer.options/0 for more info.","ref":"Remedy.Consumer.html#start_link/2","title":"Remedy.Consumer.start_link/2","type":"function"},{"doc":"","ref":"Remedy.Consumer.html#t:channel_create/0","title":"Remedy.Consumer.channel_create/0","type":"type"},{"doc":"","ref":"Remedy.Consumer.html#t:channel_delete/0","title":"Remedy.Consumer.channel_delete/0","type":"type"},{"doc":"","ref":"Remedy.Consumer.html#t:channel_pins_ack/0","title":"Remedy.Consumer.channel_pins_ack/0","type":"type"},{"doc":"","ref":"Remedy.Consumer.html#t:channel_pins_update/0","title":"Remedy.Consumer.channel_pins_update/0","type":"type"},{"doc":"Dispatched when a channel is updated. old_channel will be nil when the pre-update channel could not be fetched from the cache.","ref":"Remedy.Consumer.html#t:channel_update/0","title":"Remedy.Consumer.channel_update/0","type":"type"},{"doc":"","ref":"Remedy.Consumer.html#t:event/0","title":"Remedy.Consumer.event/0","type":"type"},{"doc":"","ref":"Remedy.Consumer.html#t:guild_available/0","title":"Remedy.Consumer.guild_available/0","type":"type"},{"doc":"","ref":"Remedy.Consumer.html#t:guild_ban_add/0","title":"Remedy.Consumer.guild_ban_add/0","type":"type"},{"doc":"","ref":"Remedy.Consumer.html#t:guild_ban_remove/0","title":"Remedy.Consumer.guild_ban_remove/0","type":"type"},{"doc":"","ref":"Remedy.Consumer.html#t:guild_create/0","title":"Remedy.Consumer.guild_create/0","type":"type"},{"doc":"","ref":"Remedy.Consumer.html#t:guild_delete/0","title":"Remedy.Consumer.guild_delete/0","type":"type"},{"doc":"","ref":"Remedy.Consumer.html#t:guild_emojis_update/0","title":"Remedy.Consumer.guild_emojis_update/0","type":"type"},{"doc":"","ref":"Remedy.Consumer.html#t:guild_integrations_update/0","title":"Remedy.Consumer.guild_integrations_update/0","type":"type"},{"doc":"","ref":"Remedy.Consumer.html#t:guild_member_add/0","title":"Remedy.Consumer.guild_member_add/0","type":"type"},{"doc":"","ref":"Remedy.Consumer.html#t:guild_member_remove/0","title":"Remedy.Consumer.guild_member_remove/0","type":"type"},{"doc":"Dispatched when a guild member is updated. old_member will be nil when the pre-update member could not be fetched from the cache.","ref":"Remedy.Consumer.html#t:guild_member_update/0","title":"Remedy.Consumer.guild_member_update/0","type":"type"},{"doc":"","ref":"Remedy.Consumer.html#t:guild_members_chunk/0","title":"Remedy.Consumer.guild_members_chunk/0","type":"type"},{"doc":"","ref":"Remedy.Consumer.html#t:guild_role_create/0","title":"Remedy.Consumer.guild_role_create/0","type":"type"},{"doc":"","ref":"Remedy.Consumer.html#t:guild_role_delete/0","title":"Remedy.Consumer.guild_role_delete/0","type":"type"},{"doc":"Dispatched when a role on a guild is updated. old_role will be nil when the pre-update role could not be fetched from the cache.","ref":"Remedy.Consumer.html#t:guild_role_update/0","title":"Remedy.Consumer.guild_role_update/0","type":"type"},{"doc":"","ref":"Remedy.Consumer.html#t:guild_unavailable/0","title":"Remedy.Consumer.guild_unavailable/0","type":"type"},{"doc":"","ref":"Remedy.Consumer.html#t:guild_update/0","title":"Remedy.Consumer.guild_update/0","type":"type"},{"doc":"","ref":"Remedy.Consumer.html#t:message_ack/0","title":"Remedy.Consumer.message_ack/0","type":"type"},{"doc":"","ref":"Remedy.Consumer.html#t:message_create/0","title":"Remedy.Consumer.message_create/0","type":"type"},{"doc":"","ref":"Remedy.Consumer.html#t:message_delete/0","title":"Remedy.Consumer.message_delete/0","type":"type"},{"doc":"","ref":"Remedy.Consumer.html#t:message_delete_bulk/0","title":"Remedy.Consumer.message_delete_bulk/0","type":"type"},{"doc":"","ref":"Remedy.Consumer.html#t:message_reaction_add/0","title":"Remedy.Consumer.message_reaction_add/0","type":"type"},{"doc":"","ref":"Remedy.Consumer.html#t:message_reaction_remove/0","title":"Remedy.Consumer.message_reaction_remove/0","type":"type"},{"doc":"","ref":"Remedy.Consumer.html#t:message_reaction_remove_all/0","title":"Remedy.Consumer.message_reaction_remove_all/0","type":"type"},{"doc":"","ref":"Remedy.Consumer.html#t:message_reaction_remove_emoji/0","title":"Remedy.Consumer.message_reaction_remove_emoji/0","type":"type"},{"doc":"","ref":"Remedy.Consumer.html#t:message_update/0","title":"Remedy.Consumer.message_update/0","type":"type"},{"doc":"General process options. The subscribe_to option should only be set if you want to use your own producer or producer consumer.","ref":"Remedy.Consumer.html#t:option/0","title":"Remedy.Consumer.option/0","type":"type"},{"doc":"","ref":"Remedy.Consumer.html#t:options/0","title":"Remedy.Consumer.options/0","type":"type"},{"doc":"Dispatched when a user's presence is updated. old_presence will be nil when the pre-update presence could not be fetched from the cache.","ref":"Remedy.Consumer.html#t:presence_update/0","title":"Remedy.Consumer.presence_update/0","type":"type"},{"doc":"","ref":"Remedy.Consumer.html#t:ready/0","title":"Remedy.Consumer.ready/0","type":"type"},{"doc":"","ref":"Remedy.Consumer.html#t:resumed/0","title":"Remedy.Consumer.resumed/0","type":"type"},{"doc":"","ref":"Remedy.Consumer.html#t:typing_start/0","title":"Remedy.Consumer.typing_start/0","type":"type"},{"doc":"","ref":"Remedy.Consumer.html#t:user_settings_update/0","title":"Remedy.Consumer.user_settings_update/0","type":"type"},{"doc":"Dispatched when a user is updated. old_user will be nil when the pre-update user could not be fetched from the cache.","ref":"Remedy.Consumer.html#t:user_update/0","title":"Remedy.Consumer.user_update/0","type":"type"},{"doc":"Dispatched when the bot is ready to begin sending audio after joining a voice channel. Note that the third tuple element is of type VoiceWSState.t() instead of WSState.t().","ref":"Remedy.Consumer.html#t:voice_ready/0","title":"Remedy.Consumer.voice_ready/0","type":"type"},{"doc":"","ref":"Remedy.Consumer.html#t:voice_server_update/0","title":"Remedy.Consumer.voice_server_update/0","type":"type"},{"doc":"Dispatched when the bot starts or stops speaking. Note that the third tuple element is of type VoiceWSState.t() instead of WSState.t().","ref":"Remedy.Consumer.html#t:voice_speaking_update/0","title":"Remedy.Consumer.voice_speaking_update/0","type":"type"},{"doc":"","ref":"Remedy.Consumer.html#t:voice_state_update/0","title":"Remedy.Consumer.voice_state_update/0","type":"type"},{"doc":"","ref":"Remedy.Consumer.html#t:webhooks_update/0","title":"Remedy.Consumer.webhooks_update/0","type":"type"},{"doc":"Functions that work on permissions. Some functions return a list of permissions. You can use enumerable functions to work with permissions: alias Remedy.Cache.GuildCache alias Remedy.Struct.Guild.Member guild = GuildCache.get!(279093381723062272) member = Map.get(guild.members, 177888205536886784) member_perms = Member.guild_permissions(member, guild) if :administrator in member_perms do IO.puts(&quot;This user has the administrator permission.&quot;) end","ref":"Remedy.Permission.html","title":"Remedy.Permission","type":"module"},{"doc":"Returns a list of all permissions.","ref":"Remedy.Permission.html#all/0","title":"Remedy.Permission.all/0","type":"function"},{"doc":"Converts the given bit to a permission. This function returns :error if bit does not map to a permission. Examples iex&gt; Remedy.Permission.from_bit(0x04000000) {:ok, :change_nickname} iex&gt; Remedy.Permission.from_bit(0) :error","ref":"Remedy.Permission.html#from_bit/1","title":"Remedy.Permission.from_bit/1","type":"function"},{"doc":"Same as from_bit/1 , but raises ArgumentError in case of failure. Examples iex&gt; Remedy.Permission.from_bit!(0x04000000) :change_nickname iex&gt; Remedy.Permission.from_bit!(0) ** (ArgumentError) expected a valid bit, got: `0`","ref":"Remedy.Permission.html#from_bit!/1","title":"Remedy.Permission.from_bit!/1","type":"function"},{"doc":"Converts the given bitset to a list of permissions. If invalid bits are given they will be omitted from the results. Examples iex&gt; Remedy.Permission.from_bitset(0x08000002) [:manage_nicknames, :kick_members] iex&gt; Remedy.Permission.from_bitset(0x4000000000000) []","ref":"Remedy.Permission.html#from_bitset/1","title":"Remedy.Permission.from_bitset/1","type":"function"},{"doc":"Returns true if term is a permission; otherwise returns false . Examples iex&gt; Remedy.Permission.is_permission(:administrator) true iex&gt; Remedy.Permission.is_permission(:not_a_permission) false","ref":"Remedy.Permission.html#is_permission/1","title":"Remedy.Permission.is_permission/1","type":"macro"},{"doc":"Converts the given permission to a bit. Examples iex&gt; Remedy.Permission.to_bit(:administrator) 8","ref":"Remedy.Permission.html#to_bit/1","title":"Remedy.Permission.to_bit/1","type":"function"},{"doc":"Converts the given enumerable of permissions to a bitset. Examples iex&gt; Remedy.Permission.to_bitset([:administrator, :create_instant_invite]) 9","ref":"Remedy.Permission.html#to_bitset/1","title":"Remedy.Permission.to_bitset/1","type":"function"},{"doc":"Represents a single permission as a bitvalue.","ref":"Remedy.Permission.html#t:bit/0","title":"Remedy.Permission.bit/0","type":"type"},{"doc":"Represents a set of permissions as a bitvalue.","ref":"Remedy.Permission.html#t:bitset/0","title":"Remedy.Permission.bitset/0","type":"type"},{"doc":"","ref":"Remedy.Permission.html#t:general_permission/0","title":"Remedy.Permission.general_permission/0","type":"type"},{"doc":"","ref":"Remedy.Permission.html#t:t/0","title":"Remedy.Permission.t/0","type":"type"},{"doc":"","ref":"Remedy.Permission.html#t:text_permission/0","title":"Remedy.Permission.text_permission/0","type":"type"},{"doc":"","ref":"Remedy.Permission.html#t:voice_permission/0","title":"Remedy.Permission.voice_permission/0","type":"type"},{"doc":"","ref":"Remedy.Schema.ApplicationWebhook.html","title":"Remedy.Schema.ApplicationWebhook","type":"module"},{"doc":"","ref":"Remedy.Schema.Command.html","title":"Remedy.Schema.Command","type":"module"},{"doc":"","ref":"Remedy.Schema.Command.html#validate/1","title":"Remedy.Schema.Command.validate/1","type":"function"},{"doc":"","ref":"Remedy.Schema.Component.html","title":"Remedy.Schema.Component","type":"module"},{"doc":"","ref":"Remedy.Schema.Embed.Author.html","title":"Remedy.Schema.Embed.Author","type":"module"},{"doc":"","ref":"Remedy.Schema.Embed.Field.html","title":"Remedy.Schema.Embed.Field","type":"module"},{"doc":"","ref":"Remedy.Schema.Embed.Footer.html","title":"Remedy.Schema.Embed.Footer","type":"module"},{"doc":"","ref":"Remedy.Schema.Emoji.html","title":"Remedy.Schema.Emoji","type":"module"},{"doc":"","ref":"Remedy.Schema.Emoji.html#validate/1","title":"Remedy.Schema.Emoji.validate/1","type":"function"},{"doc":"","ref":"Remedy.Schema.Guild.html","title":"Remedy.Schema.Guild","type":"module"},{"doc":"","ref":"Remedy.Schema.IncomingWebhook.html","title":"Remedy.Schema.IncomingWebhook","type":"module"},{"doc":"","ref":"Remedy.Schema.Member.html","title":"Remedy.Schema.Member","type":"module"},{"doc":"","ref":"Remedy.Schema.Role.html","title":"Remedy.Schema.Role","type":"module"},{"doc":"","ref":"Remedy.Schema.StageInstance.html","title":"Remedy.Schema.StageInstance","type":"module"},{"doc":"","ref":"Remedy.Schema.Sticker.html","title":"Remedy.Schema.Sticker","type":"module"},{"doc":"","ref":"Remedy.Schema.StickerPack.html","title":"Remedy.Schema.StickerPack","type":"module"},{"doc":"","ref":"Remedy.Schema.Team.html","title":"Remedy.Schema.Team","type":"module"},{"doc":"","ref":"Remedy.Schema.TeamMember.html","title":"Remedy.Schema.TeamMember","type":"module"},{"doc":"","ref":"Remedy.Schema.User.html","title":"Remedy.Schema.User","type":"module"},{"doc":"","ref":"Remedy.Schema.VoiceRegion.html","title":"Remedy.Schema.VoiceRegion","type":"module"},{"doc":"","ref":"Remedy.Schema.VoiceState.html","title":"Remedy.Schema.VoiceState","type":"module"},{"doc":"","ref":"Remedy.Schema.WSState.html","title":"Remedy.Schema.WSState","type":"module"},{"doc":"","ref":"Remedy.Schema.WSvState.html","title":"Remedy.Schema.WSvState","type":"module"},{"doc":"","ref":"Remedy.Schema.Webhook.html","title":"Remedy.Schema.Webhook","type":"module"},{"doc":"Struct for interaction data.","ref":"Remedy.Struct.ApplicationCommandInteractionData.html","title":"Remedy.Struct.ApplicationCommandInteractionData","type":"module"},{"doc":"For components, the type of the component","ref":"Remedy.Struct.ApplicationCommandInteractionData.html#t:component_type/0","title":"Remedy.Struct.ApplicationCommandInteractionData.component_type/0","type":"type"},{"doc":"For components, the custom_id of the component","ref":"Remedy.Struct.ApplicationCommandInteractionData.html#t:custom_id/0","title":"Remedy.Struct.ApplicationCommandInteractionData.custom_id/0","type":"type"},{"doc":"ID of the invoked command","ref":"Remedy.Struct.ApplicationCommandInteractionData.html#t:id/0","title":"Remedy.Struct.ApplicationCommandInteractionData.id/0","type":"type"},{"doc":"Name of the invoked command","ref":"Remedy.Struct.ApplicationCommandInteractionData.html#t:name/0","title":"Remedy.Struct.ApplicationCommandInteractionData.name/0","type":"type"},{"doc":"Parameters and values supplied by the user, if applicable","ref":"Remedy.Struct.ApplicationCommandInteractionData.html#t:options/0","title":"Remedy.Struct.ApplicationCommandInteractionData.options/0","type":"type"},{"doc":"Converted users &amp; roles &amp; channels","ref":"Remedy.Struct.ApplicationCommandInteractionData.html#t:resolved/0","title":"Remedy.Struct.ApplicationCommandInteractionData.resolved/0","type":"type"},{"doc":"Command interaction data for slash commands. Used as part of Remedy.Struct.Interaction.t/0 . Official reference: https://discord.com/developers/docs/interactions/slash-commands#interaction-applicationcommandinteractiondata","ref":"Remedy.Struct.ApplicationCommandInteractionData.html#t:t/0","title":"Remedy.Struct.ApplicationCommandInteractionData.t/0","type":"type"},{"doc":"Struct for command invocation arguments.","ref":"Remedy.Struct.ApplicationCommandInteractionDataOption.html","title":"Remedy.Struct.ApplicationCommandInteractionDataOption","type":"module"},{"doc":"Parameter name","ref":"Remedy.Struct.ApplicationCommandInteractionDataOption.html#t:name/0","title":"Remedy.Struct.ApplicationCommandInteractionDataOption.name/0","type":"type"},{"doc":"Parameter options for subcommands. Mutually exclusive with value .","ref":"Remedy.Struct.ApplicationCommandInteractionDataOption.html#t:options/0","title":"Remedy.Struct.ApplicationCommandInteractionDataOption.options/0","type":"type"},{"doc":"Command interaction data struct","ref":"Remedy.Struct.ApplicationCommandInteractionDataOption.html#t:t/0","title":"Remedy.Struct.ApplicationCommandInteractionDataOption.t/0","type":"type"},{"doc":"The application command option type. See https://discord.com/developers/docs/interactions/slash-commands#application-command-object-application-command-option-type for more details.","ref":"Remedy.Struct.ApplicationCommandInteractionDataOption.html#t:type/0","title":"Remedy.Struct.ApplicationCommandInteractionDataOption.type/0","type":"type"},{"doc":"Parameter value. Mutually exclusive with options .","ref":"Remedy.Struct.ApplicationCommandInteractionDataOption.html#t:value/0","title":"Remedy.Struct.ApplicationCommandInteractionDataOption.value/0","type":"type"},{"doc":"Converted interaction payload.","ref":"Remedy.Struct.ApplicationCommandInteractionDataResolved.html","title":"Remedy.Struct.ApplicationCommandInteractionDataResolved","type":"module"},{"doc":"IDs and corresponding partial channels. The channels in this map only have the following keys set: id name type permissions","ref":"Remedy.Struct.ApplicationCommandInteractionDataResolved.html#t:channels/0","title":"Remedy.Struct.ApplicationCommandInteractionDataResolved.channels/0","type":"type"},{"doc":"IDs and corresponding partial members. These members are missing values on the following fields: user deaf mute The corresponding user data can be looked up in users . For members that are part of this map, data for the corresponding user will always be included.","ref":"Remedy.Struct.ApplicationCommandInteractionDataResolved.html#t:members/0","title":"Remedy.Struct.ApplicationCommandInteractionDataResolved.members/0","type":"type"},{"doc":"The IDs and corresponding messages.","ref":"Remedy.Struct.ApplicationCommandInteractionDataResolved.html#t:messages/0","title":"Remedy.Struct.ApplicationCommandInteractionDataResolved.messages/0","type":"type"},{"doc":"IDs and corresponding roles","ref":"Remedy.Struct.ApplicationCommandInteractionDataResolved.html#t:roles/0","title":"Remedy.Struct.ApplicationCommandInteractionDataResolved.roles/0","type":"type"},{"doc":"Resolved interaction data","ref":"Remedy.Struct.ApplicationCommandInteractionDataResolved.html#t:t/0","title":"Remedy.Struct.ApplicationCommandInteractionDataResolved.t/0","type":"type"},{"doc":"IDs and corresponding users","ref":"Remedy.Struct.ApplicationCommandInteractionDataResolved.html#t:users/0","title":"Remedy.Struct.ApplicationCommandInteractionDataResolved.users/0","type":"type"},{"doc":"Struct representing a Discord guild channel. A Remedy.Struct.Channel represents all 5 types of channels. Each channel has a field :type with any of the following values: 0 - GUILD_TEXT 1 - DM 2 - GUILD_VOICE 3 - GROUP_DM 4 - GUILD_CATEGORY More information can be found on the Discord API Channel Documentation . Mentioning Channels in Messages A Remedy.Struct.Channel can be mentioned in message content using the String.Chars protocol or mention/1 . channel = %Remedy.Struct.Channel{id: 381889573426429952} Remedy.Api.create_message!(184046599834435585, &quot;\#{channel}&quot;) %Remedy.Struct.Message{content: &quot;&lt;#381889573426429952&gt;&quot;} channel = %Remedy.Struct.Channel{id: 280085880452939778} Remedy.Api.create_message!(280085880452939778, &quot;\#{Remedy.Struct.Channel.mention(channel)}&quot;) %Remedy.Struct.Message{content: &quot;&lt;#280085880452939778&gt;&quot;}","ref":"Remedy.Struct.Channel.html","title":"Remedy.Struct.Channel","type":"module"},{"doc":"Formats a Remedy.Struct.Channel into a mention. Examples iex&gt; channel = %Remedy.Struct.Channel{id: 381889573426429952} ...&gt; Remedy.Struct.Channel.mention(channel) &quot;&lt;#381889573426429952&gt;&quot;","ref":"Remedy.Struct.Channel.html#mention/1","title":"Remedy.Struct.Channel.mention/1","type":"function"},{"doc":"The application id of the group DM creator if it is bot-created","ref":"Remedy.Struct.Channel.html#t:application_id/0","title":"Remedy.Struct.Channel.application_id/0","type":"type"},{"doc":"The bitrate of the voice channel","ref":"Remedy.Struct.Channel.html#t:bitrate/0","title":"Remedy.Struct.Channel.bitrate/0","type":"type"},{"doc":"A Remedy.Struct.Channel that represents a channel category in a guild.","ref":"Remedy.Struct.Channel.html#t:channel_category/0","title":"Remedy.Struct.Channel.channel_category/0","type":"type"},{"doc":"A Remedy.Struct.Channel that represents a DM channel.","ref":"Remedy.Struct.Channel.html#t:dm_channel/0","title":"Remedy.Struct.Channel.dm_channel/0","type":"type"},{"doc":"A Remedy.Struct.Channel that represents a group DM channel.","ref":"Remedy.Struct.Channel.html#t:group_dm_channel/0","title":"Remedy.Struct.Channel.group_dm_channel/0","type":"type"},{"doc":"A Remedy.Struct.Channel that represents a channel in a guild.","ref":"Remedy.Struct.Channel.html#t:guild_channel/0","title":"Remedy.Struct.Channel.guild_channel/0","type":"type"},{"doc":"The id of the channel's guild","ref":"Remedy.Struct.Channel.html#t:guild_id/0","title":"Remedy.Struct.Channel.guild_id/0","type":"type"},{"doc":"A Remedy.Struct.Channel that represents a text channel in a guild.","ref":"Remedy.Struct.Channel.html#t:guild_text_channel/0","title":"Remedy.Struct.Channel.guild_text_channel/0","type":"type"},{"doc":"A Remedy.Struct.Channel that represents a voice channel in a guild.","ref":"Remedy.Struct.Channel.html#t:guild_voice_channel/0","title":"Remedy.Struct.Channel.guild_voice_channel/0","type":"type"},{"doc":"The icon hash of the channel","ref":"Remedy.Struct.Channel.html#t:icon/0","title":"Remedy.Struct.Channel.icon/0","type":"type"},{"doc":"The channel's id","ref":"Remedy.Struct.Channel.html#t:id/0","title":"Remedy.Struct.Channel.id/0","type":"type"},{"doc":"Id of the last message sent","ref":"Remedy.Struct.Channel.html#t:last_message_id/0","title":"Remedy.Struct.Channel.last_message_id/0","type":"type"},{"doc":"When the last pinned message was pinned","ref":"Remedy.Struct.Channel.html#t:last_pin_timestamp/0","title":"Remedy.Struct.Channel.last_pin_timestamp/0","type":"type"},{"doc":"The name of the channel","ref":"Remedy.Struct.Channel.html#t:name/0","title":"Remedy.Struct.Channel.name/0","type":"type"},{"doc":"If the channel is nsfw","ref":"Remedy.Struct.Channel.html#t:nsfw/0","title":"Remedy.Struct.Channel.nsfw/0","type":"type"},{"doc":"The id of the DM creator","ref":"Remedy.Struct.Channel.html#t:owner_id/0","title":"Remedy.Struct.Channel.owner_id/0","type":"type"},{"doc":"The id of the parent category for a channel","ref":"Remedy.Struct.Channel.html#t:parent_id/0","title":"Remedy.Struct.Channel.parent_id/0","type":"type"},{"doc":"The list of overwrites","ref":"Remedy.Struct.Channel.html#t:permission_overwrites/0","title":"Remedy.Struct.Channel.permission_overwrites/0","type":"type"},{"doc":"The ordered position of the channel","ref":"Remedy.Struct.Channel.html#t:position/0","title":"Remedy.Struct.Channel.position/0","type":"type"},{"doc":"The recipients of the DM","ref":"Remedy.Struct.Channel.html#t:recipients/0","title":"Remedy.Struct.Channel.recipients/0","type":"type"},{"doc":"","ref":"Remedy.Struct.Channel.html#t:t/0","title":"Remedy.Struct.Channel.t/0","type":"type"},{"doc":"A Remedy.Struct.Channel that represents a text channel.","ref":"Remedy.Struct.Channel.html#t:text_channel/0","title":"Remedy.Struct.Channel.text_channel/0","type":"type"},{"doc":"Current channel topic","ref":"Remedy.Struct.Channel.html#t:topic/0","title":"Remedy.Struct.Channel.topic/0","type":"type"},{"doc":"The user limit of the voice channel","ref":"Remedy.Struct.Channel.html#t:user_limit/0","title":"Remedy.Struct.Channel.user_limit/0","type":"type"},{"doc":"A Remedy.Struct.Channel that represents a voice channel.","ref":"Remedy.Struct.Channel.html#t:voice_channel/0","title":"Remedy.Struct.Channel.voice_channel/0","type":"type"},{"doc":"Functions that work on Discord embeds. Building Embeds Remedy.Struct.Embed s can be built using this module's builder functions or standard Map syntax: iex&gt; import Remedy.Struct.Embed ...&gt; embed = ...&gt; %Remedy.Struct.Embed{} ...&gt; |&gt; put_title(&quot;craig&quot;) ...&gt; |&gt; put_description(&quot;remedy&quot;) ...&gt; |&gt; put_url(&quot;https://google.com/&quot;) ...&gt; |&gt; put_timestamp(&quot;2016-05-05T21:04:13.203Z&quot;) ...&gt; |&gt; put_color(431_948) ...&gt; |&gt; put_field(&quot;Field 1&quot;, &quot;Test&quot;) ...&gt; |&gt; put_field(&quot;Field 2&quot;, &quot;More test&quot;, true) ...&gt; embed %Remedy.Struct.Embed{ title: &quot;craig&quot;, description: &quot;remedy&quot;, url: &quot;https://google.com/&quot;, timestamp: &quot;2016-05-05T21:04:13.203Z&quot;, color: 431_948, fields: [ %Remedy.Struct.Embed.Field{name: &quot;Field 1&quot;, value: &quot;Test&quot;}, %Remedy.Struct.Embed.Field{name: &quot;Field 2&quot;, value: &quot;More test&quot;, inline: true} ] } Using structs You can also create Remedy.Struct.Embed s from structs, by using the Remedy.Struct.Embed module. Here's how the example above could be build using structs defmodule MyApp.MyStruct do use Remedy.Struct.Embed defstruct [] def title(_), do: &quot;craig&quot; def description(_), do: &quot;remedy&quot; def url(_), do: &quot;https://google.com/&quot; def timestamp(_), do: &quot;2016-05-05T21:04:13.203Z&quot; def color(_), do: 431_948 def fields(_) do [ %Remedy.Struct.Embed.Field{name: &quot;Field 1&quot;, value: &quot;Test&quot;}, %Remedy.Struct.Embed.Field{name: &quot;Field 2&quot;, value: &quot;More test&quot;, inline: true} ] end end Remedy.Struct.Embed.from(%MyApp.MyStruct{}) %Remedy.Struct.Embed{ title: &quot;craig&quot;, description: &quot;remedy&quot;, url: &quot; https://google.com/&quot;, timestamp: &quot;2016-05-05T21:04:13.203Z&quot;, color: 431_948, fields: [ % Remedy.Struct.Embed.Field { name : &quot;Field 1&quot; , value : &quot;Test&quot; } , % Remedy.Struct.Embed.Field { name : &quot;Field 2&quot; , value : &quot;More test&quot; , inline : true } ] } See this modules callbacks for a list of all the functions that can be implemented . The implementation of these callbacks is optional . Not implemented functions will simply be ignored .","ref":"Remedy.Struct.Embed.html","title":"Remedy.Struct.Embed","type":"behaviour"},{"doc":"","ref":"Remedy.Struct.Embed.html#c:author/1","title":"Remedy.Struct.Embed.author/1","type":"callback"},{"doc":"","ref":"Remedy.Struct.Embed.html#c:color/1","title":"Remedy.Struct.Embed.color/1","type":"callback"},{"doc":"","ref":"Remedy.Struct.Embed.html#c:description/1","title":"Remedy.Struct.Embed.description/1","type":"callback"},{"doc":"","ref":"Remedy.Struct.Embed.html#c:fields/1","title":"Remedy.Struct.Embed.fields/1","type":"callback"},{"doc":"","ref":"Remedy.Struct.Embed.html#c:footer/1","title":"Remedy.Struct.Embed.footer/1","type":"callback"},{"doc":"Create an embed from a struct that implements the Remedy.Struct.Embed behaviour","ref":"Remedy.Struct.Embed.html#from/1","title":"Remedy.Struct.Embed.from/1","type":"function"},{"doc":"","ref":"Remedy.Struct.Embed.html#c:image/1","title":"Remedy.Struct.Embed.image/1","type":"callback"},{"doc":"Puts a Remedy.Struct.Embed.Author under :author in embed . Examples iex&gt; embed = %Remedy.Struct.Embed{} ...&gt; Remedy.Struct.Embed.put_author(embed, &quot;skippi&quot;, &quot;https://github.com/skippi&quot;, nil) %Remedy.Struct.Embed{ author: %Remedy.Struct.Embed.Author{ name: &quot;skippi&quot;, url: &quot;https://github.com/skippi&quot;, icon_url: nil } }","ref":"Remedy.Struct.Embed.html#put_author/4","title":"Remedy.Struct.Embed.put_author/4","type":"function"},{"doc":"Puts the given value under :color in embed . Examples iex&gt; embed = %Remedy.Struct.Embed{} ...&gt; Remedy.Struct.Embed.put_color(embed, 431948) %Remedy.Struct.Embed{color: 431948}","ref":"Remedy.Struct.Embed.html#put_color/2","title":"Remedy.Struct.Embed.put_color/2","type":"function"},{"doc":"Puts the given value under :description in embed . Examples iex&gt; embed = %Remedy.Struct.Embed{} ...&gt; Remedy.Struct.Embed.put_description(embed, &quot;An elixir library for the discord API.&quot;) %Remedy.Struct.Embed{description: &quot;An elixir library for the discord API.&quot;}","ref":"Remedy.Struct.Embed.html#put_description/2","title":"Remedy.Struct.Embed.put_description/2","type":"function"},{"doc":"Adds a Remedy.Struct.Embed.Field under :fields in embed . Examples iex&gt; embed = %Remedy.Struct.Embed{} ...&gt; Remedy.Struct.Embed.put_field(embed, &quot;First User&quot;, &quot;b1nzy&quot;) %Remedy.Struct.Embed{ fields: [ %Remedy.Struct.Embed.Field{name: &quot;First User&quot;, value: &quot;b1nzy&quot;} ] } iex&gt; embed = %Remedy.Struct.Embed{ ...&gt; fields: [ ...&gt; %Remedy.Struct.Embed.Field{name: &quot;First User&quot;, value: &quot;b1nzy&quot;} ...&gt; ] ...&gt; } ...&gt; Remedy.Struct.Embed.put_field(embed, &quot;Second User&quot;, &quot;Danny&quot;) %Remedy.Struct.Embed{ fields: [ %Remedy.Struct.Embed.Field{name: &quot;First User&quot;, value: &quot;b1nzy&quot;}, %Remedy.Struct.Embed.Field{name: &quot;Second User&quot;, value: &quot;Danny&quot;} ] }","ref":"Remedy.Struct.Embed.html#put_field/4","title":"Remedy.Struct.Embed.put_field/4","type":"function"},{"doc":"Puts a Remedy.Struct.Embed.Footer under :footer in embed . Examples iex&gt; embed = %Remedy.Struct.Embed{} ...&gt; Remedy.Struct.Embed.put_footer(embed, &quot;Discord API&quot;, nil) %Remedy.Struct.Embed{ footer: %Remedy.Struct.Embed.Footer{ text: &quot;Discord API&quot;, icon_url: nil } } iex&gt; embed = %Remedy.Struct.Embed{} ...&gt; Remedy.Struct.Embed.put_footer(embed, &quot;remedy footer&quot;, &quot;https://discord.com/assets/53ef346458017da2062aca5c7955946b.svg&quot;) %Remedy.Struct.Embed{ footer: %Remedy.Struct.Embed.Footer{ text: &quot;remedy footer&quot;, icon_url: &quot;https://discord.com/assets/53ef346458017da2062aca5c7955946b.svg&quot; } }","ref":"Remedy.Struct.Embed.html#put_footer/3","title":"Remedy.Struct.Embed.put_footer/3","type":"function"},{"doc":"Puts a Remedy.Struct.Embed.Image under :image in embed . Examples iex&gt; embed = %Remedy.Struct.Embed{} ...&gt; Remedy.Struct.Embed.put_image(embed, &quot;https://discord.com/assets/af92e60c16b7019f34a467383b31490a.svg&quot;) %Remedy.Struct.Embed{ image: %Remedy.Struct.Embed.Image{ url: &quot;https://discord.com/assets/af92e60c16b7019f34a467383b31490a.svg&quot; } }","ref":"Remedy.Struct.Embed.html#put_image/2","title":"Remedy.Struct.Embed.put_image/2","type":"function"},{"doc":"Puts a Remedy.Struct.Embed.Thumbnail under :thumbnail in embed . Examples iex&gt; embed = %Remedy.Struct.Embed{} ...&gt; Remedy.Struct.Embed.put_thumbnail(embed, &quot;https://discord.com/assets/af92e60c16b7019f34a467383b31490a.svg&quot;) %Remedy.Struct.Embed{ thumbnail: %Remedy.Struct.Embed.Thumbnail{ url: &quot;https://discord.com/assets/af92e60c16b7019f34a467383b31490a.svg&quot; } }","ref":"Remedy.Struct.Embed.html#put_thumbnail/2","title":"Remedy.Struct.Embed.put_thumbnail/2","type":"function"},{"doc":"Puts the given value under :timestamp in embed . Examples iex&gt; embed = % Remedy.Struct.Embed { } ...&gt; Remedy.Struct.Embed . put_timestamp ( embed , &quot;2018-04-21T17:33:51.893000Z&quot; ) % Remedy.Struct.Embed { timestamp : &quot;2018-04-21T17:33:51.893000Z&quot; }","ref":"Remedy.Struct.Embed.html#put_timestamp/2","title":"Remedy.Struct.Embed.put_timestamp/2","type":"function"},{"doc":"Puts the given value under :title in embed . Examples iex&gt; embed = %Remedy.Struct.Embed{} ...&gt; Remedy.Struct.Embed.put_title(embed, &quot;remedy&quot;) %Remedy.Struct.Embed{title: &quot;remedy&quot;}","ref":"Remedy.Struct.Embed.html#put_title/2","title":"Remedy.Struct.Embed.put_title/2","type":"function"},{"doc":"Puts the given value under :url in embed . Examples iex&gt; embed = %Remedy.Struct.Embed{} ...&gt; Remedy.Struct.Embed.put_url(embed, &quot;https://github.com/bdanklin/remedy&quot;) %Remedy.Struct.Embed{url: &quot;https://github.com/bdanklin/remedy&quot;}","ref":"Remedy.Struct.Embed.html#put_url/2","title":"Remedy.Struct.Embed.put_url/2","type":"function"},{"doc":"","ref":"Remedy.Struct.Embed.html#c:thumbnail/1","title":"Remedy.Struct.Embed.thumbnail/1","type":"callback"},{"doc":"","ref":"Remedy.Struct.Embed.html#c:timestamp/1","title":"Remedy.Struct.Embed.timestamp/1","type":"callback"},{"doc":"","ref":"Remedy.Struct.Embed.html#c:title/1","title":"Remedy.Struct.Embed.title/1","type":"callback"},{"doc":"","ref":"Remedy.Struct.Embed.html#c:url/1","title":"Remedy.Struct.Embed.url/1","type":"callback"},{"doc":"Author information","ref":"Remedy.Struct.Embed.html#t:author/0","title":"Remedy.Struct.Embed.author/0","type":"type"},{"doc":"Color code of the embed","ref":"Remedy.Struct.Embed.html#t:color/0","title":"Remedy.Struct.Embed.color/0","type":"type"},{"doc":"Description of the embed","ref":"Remedy.Struct.Embed.html#t:description/0","title":"Remedy.Struct.Embed.description/0","type":"type"},{"doc":"Fields information","ref":"Remedy.Struct.Embed.html#t:fields/0","title":"Remedy.Struct.Embed.fields/0","type":"type"},{"doc":"Footer information","ref":"Remedy.Struct.Embed.html#t:footer/0","title":"Remedy.Struct.Embed.footer/0","type":"type"},{"doc":"Image information","ref":"Remedy.Struct.Embed.html#t:image/0","title":"Remedy.Struct.Embed.image/0","type":"type"},{"doc":"Provider information","ref":"Remedy.Struct.Embed.html#t:provider/0","title":"Remedy.Struct.Embed.provider/0","type":"type"},{"doc":"","ref":"Remedy.Struct.Embed.html#t:t/0","title":"Remedy.Struct.Embed.t/0","type":"type"},{"doc":"Thumbnail information","ref":"Remedy.Struct.Embed.html#t:thumbnail/0","title":"Remedy.Struct.Embed.thumbnail/0","type":"type"},{"doc":"Timestamp of embed content","ref":"Remedy.Struct.Embed.html#t:timestamp/0","title":"Remedy.Struct.Embed.timestamp/0","type":"type"},{"doc":"Title of the embed","ref":"Remedy.Struct.Embed.html#t:title/0","title":"Remedy.Struct.Embed.title/0","type":"type"},{"doc":"Type of the embed","ref":"Remedy.Struct.Embed.html#t:type/0","title":"Remedy.Struct.Embed.type/0","type":"type"},{"doc":"Url of the embed","ref":"Remedy.Struct.Embed.html#t:url/0","title":"Remedy.Struct.Embed.url/0","type":"type"},{"doc":"Video information","ref":"Remedy.Struct.Embed.html#t:video/0","title":"Remedy.Struct.Embed.video/0","type":"type"},{"doc":"Struct representing a Discord embed author.","ref":"Remedy.Struct.Embed.Author.html","title":"Remedy.Struct.Embed.Author","type":"module"},{"doc":"URL of the author icon","ref":"Remedy.Struct.Embed.Author.html#t:icon_url/0","title":"Remedy.Struct.Embed.Author.icon_url/0","type":"type"},{"doc":"Name of the author","ref":"Remedy.Struct.Embed.Author.html#t:name/0","title":"Remedy.Struct.Embed.Author.name/0","type":"type"},{"doc":"Proxied URL of author icon","ref":"Remedy.Struct.Embed.Author.html#t:proxy_icon_url/0","title":"Remedy.Struct.Embed.Author.proxy_icon_url/0","type":"type"},{"doc":"","ref":"Remedy.Struct.Embed.Author.html#t:t/0","title":"Remedy.Struct.Embed.Author.t/0","type":"type"},{"doc":"URL of the author","ref":"Remedy.Struct.Embed.Author.html#t:url/0","title":"Remedy.Struct.Embed.Author.url/0","type":"type"},{"doc":"Struct representing a Discord embed field.","ref":"Remedy.Struct.Embed.Field.html","title":"Remedy.Struct.Embed.Field","type":"module"},{"doc":"Whether the field should display as inline","ref":"Remedy.Struct.Embed.Field.html#t:inline/0","title":"Remedy.Struct.Embed.Field.inline/0","type":"type"},{"doc":"Name of the field","ref":"Remedy.Struct.Embed.Field.html#t:name/0","title":"Remedy.Struct.Embed.Field.name/0","type":"type"},{"doc":"","ref":"Remedy.Struct.Embed.Field.html#t:t/0","title":"Remedy.Struct.Embed.Field.t/0","type":"type"},{"doc":"Value of the field","ref":"Remedy.Struct.Embed.Field.html#t:value/0","title":"Remedy.Struct.Embed.Field.value/0","type":"type"},{"doc":"Struct representing a Discord embed footer.","ref":"Remedy.Struct.Embed.Footer.html","title":"Remedy.Struct.Embed.Footer","type":"module"},{"doc":"URL of footer icon","ref":"Remedy.Struct.Embed.Footer.html#t:icon_url/0","title":"Remedy.Struct.Embed.Footer.icon_url/0","type":"type"},{"doc":"Proxied URL of footer icon","ref":"Remedy.Struct.Embed.Footer.html#t:proxy_icon_url/0","title":"Remedy.Struct.Embed.Footer.proxy_icon_url/0","type":"type"},{"doc":"","ref":"Remedy.Struct.Embed.Footer.html#t:t/0","title":"Remedy.Struct.Embed.Footer.t/0","type":"type"},{"doc":"Footer text","ref":"Remedy.Struct.Embed.Footer.html#t:text/0","title":"Remedy.Struct.Embed.Footer.text/0","type":"type"},{"doc":"Struct representing a Discord embed image.","ref":"Remedy.Struct.Embed.Image.html","title":"Remedy.Struct.Embed.Image","type":"module"},{"doc":"Height of the image","ref":"Remedy.Struct.Embed.Image.html#t:height/0","title":"Remedy.Struct.Embed.Image.height/0","type":"type"},{"doc":"URL of image icon","ref":"Remedy.Struct.Embed.Image.html#t:proxy_url/0","title":"Remedy.Struct.Embed.Image.proxy_url/0","type":"type"},{"doc":"","ref":"Remedy.Struct.Embed.Image.html#t:t/0","title":"Remedy.Struct.Embed.Image.t/0","type":"type"},{"doc":"Image text","ref":"Remedy.Struct.Embed.Image.html#t:url/0","title":"Remedy.Struct.Embed.Image.url/0","type":"type"},{"doc":"Width of the image","ref":"Remedy.Struct.Embed.Image.html#t:width/0","title":"Remedy.Struct.Embed.Image.width/0","type":"type"},{"doc":"Struct representing a Discord embed provider.","ref":"Remedy.Struct.Embed.Provider.html","title":"Remedy.Struct.Embed.Provider","type":"module"},{"doc":"Name of the provider","ref":"Remedy.Struct.Embed.Provider.html#t:name/0","title":"Remedy.Struct.Embed.Provider.name/0","type":"type"},{"doc":"","ref":"Remedy.Struct.Embed.Provider.html#t:t/0","title":"Remedy.Struct.Embed.Provider.t/0","type":"type"},{"doc":"URL of provider","ref":"Remedy.Struct.Embed.Provider.html#t:url/0","title":"Remedy.Struct.Embed.Provider.url/0","type":"type"},{"doc":"Struct representing a Discord embed thumbnail.","ref":"Remedy.Struct.Embed.Thumbnail.html","title":"Remedy.Struct.Embed.Thumbnail","type":"module"},{"doc":"Height of the thumbnail","ref":"Remedy.Struct.Embed.Thumbnail.html#t:height/0","title":"Remedy.Struct.Embed.Thumbnail.height/0","type":"type"},{"doc":"URL of thumbnail icon","ref":"Remedy.Struct.Embed.Thumbnail.html#t:proxy_url/0","title":"Remedy.Struct.Embed.Thumbnail.proxy_url/0","type":"type"},{"doc":"","ref":"Remedy.Struct.Embed.Thumbnail.html#t:t/0","title":"Remedy.Struct.Embed.Thumbnail.t/0","type":"type"},{"doc":"Source URL of the thumbnail","ref":"Remedy.Struct.Embed.Thumbnail.html#t:url/0","title":"Remedy.Struct.Embed.Thumbnail.url/0","type":"type"},{"doc":"Width of the thumbnail","ref":"Remedy.Struct.Embed.Thumbnail.html#t:width/0","title":"Remedy.Struct.Embed.Thumbnail.width/0","type":"type"},{"doc":"Struct representing a Discord embed video.","ref":"Remedy.Struct.Embed.Video.html","title":"Remedy.Struct.Embed.Video","type":"module"},{"doc":"Height of the video","ref":"Remedy.Struct.Embed.Video.html#t:height/0","title":"Remedy.Struct.Embed.Video.height/0","type":"type"},{"doc":"","ref":"Remedy.Struct.Embed.Video.html#t:t/0","title":"Remedy.Struct.Embed.Video.t/0","type":"type"},{"doc":"Source URL of the video","ref":"Remedy.Struct.Embed.Video.html#t:url/0","title":"Remedy.Struct.Embed.Video.url/0","type":"type"},{"doc":"Width of the video","ref":"Remedy.Struct.Embed.Video.html#t:width/0","title":"Remedy.Struct.Embed.Video.width/0","type":"type"},{"doc":"Struct representing a Discord emoji. Mentioning Emojis in Messages A Remedy.Struct.Emoji can be mentioned in message content using the String.Chars protocol or mention/1 . emoji = %Remedy.Struct.Emoji{id: 437093487582642177, name: &quot;foxbot&quot;} Remedy.Api.create_message!(184046599834435585, &quot;\#{emoji}&quot;) %Remedy.Struct.Message{content: &quot;&lt;:foxbot:437093487582642177&gt;&quot;} emoji = %Remedy.Struct.Emoji{id: 436885297037312001, name: &quot;tealixir&quot;} Remedy.Api.create_message!(280085880452939778, &quot;\#{Remedy.Struct.Emoji.mention(emoji)}&quot;) %Remedy.Struct.Message{content: &quot;&lt;:tealixir:436885297037312001&gt;&quot;} Using Emojis in the Api A Remedy.Struct.Emoji can be used in Remedy.Api by using its api name or the struct itself. emoji = %Remedy.Struct.Emoji{id: 436885297037312001, name: &quot;tealixir&quot;} Remedy.Api.create_reaction(381889573426429952, 436247584349356032, Remedy.Struct.Emoji.api_name(emoji)) {:ok} emoji = %Remedy.Struct.Emoji{id: 436189601820966923, name: &quot;elixir&quot;} Remedy.Api.create_reaction(381889573426429952, 436247584349356032, emoji) {:ok} See Remedy.Struct.Emoji.api_name/0 for more information.","ref":"Remedy.Struct.Emoji.html","title":"Remedy.Struct.Emoji","type":"module"},{"doc":"Formats an emoji struct into its Remedy.Struct.Emoji.api_name/0 . Examples iex&gt; emoji = %Remedy.Struct.Emoji{name: &quot;Γ¡É&quot;} ...&gt; Remedy.Struct.Emoji.api_name(emoji) &quot;Γ¡É&quot; iex&gt; emoji = %Remedy.Struct.Emoji{id: 437093487582642177, name: &quot;foxbot&quot;} ...&gt; Remedy.Struct.Emoji.api_name(emoji) &quot;foxbot:437093487582642177&quot;","ref":"Remedy.Struct.Emoji.html#api_name/1","title":"Remedy.Struct.Emoji.api_name/1","type":"function"},{"doc":"Returns the url of a custom emoji's image. If the emoji is not a custom one, returns nil . Examples iex&gt; emoji = %Remedy.Struct.Emoji{id: 450225070569291776} iex&gt; Remedy.Struct.Emoji.image_url(emoji) &quot;https://cdn.discordapp.com/emojis/450225070569291776.png&quot; iex&gt; emoji = %Remedy.Struct.Emoji{id: 406140226998894614, animated: true} iex&gt; Remedy.Struct.Emoji.image_url(emoji) &quot;https://cdn.discordapp.com/emojis/406140226998894614.gif&quot; iex&gt; emoji = %Remedy.Struct.Emoji{id: nil, name: &quot;Γ¡É&quot;} iex&gt; Remedy.Struct.Emoji.image_url(emoji) nil","ref":"Remedy.Struct.Emoji.html#image_url/1","title":"Remedy.Struct.Emoji.image_url/1","type":"function"},{"doc":"Formats an Remedy.Struct.Emoji into a mention. Examples iex&gt; emoji = %Remedy.Struct.Emoji{name: &quot;≡ƒæì&quot;} ...&gt; Remedy.Struct.Emoji.mention(emoji) &quot;≡ƒæì&quot; iex&gt; emoji = %Remedy.Struct.Emoji{id: 436885297037312001, name: &quot;tealixir&quot;} ...&gt; Remedy.Struct.Emoji.mention(emoji) &quot;&lt;:tealixir:436885297037312001&gt;&quot; iex&gt; emoji = %Remedy.Struct.Emoji{id: 437016804309860372, name: &quot;blobseizure&quot;, animated: true} ...&gt; Remedy.Struct.Emoji.mention(emoji) &quot;&lt;a:blobseizure:437016804309860372&gt;&quot;","ref":"Remedy.Struct.Emoji.html#mention/1","title":"Remedy.Struct.Emoji.mention/1","type":"function"},{"doc":"Whether this emoji is animated","ref":"Remedy.Struct.Emoji.html#t:animated/0","title":"Remedy.Struct.Emoji.animated/0","type":"type"},{"doc":"Emoji string to be used with the Discord API. Some API endpoints take an emoji . If it is a custom emoji, it must be structured as &quot;id:name&quot; . If it is an unicode emoji, it can be structured as any of the following: &quot;name&quot; A base 16 unicode emoji string. api_name/1 is a convenience function that returns a Remedy.Struct.Emoji 's api name. Examples # Custom Emojis &quot;remedy:431890438091489&quot; # Unicode Emojis &quot;≡ƒæì&quot; &quot;\\xF0\\x9F\\x98\\x81&quot; &quot;\\u2b50&quot;","ref":"Remedy.Struct.Emoji.html#t:api_name/0","title":"Remedy.Struct.Emoji.api_name/0","type":"type"},{"doc":"Id of the emoji","ref":"Remedy.Struct.Emoji.html#t:id/0","title":"Remedy.Struct.Emoji.id/0","type":"type"},{"doc":"Whether this emoji is managed","ref":"Remedy.Struct.Emoji.html#t:managed/0","title":"Remedy.Struct.Emoji.managed/0","type":"type"},{"doc":"Name of the emoji","ref":"Remedy.Struct.Emoji.html#t:name/0","title":"Remedy.Struct.Emoji.name/0","type":"type"},{"doc":"Whether this emoji must be wrapped in colons","ref":"Remedy.Struct.Emoji.html#t:require_colons/0","title":"Remedy.Struct.Emoji.require_colons/0","type":"type"},{"doc":"Roles this emoji is whitelisted to","ref":"Remedy.Struct.Emoji.html#t:roles/0","title":"Remedy.Struct.Emoji.roles/0","type":"type"},{"doc":"","ref":"Remedy.Struct.Emoji.html#t:t/0","title":"Remedy.Struct.Emoji.t/0","type":"type"},{"doc":"User that created this emoji","ref":"Remedy.Struct.Emoji.html#t:user/0","title":"Remedy.Struct.Emoji.user/0","type":"type"},{"doc":"Represents an update to channel pins.","ref":"Remedy.Struct.Event.ChannelPinsUpdate.html","title":"Remedy.Struct.Event.ChannelPinsUpdate","type":"module"},{"doc":"The ID of the channel","ref":"Remedy.Struct.Event.ChannelPinsUpdate.html#t:channel_id/0","title":"Remedy.Struct.Event.ChannelPinsUpdate.channel_id/0","type":"type"},{"doc":"The ID of the guild, if the pin update was on a guild","ref":"Remedy.Struct.Event.ChannelPinsUpdate.html#t:guild_id/0","title":"Remedy.Struct.Event.ChannelPinsUpdate.guild_id/0","type":"type"},{"doc":"The time at which the most recent pinned message was pinned","ref":"Remedy.Struct.Event.ChannelPinsUpdate.html#t:last_pin_timestamp/0","title":"Remedy.Struct.Event.ChannelPinsUpdate.last_pin_timestamp/0","type":"type"},{"doc":"Event sent when a message is pinned or unpinned in a text channel","ref":"Remedy.Struct.Event.ChannelPinsUpdate.html#t:t/0","title":"Remedy.Struct.Event.ChannelPinsUpdate.t/0","type":"type"},{"doc":"Sent when a user is banned from a guild","ref":"Remedy.Struct.Event.GuildBanAdd.html","title":"Remedy.Struct.Event.GuildBanAdd","type":"module"},{"doc":"ID of the guild","ref":"Remedy.Struct.Event.GuildBanAdd.html#t:guild_id/0","title":"Remedy.Struct.Event.GuildBanAdd.guild_id/0","type":"type"},{"doc":"Event sent when a user is banned from a guild","ref":"Remedy.Struct.Event.GuildBanAdd.html#t:t/0","title":"Remedy.Struct.Event.GuildBanAdd.t/0","type":"type"},{"doc":"Banned user","ref":"Remedy.Struct.Event.GuildBanAdd.html#t:user/0","title":"Remedy.Struct.Event.GuildBanAdd.user/0","type":"type"},{"doc":"Sent when a user is unbanned from a guild","ref":"Remedy.Struct.Event.GuildBanRemove.html","title":"Remedy.Struct.Event.GuildBanRemove","type":"module"},{"doc":"ID of the guild","ref":"Remedy.Struct.Event.GuildBanRemove.html#t:guild_id/0","title":"Remedy.Struct.Event.GuildBanRemove.guild_id/0","type":"type"},{"doc":"Event sent when a user is unbanned from a guild","ref":"Remedy.Struct.Event.GuildBanRemove.html#t:t/0","title":"Remedy.Struct.Event.GuildBanRemove.t/0","type":"type"},{"doc":"Unbanned user","ref":"Remedy.Struct.Event.GuildBanRemove.html#t:user/0","title":"Remedy.Struct.Event.GuildBanRemove.user/0","type":"type"},{"doc":"Sent when a guild integration is updated","ref":"Remedy.Struct.Event.GuildIntegrationsUpdate.html","title":"Remedy.Struct.Event.GuildIntegrationsUpdate","type":"module"},{"doc":"ID of the guild whose integrations were updated","ref":"Remedy.Struct.Event.GuildIntegrationsUpdate.html#t:guild_id/0","title":"Remedy.Struct.Event.GuildIntegrationsUpdate.guild_id/0","type":"type"},{"doc":"Event sent when a guild integration is updated","ref":"Remedy.Struct.Event.GuildIntegrationsUpdate.html#t:t/0","title":"Remedy.Struct.Event.GuildIntegrationsUpdate.t/0","type":"type"},{"doc":"Struct representing an Invite Create event","ref":"Remedy.Struct.Event.InviteCreate.html","title":"Remedy.Struct.Event.InviteCreate","type":"module"},{"doc":"Channel id of the channel this invite is for.","ref":"Remedy.Struct.Event.InviteCreate.html#t:channel_id/0","title":"Remedy.Struct.Event.InviteCreate.channel_id/0","type":"type"},{"doc":"The unique invite code.","ref":"Remedy.Struct.Event.InviteCreate.html#t:code/0","title":"Remedy.Struct.Event.InviteCreate.code/0","type":"type"},{"doc":"The time at which the invite was created.","ref":"Remedy.Struct.Event.InviteCreate.html#t:created_at/0","title":"Remedy.Struct.Event.InviteCreate.created_at/0","type":"type"},{"doc":"Guild id of the guild this invite is for.","ref":"Remedy.Struct.Event.InviteCreate.html#t:guild_id/0","title":"Remedy.Struct.Event.InviteCreate.guild_id/0","type":"type"},{"doc":"The user that created the invite.","ref":"Remedy.Struct.Event.InviteCreate.html#t:inviter/0","title":"Remedy.Struct.Event.InviteCreate.inviter/0","type":"type"},{"doc":"Duration (in seconds) after which the invite expires.","ref":"Remedy.Struct.Event.InviteCreate.html#t:max_age/0","title":"Remedy.Struct.Event.InviteCreate.max_age/0","type":"type"},{"doc":"Max number of times this invite can be used.","ref":"Remedy.Struct.Event.InviteCreate.html#t:max_uses/0","title":"Remedy.Struct.Event.InviteCreate.max_uses/0","type":"type"},{"doc":"","ref":"Remedy.Struct.Event.InviteCreate.html#t:t/0","title":"Remedy.Struct.Event.InviteCreate.t/0","type":"type"},{"doc":"Partially populated user struct of the target user for this invite.","ref":"Remedy.Struct.Event.InviteCreate.html#t:target_user/0","title":"Remedy.Struct.Event.InviteCreate.target_user/0","type":"type"},{"doc":"The type of user target for this invite.","ref":"Remedy.Struct.Event.InviteCreate.html#t:target_user_type/0","title":"Remedy.Struct.Event.InviteCreate.target_user_type/0","type":"type"},{"doc":"Whether this invite only grants temporary membership.","ref":"Remedy.Struct.Event.InviteCreate.html#t:temporary/0","title":"Remedy.Struct.Event.InviteCreate.temporary/0","type":"type"},{"doc":"Number of times this invite has been used.","ref":"Remedy.Struct.Event.InviteCreate.html#t:uses/0","title":"Remedy.Struct.Event.InviteCreate.uses/0","type":"type"},{"doc":"Struct representing an Invite Delete event","ref":"Remedy.Struct.Event.InviteDelete.html","title":"Remedy.Struct.Event.InviteDelete","type":"module"},{"doc":"Channel id of the channel this invite is for.","ref":"Remedy.Struct.Event.InviteDelete.html#t:channel_id/0","title":"Remedy.Struct.Event.InviteDelete.channel_id/0","type":"type"},{"doc":"The unique invite code.","ref":"Remedy.Struct.Event.InviteDelete.html#t:code/0","title":"Remedy.Struct.Event.InviteDelete.code/0","type":"type"},{"doc":"Guild id of the guild this invite is for.","ref":"Remedy.Struct.Event.InviteDelete.html#t:guild_id/0","title":"Remedy.Struct.Event.InviteDelete.guild_id/0","type":"type"},{"doc":"","ref":"Remedy.Struct.Event.InviteDelete.html#t:t/0","title":"Remedy.Struct.Event.InviteDelete.t/0","type":"type"},{"doc":"Struct representing a Message Delete event","ref":"Remedy.Struct.Event.MessageDelete.html","title":"Remedy.Struct.Event.MessageDelete","type":"module"},{"doc":"Channel id of the deleted message","ref":"Remedy.Struct.Event.MessageDelete.html#t:channel_id/0","title":"Remedy.Struct.Event.MessageDelete.channel_id/0","type":"type"},{"doc":"Guild id of the deleted message nil if a non-guild message was deleted.","ref":"Remedy.Struct.Event.MessageDelete.html#t:guild_id/0","title":"Remedy.Struct.Event.MessageDelete.guild_id/0","type":"type"},{"doc":"Id of the deleted message","ref":"Remedy.Struct.Event.MessageDelete.html#t:id/0","title":"Remedy.Struct.Event.MessageDelete.id/0","type":"type"},{"doc":"","ref":"Remedy.Struct.Event.MessageDelete.html#t:t/0","title":"Remedy.Struct.Event.MessageDelete.t/0","type":"type"},{"doc":"Struct representing a Message Delete Bulk event","ref":"Remedy.Struct.Event.MessageDeleteBulk.html","title":"Remedy.Struct.Event.MessageDeleteBulk","type":"module"},{"doc":"Channel id of the deleted message","ref":"Remedy.Struct.Event.MessageDeleteBulk.html#t:channel_id/0","title":"Remedy.Struct.Event.MessageDeleteBulk.channel_id/0","type":"type"},{"doc":"Guild id of the deleted message nil if a non-guild message was deleted.","ref":"Remedy.Struct.Event.MessageDeleteBulk.html#t:guild_id/0","title":"Remedy.Struct.Event.MessageDeleteBulk.guild_id/0","type":"type"},{"doc":"Ids of the deleted messages","ref":"Remedy.Struct.Event.MessageDeleteBulk.html#t:ids/0","title":"Remedy.Struct.Event.MessageDeleteBulk.ids/0","type":"type"},{"doc":"","ref":"Remedy.Struct.Event.MessageDeleteBulk.html#t:t/0","title":"Remedy.Struct.Event.MessageDeleteBulk.t/0","type":"type"},{"doc":"Sent when a user adds a reaction to a message","ref":"Remedy.Struct.Event.MessageReactionAdd.html","title":"Remedy.Struct.Event.MessageReactionAdd","type":"module"},{"doc":"Channel in which the reaction was added","ref":"Remedy.Struct.Event.MessageReactionAdd.html#t:channel_id/0","title":"Remedy.Struct.Event.MessageReactionAdd.channel_id/0","type":"type"},{"doc":"The (partial) emoji used to react","ref":"Remedy.Struct.Event.MessageReactionAdd.html#t:emoji/0","title":"Remedy.Struct.Event.MessageReactionAdd.emoji/0","type":"type"},{"doc":"Guild ID in which the reaction was added, if applicable","ref":"Remedy.Struct.Event.MessageReactionAdd.html#t:guild_id/0","title":"Remedy.Struct.Event.MessageReactionAdd.guild_id/0","type":"type"},{"doc":"The member who reacted, if this happened on a guild","ref":"Remedy.Struct.Event.MessageReactionAdd.html#t:member/0","title":"Remedy.Struct.Event.MessageReactionAdd.member/0","type":"type"},{"doc":"Message to which the reaction was added","ref":"Remedy.Struct.Event.MessageReactionAdd.html#t:message_id/0","title":"Remedy.Struct.Event.MessageReactionAdd.message_id/0","type":"type"},{"doc":"Event sent when a user adds a reaction to a message","ref":"Remedy.Struct.Event.MessageReactionAdd.html#t:t/0","title":"Remedy.Struct.Event.MessageReactionAdd.t/0","type":"type"},{"doc":"ID of the user who added the reaction","ref":"Remedy.Struct.Event.MessageReactionAdd.html#t:user_id/0","title":"Remedy.Struct.Event.MessageReactionAdd.user_id/0","type":"type"},{"doc":"Sent when a user removes a reaction from a message","ref":"Remedy.Struct.Event.MessageReactionRemove.html","title":"Remedy.Struct.Event.MessageReactionRemove","type":"module"},{"doc":"ID of the channel in which the reaction was created","ref":"Remedy.Struct.Event.MessageReactionRemove.html#t:channel_id/0","title":"Remedy.Struct.Event.MessageReactionRemove.channel_id/0","type":"type"},{"doc":"Partial emoji object that was removed","ref":"Remedy.Struct.Event.MessageReactionRemove.html#t:emoji/0","title":"Remedy.Struct.Event.MessageReactionRemove.emoji/0","type":"type"},{"doc":"ID of the guild on which the message lives, if applicable","ref":"Remedy.Struct.Event.MessageReactionRemove.html#t:guild_id/0","title":"Remedy.Struct.Event.MessageReactionRemove.guild_id/0","type":"type"},{"doc":"ID of the message to which the reaction was attached","ref":"Remedy.Struct.Event.MessageReactionRemove.html#t:message_id/0","title":"Remedy.Struct.Event.MessageReactionRemove.message_id/0","type":"type"},{"doc":"Event sent when a user removes a reaction from a message","ref":"Remedy.Struct.Event.MessageReactionRemove.html#t:t/0","title":"Remedy.Struct.Event.MessageReactionRemove.t/0","type":"type"},{"doc":"Author of the reaction","ref":"Remedy.Struct.Event.MessageReactionRemove.html#t:user_id/0","title":"Remedy.Struct.Event.MessageReactionRemove.user_id/0","type":"type"},{"doc":"Sent when a user explicitly removes all reactions from a message","ref":"Remedy.Struct.Event.MessageReactionRemoveAll.html","title":"Remedy.Struct.Event.MessageReactionRemoveAll","type":"module"},{"doc":"ID of the channel in which the message resides.","ref":"Remedy.Struct.Event.MessageReactionRemoveAll.html#t:channel_id/0","title":"Remedy.Struct.Event.MessageReactionRemoveAll.channel_id/0","type":"type"},{"doc":"ID of the guild for the message, if applicable.","ref":"Remedy.Struct.Event.MessageReactionRemoveAll.html#t:guild_id/0","title":"Remedy.Struct.Event.MessageReactionRemoveAll.guild_id/0","type":"type"},{"doc":"ID of the message from which all reactions were removed.","ref":"Remedy.Struct.Event.MessageReactionRemoveAll.html#t:message_id/0","title":"Remedy.Struct.Event.MessageReactionRemoveAll.message_id/0","type":"type"},{"doc":"Event sent when a user explicitly removes all reactions from a message","ref":"Remedy.Struct.Event.MessageReactionRemoveAll.html#t:t/0","title":"Remedy.Struct.Event.MessageReactionRemoveAll.t/0","type":"type"},{"doc":"Sent when a bot removes all instances of a given emoji from the reactions of a message","ref":"Remedy.Struct.Event.MessageReactionRemoveEmoji.html","title":"Remedy.Struct.Event.MessageReactionRemoveEmoji","type":"module"},{"doc":"Channel in which the message resides.","ref":"Remedy.Struct.Event.MessageReactionRemoveEmoji.html#t:channel_id/0","title":"Remedy.Struct.Event.MessageReactionRemoveEmoji.channel_id/0","type":"type"},{"doc":"The (partial) emoji that was removed.","ref":"Remedy.Struct.Event.MessageReactionRemoveEmoji.html#t:emoji/0","title":"Remedy.Struct.Event.MessageReactionRemoveEmoji.emoji/0","type":"type"},{"doc":"Guild on which the message resides, if applicable.","ref":"Remedy.Struct.Event.MessageReactionRemoveEmoji.html#t:guild_id/0","title":"Remedy.Struct.Event.MessageReactionRemoveEmoji.guild_id/0","type":"type"},{"doc":"Message from which the emoji was removed.","ref":"Remedy.Struct.Event.MessageReactionRemoveEmoji.html#t:message_id/0","title":"Remedy.Struct.Event.MessageReactionRemoveEmoji.message_id/0","type":"type"},{"doc":"Event sent when a bot removes all instances of a given emoji from the reactions of a message","ref":"Remedy.Struct.Event.MessageReactionRemoveEmoji.html#t:t/0","title":"Remedy.Struct.Event.MessageReactionRemoveEmoji.t/0","type":"type"},{"doc":"Sent on READY","ref":"Remedy.Struct.Event.PartialApplication.html","title":"Remedy.Struct.Event.PartialApplication","type":"module"},{"doc":"Public flags of the application. See https://discord.com/developers/docs/resources/application#application-object-application-flags","ref":"Remedy.Struct.Event.PartialApplication.html#t:flags/0","title":"Remedy.Struct.Event.PartialApplication.flags/0","type":"type"},{"doc":"ID of the application","ref":"Remedy.Struct.Event.PartialApplication.html#t:id/0","title":"Remedy.Struct.Event.PartialApplication.id/0","type":"type"},{"doc":"Event sent as part of the READY payload.","ref":"Remedy.Struct.Event.PartialApplication.html#t:t/0","title":"Remedy.Struct.Event.PartialApplication.t/0","type":"type"},{"doc":"Sent after initial handshake with the gateway","ref":"Remedy.Struct.Event.Ready.html","title":"Remedy.Struct.Event.Ready","type":"module"},{"doc":"Partial application object with id and flags","ref":"Remedy.Struct.Event.Ready.html#t:application/0","title":"Remedy.Struct.Event.Ready.application/0","type":"type"},{"doc":"The guilds that the bot user is in","ref":"Remedy.Struct.Event.Ready.html#t:guilds/0","title":"Remedy.Struct.Event.Ready.guilds/0","type":"type"},{"doc":"Used for resuming connections. If you are wondering whether you need to use this, you probably don't. Remedy handles reconnections for you.","ref":"Remedy.Struct.Event.Ready.html#t:session_id/0","title":"Remedy.Struct.Event.Ready.session_id/0","type":"type"},{"doc":"A pair of two integers {shard_id, num_shards} . For more information, see https://discord.com/developers/docs/topics/gateway#sharding.","ref":"Remedy.Struct.Event.Ready.html#t:shard/0","title":"Remedy.Struct.Event.Ready.shard/0","type":"type"},{"doc":"Event sent after initial handshake with the gateway","ref":"Remedy.Struct.Event.Ready.html#t:t/0","title":"Remedy.Struct.Event.Ready.t/0","type":"type"},{"doc":"Information about the bot user","ref":"Remedy.Struct.Event.Ready.html#t:user/0","title":"Remedy.Struct.Event.Ready.user/0","type":"type"},{"doc":"Gateway version. See https://discord.com/developers/docs/topics/gateway#gateways-gateway-versions","ref":"Remedy.Struct.Event.Ready.html#t:v/0","title":"Remedy.Struct.Event.Ready.v/0","type":"type"},{"doc":"Struct representing a Remedy-generated Speaking Update event Remedy will generate this event when the bot starts or stops playing audio.","ref":"Remedy.Struct.Event.SpeakingUpdate.html","title":"Remedy.Struct.Event.SpeakingUpdate","type":"module"},{"doc":"Id of the channel this speaking update is occurring in.","ref":"Remedy.Struct.Event.SpeakingUpdate.html#t:channel_id/0","title":"Remedy.Struct.Event.SpeakingUpdate.channel_id/0","type":"type"},{"doc":"Id of the guild this speaking update is occurring in.","ref":"Remedy.Struct.Event.SpeakingUpdate.html#t:guild_id/0","title":"Remedy.Struct.Event.SpeakingUpdate.guild_id/0","type":"type"},{"doc":"Boolean representing if bot has started or stopped speaking.","ref":"Remedy.Struct.Event.SpeakingUpdate.html#t:speaking/0","title":"Remedy.Struct.Event.SpeakingUpdate.speaking/0","type":"type"},{"doc":"","ref":"Remedy.Struct.Event.SpeakingUpdate.html#t:t/0","title":"Remedy.Struct.Event.SpeakingUpdate.t/0","type":"type"},{"doc":"Boolean representing if speaking update was caused by an audio timeout.","ref":"Remedy.Struct.Event.SpeakingUpdate.html#t:timed_out/0","title":"Remedy.Struct.Event.SpeakingUpdate.timed_out/0","type":"type"},{"doc":"Sent when a user starts typing in a channel","ref":"Remedy.Struct.Event.TypingStart.html","title":"Remedy.Struct.Event.TypingStart","type":"module"},{"doc":"Channel in which the user started typing","ref":"Remedy.Struct.Event.TypingStart.html#t:channel_id/0","title":"Remedy.Struct.Event.TypingStart.channel_id/0","type":"type"},{"doc":"ID of the guild where the user started typing, if applicable","ref":"Remedy.Struct.Event.TypingStart.html#t:guild_id/0","title":"Remedy.Struct.Event.TypingStart.guild_id/0","type":"type"},{"doc":"The member who started typing if this happened in a guild","ref":"Remedy.Struct.Event.TypingStart.html#t:member/0","title":"Remedy.Struct.Event.TypingStart.member/0","type":"type"},{"doc":"Event sent when a user starts typing in a channel","ref":"Remedy.Struct.Event.TypingStart.html#t:t/0","title":"Remedy.Struct.Event.TypingStart.t/0","type":"type"},{"doc":"Unix time (in seconds) of when the user started typing","ref":"Remedy.Struct.Event.TypingStart.html#t:timestamp/0","title":"Remedy.Struct.Event.TypingStart.timestamp/0","type":"type"},{"doc":"ID of the user who started typing","ref":"Remedy.Struct.Event.TypingStart.html#t:user_id/0","title":"Remedy.Struct.Event.TypingStart.user_id/0","type":"type"},{"doc":"Struct representing a Remedy-generated Voice Ready event Remedy will generate this event when the bot joins a voice channel and is ready to play audio. Listening to this event may be used for bots that begin playing audio directly after joining a voice channel as an alternative to waiting until Remedy.Voice.ready?/1 returns true .","ref":"Remedy.Struct.Event.VoiceReady.html","title":"Remedy.Struct.Event.VoiceReady","type":"module"},{"doc":"Id of the channel that voice is ready in.","ref":"Remedy.Struct.Event.VoiceReady.html#t:channel_id/0","title":"Remedy.Struct.Event.VoiceReady.channel_id/0","type":"type"},{"doc":"Id of the guild that voice is ready in.","ref":"Remedy.Struct.Event.VoiceReady.html#t:guild_id/0","title":"Remedy.Struct.Event.VoiceReady.guild_id/0","type":"type"},{"doc":"","ref":"Remedy.Struct.Event.VoiceReady.html#t:t/0","title":"Remedy.Struct.Event.VoiceReady.t/0","type":"type"},{"doc":"Sent when a guild's voice server is updated","ref":"Remedy.Struct.Event.VoiceServerUpdate.html","title":"Remedy.Struct.Event.VoiceServerUpdate","type":"module"},{"doc":"The voice server host","ref":"Remedy.Struct.Event.VoiceServerUpdate.html#t:endpoint/0","title":"Remedy.Struct.Event.VoiceServerUpdate.endpoint/0","type":"type"},{"doc":"Guild this voice server update is for","ref":"Remedy.Struct.Event.VoiceServerUpdate.html#t:guild_id/0","title":"Remedy.Struct.Event.VoiceServerUpdate.guild_id/0","type":"type"},{"doc":"Event sent when a guild's voice server is updated","ref":"Remedy.Struct.Event.VoiceServerUpdate.html#t:t/0","title":"Remedy.Struct.Event.VoiceServerUpdate.t/0","type":"type"},{"doc":"Voice connection token","ref":"Remedy.Struct.Event.VoiceServerUpdate.html#t:token/0","title":"Remedy.Struct.Event.VoiceServerUpdate.token/0","type":"type"},{"doc":"Represents a user's voice connection status","ref":"Remedy.Struct.Event.VoiceState.html","title":"Remedy.Struct.Event.VoiceState","type":"module"},{"doc":"Channel ID this voice state is for","ref":"Remedy.Struct.Event.VoiceState.html#t:channel_id/0","title":"Remedy.Struct.Event.VoiceState.channel_id/0","type":"type"},{"doc":"Whether this user is deafened by the server","ref":"Remedy.Struct.Event.VoiceState.html#t:deaf?/0","title":"Remedy.Struct.Event.VoiceState.deaf?/0","type":"type"},{"doc":"Guild ID this voice state is for, if applicable","ref":"Remedy.Struct.Event.VoiceState.html#t:guild_id/0","title":"Remedy.Struct.Event.VoiceState.guild_id/0","type":"type"},{"doc":"Guild member this voice state is for, if applicable","ref":"Remedy.Struct.Event.VoiceState.html#t:member/0","title":"Remedy.Struct.Event.VoiceState.member/0","type":"type"},{"doc":"Whether this user is muteened by the server","ref":"Remedy.Struct.Event.VoiceState.html#t:mute?/0","title":"Remedy.Struct.Event.VoiceState.mute?/0","type":"type"},{"doc":"Time at which the user requested to speak, if applicable","ref":"Remedy.Struct.Event.VoiceState.html#t:request_to_speak_timestamp/0","title":"Remedy.Struct.Event.VoiceState.request_to_speak_timestamp/0","type":"type"},{"doc":"Whether this user is locally deafened","ref":"Remedy.Struct.Event.VoiceState.html#t:self_deaf?/0","title":"Remedy.Struct.Event.VoiceState.self_deaf?/0","type":"type"},{"doc":"Whether this user is locally muted","ref":"Remedy.Struct.Event.VoiceState.html#t:self_mute?/0","title":"Remedy.Struct.Event.VoiceState.self_mute?/0","type":"type"},{"doc":"Whether the user is streaming using &quot;Go Live&quot;","ref":"Remedy.Struct.Event.VoiceState.html#t:self_stream?/0","title":"Remedy.Struct.Event.VoiceState.self_stream?/0","type":"type"},{"doc":"Whether this user's camera is enabled","ref":"Remedy.Struct.Event.VoiceState.html#t:self_video?/0","title":"Remedy.Struct.Event.VoiceState.self_video?/0","type":"type"},{"doc":"Session ID for this voice state","ref":"Remedy.Struct.Event.VoiceState.html#t:session_id/0","title":"Remedy.Struct.Event.VoiceState.session_id/0","type":"type"},{"doc":"Whether this user is muted by the current user","ref":"Remedy.Struct.Event.VoiceState.html#t:suppress?/0","title":"Remedy.Struct.Event.VoiceState.suppress?/0","type":"type"},{"doc":"Event sent when a user's voice status is updated","ref":"Remedy.Struct.Event.VoiceState.html#t:t/0","title":"Remedy.Struct.Event.VoiceState.t/0","type":"type"},{"doc":"User this voice state is for","ref":"Remedy.Struct.Event.VoiceState.html#t:user_id/0","title":"Remedy.Struct.Event.VoiceState.user_id/0","type":"type"},{"doc":"Struct representing a Discord guild.","ref":"Remedy.Struct.Guild.html","title":"Remedy.Struct.Guild","type":"module"},{"doc":"Returns the URL of a guild's icon, or nil if there is no icon. Supported image formats are PNG, JPEG, and WebP. Examples iex&gt; guild = %Remedy.Struct.Guild{icon: &quot;86e39f7ae3307e811784e2ffd11a7310&quot;, ...&gt; id: 41771983423143937} iex&gt; Remedy.Struct.Guild.icon_url(guild) &quot;https://cdn.discordapp.com/icons/41771983423143937/86e39f7ae3307e811784e2ffd11a7310.webp&quot; iex&gt; Remedy.Struct.Guild.icon_url(guild, &quot;png&quot;) &quot;https://cdn.discordapp.com/icons/41771983423143937/86e39f7ae3307e811784e2ffd11a7310.png&quot; iex&gt; guild = %Remedy.Struct.Guild{icon: nil} iex&gt; Remedy.Struct.Guild.icon_url(guild) nil","ref":"Remedy.Struct.Guild.html#icon_url/2","title":"Remedy.Struct.Guild.icon_url/2","type":"function"},{"doc":"Returns the URL of a guild's splash, or nil if there is no splash. Supported image formats are PNG, JPEG, and WebP. Examples iex&gt; guild = %Remedy.Struct.Guild{splash: &quot;86e39f7ae3307e811784e2ffd11a7310&quot;, ...&gt; id: 41771983423143937} iex&gt; Remedy.Struct.Guild.splash_url(guild) &quot;https://cdn.discordapp.com/splashes/41771983423143937/86e39f7ae3307e811784e2ffd11a7310.webp&quot; iex&gt; Remedy.Struct.Guild.splash_url(guild, &quot;png&quot;) &quot;https://cdn.discordapp.com/splashes/41771983423143937/86e39f7ae3307e811784e2ffd11a7310.png&quot; iex&gt; guild = %Remedy.Struct.Guild{splash: nil} iex&gt; Remedy.Struct.Guild.splash_url(guild) nil","ref":"Remedy.Struct.Guild.html#splash_url/2","title":"Remedy.Struct.Guild.splash_url/2","type":"function"},{"doc":"The id of the guild's afk channel","ref":"Remedy.Struct.Guild.html#t:afk_channel_id/0","title":"Remedy.Struct.Guild.afk_channel_id/0","type":"type"},{"doc":"The time someone must be afk before being moved","ref":"Remedy.Struct.Guild.html#t:afk_timeout/0","title":"Remedy.Struct.Guild.afk_timeout/0","type":"type"},{"doc":"Application id of the guild creator if it is bot created.","ref":"Remedy.Struct.Guild.html#t:application_id/0","title":"Remedy.Struct.Guild.application_id/0","type":"type"},{"doc":"A Remedy.Struct.Guild that is fully available.","ref":"Remedy.Struct.Guild.html#t:available_guild/0","title":"Remedy.Struct.Guild.available_guild/0","type":"type"},{"doc":"List of channels","ref":"Remedy.Struct.Guild.html#t:channels/0","title":"Remedy.Struct.Guild.channels/0","type":"type"},{"doc":"Default message notifications level.","ref":"Remedy.Struct.Guild.html#t:default_message_notifications/0","title":"Remedy.Struct.Guild.default_message_notifications/0","type":"type"},{"doc":"The id of the embedded channel","ref":"Remedy.Struct.Guild.html#t:embed_channel_id/0","title":"Remedy.Struct.Guild.embed_channel_id/0","type":"type"},{"doc":"Whether the guild is emeddable","ref":"Remedy.Struct.Guild.html#t:embed_enabled/0","title":"Remedy.Struct.Guild.embed_enabled/0","type":"type"},{"doc":"List of emojis","ref":"Remedy.Struct.Guild.html#t:emojis/0","title":"Remedy.Struct.Guild.emojis/0","type":"type"},{"doc":"Explicit content filter level.","ref":"Remedy.Struct.Guild.html#t:explicit_content_filter/0","title":"Remedy.Struct.Guild.explicit_content_filter/0","type":"type"},{"doc":"List of guild features","ref":"Remedy.Struct.Guild.html#t:features/0","title":"Remedy.Struct.Guild.features/0","type":"type"},{"doc":"The hash of the guild's icon","ref":"Remedy.Struct.Guild.html#t:icon/0","title":"Remedy.Struct.Guild.icon/0","type":"type"},{"doc":"The guild's id","ref":"Remedy.Struct.Guild.html#t:id/0","title":"Remedy.Struct.Guild.id/0","type":"type"},{"doc":"Date the bot user joined the guild","ref":"Remedy.Struct.Guild.html#t:joined_at/0","title":"Remedy.Struct.Guild.joined_at/0","type":"type"},{"doc":"Whether the guild is considered 'large'","ref":"Remedy.Struct.Guild.html#t:large/0","title":"Remedy.Struct.Guild.large/0","type":"type"},{"doc":"Total number of members in the guild","ref":"Remedy.Struct.Guild.html#t:member_count/0","title":"Remedy.Struct.Guild.member_count/0","type":"type"},{"doc":"List of members","ref":"Remedy.Struct.Guild.html#t:members/0","title":"Remedy.Struct.Guild.members/0","type":"type"},{"doc":"Required MFA level of the guild","ref":"Remedy.Struct.Guild.html#t:mfa_level/0","title":"Remedy.Struct.Guild.mfa_level/0","type":"type"},{"doc":"The name of the guild.","ref":"Remedy.Struct.Guild.html#t:name/0","title":"Remedy.Struct.Guild.name/0","type":"type"},{"doc":"The id of the guild owner","ref":"Remedy.Struct.Guild.html#t:owner_id/0","title":"Remedy.Struct.Guild.owner_id/0","type":"type"},{"doc":"The id of the channel where admins and moderators receive notices from Discord. This is only available to guilds that contain PUBLIC in features/0 .","ref":"Remedy.Struct.Guild.html#t:public_updates_channel_id/0","title":"Remedy.Struct.Guild.public_updates_channel_id/0","type":"type"},{"doc":"The id of the voice region","ref":"Remedy.Struct.Guild.html#t:region/0","title":"Remedy.Struct.Guild.region/0","type":"type"},{"doc":"A Remedy.Struct.Guild that is sent on guild-specific rest endpoints.","ref":"Remedy.Struct.Guild.html#t:rest_guild/0","title":"Remedy.Struct.Guild.rest_guild/0","type":"type"},{"doc":"List of roles","ref":"Remedy.Struct.Guild.html#t:roles/0","title":"Remedy.Struct.Guild.roles/0","type":"type"},{"doc":"The id of the channel that is used for rules. This is only available to guilds that contain PUBLIC in features/0 .","ref":"Remedy.Struct.Guild.html#t:rules_channel_id/0","title":"Remedy.Struct.Guild.rules_channel_id/0","type":"type"},{"doc":"The hash of the guild's splash","ref":"Remedy.Struct.Guild.html#t:splash/0","title":"Remedy.Struct.Guild.splash/0","type":"type"},{"doc":"The id of the channel to which system messages are sent.","ref":"Remedy.Struct.Guild.html#t:system_channel_id/0","title":"Remedy.Struct.Guild.system_channel_id/0","type":"type"},{"doc":"","ref":"Remedy.Struct.Guild.html#t:t/0","title":"Remedy.Struct.Guild.t/0","type":"type"},{"doc":"Whether the guild is avaliable","ref":"Remedy.Struct.Guild.html#t:unavailable/0","title":"Remedy.Struct.Guild.unavailable/0","type":"type"},{"doc":"A Remedy.Struct.Guild that is unavailable.","ref":"Remedy.Struct.Guild.html#t:unavailable_guild/0","title":"Remedy.Struct.Guild.unavailable_guild/0","type":"type"},{"doc":"A Remedy.Struct.Guild that is sent on user-specific rest endpoints.","ref":"Remedy.Struct.Guild.html#t:user_guild/0","title":"Remedy.Struct.Guild.user_guild/0","type":"type"},{"doc":"The level of verification","ref":"Remedy.Struct.Guild.html#t:verification_level/0","title":"Remedy.Struct.Guild.verification_level/0","type":"type"},{"doc":"List of voice states as maps","ref":"Remedy.Struct.Guild.html#t:voice_states/0","title":"Remedy.Struct.Guild.voice_states/0","type":"type"},{"doc":"The channel id for the server widget.","ref":"Remedy.Struct.Guild.html#t:widget_channel_id/0","title":"Remedy.Struct.Guild.widget_channel_id/0","type":"type"},{"doc":"Whether or not the server widget is enabled.","ref":"Remedy.Struct.Guild.html#t:widget_enabled/0","title":"Remedy.Struct.Guild.widget_enabled/0","type":"type"},{"doc":"Represents a guild's audit log.","ref":"Remedy.Struct.Guild.AuditLog.html","title":"Remedy.Struct.Guild.AuditLog","type":"module"},{"doc":"Entries of this guild's audit log","ref":"Remedy.Struct.Guild.AuditLog.html#t:entries/0","title":"Remedy.Struct.Guild.AuditLog.entries/0","type":"type"},{"doc":"","ref":"Remedy.Struct.Guild.AuditLog.html#t:t/0","title":"Remedy.Struct.Guild.AuditLog.t/0","type":"type"},{"doc":"Users found in the audit log","ref":"Remedy.Struct.Guild.AuditLog.html#t:users/0","title":"Remedy.Struct.Guild.AuditLog.users/0","type":"type"},{"doc":"Webhooks found in the audit log","ref":"Remedy.Struct.Guild.AuditLog.html#t:webhooks/0","title":"Remedy.Struct.Guild.AuditLog.webhooks/0","type":"type"},{"doc":"Represents a single entry in the guild's audit log.","ref":"Remedy.Struct.Guild.AuditLogEntry.html","title":"Remedy.Struct.Guild.AuditLogEntry","type":"module"},{"doc":"An audit log event identifier. See Audit log events","ref":"Remedy.Struct.Guild.AuditLogEntry.html#t:action_type/0","title":"Remedy.Struct.Guild.AuditLogEntry.action_type/0","type":"type"},{"doc":"Individual changes of this audit log entry. Change keys are documented here","ref":"Remedy.Struct.Guild.AuditLogEntry.html#t:changes/0","title":"Remedy.Struct.Guild.AuditLogEntry.changes/0","type":"type"},{"doc":"The ID of this entry","ref":"Remedy.Struct.Guild.AuditLogEntry.html#t:id/0","title":"Remedy.Struct.Guild.AuditLogEntry.id/0","type":"type"},{"doc":"Optional audit entry info","ref":"Remedy.Struct.Guild.AuditLogEntry.html#t:options/0","title":"Remedy.Struct.Guild.AuditLogEntry.options/0","type":"type"},{"doc":"The reason for this change, if applicable","ref":"Remedy.Struct.Guild.AuditLogEntry.html#t:reason/0","title":"Remedy.Struct.Guild.AuditLogEntry.reason/0","type":"type"},{"doc":"","ref":"Remedy.Struct.Guild.AuditLogEntry.html#t:t/0","title":"Remedy.Struct.Guild.AuditLogEntry.t/0","type":"type"},{"doc":"The ID of the affected entity","ref":"Remedy.Struct.Guild.AuditLogEntry.html#t:target_id/0","title":"Remedy.Struct.Guild.AuditLogEntry.target_id/0","type":"type"},{"doc":"The user who made the changes","ref":"Remedy.Struct.Guild.AuditLogEntry.html#t:user_id/0","title":"Remedy.Struct.Guild.AuditLogEntry.user_id/0","type":"type"},{"doc":"Represents a guild ban.","ref":"Remedy.Struct.Guild.Ban.html","title":"Remedy.Struct.Guild.Ban","type":"module"},{"doc":"The reason for the ban","ref":"Remedy.Struct.Guild.Ban.html#t:reason/0","title":"Remedy.Struct.Guild.Ban.reason/0","type":"type"},{"doc":"","ref":"Remedy.Struct.Guild.Ban.html#t:t/0","title":"Remedy.Struct.Guild.Ban.t/0","type":"type"},{"doc":"The banned user","ref":"Remedy.Struct.Guild.Ban.html#t:user/0","title":"Remedy.Struct.Guild.Ban.user/0","type":"type"},{"doc":"Struct representing a Discord guild integration. The struct defined here only has the fields provided for Discord Bot integrations available. If you use Remedy in a non-bot application, feel free to open an issue to add it. References https://discord.com/developers/docs/resources/guild#integration-object","ref":"Remedy.Struct.Guild.Integration.html","title":"Remedy.Struct.Guild.Integration","type":"module"},{"doc":"Whether this integration is enabled","ref":"Remedy.Struct.Guild.Integration.html#t:enabled/0","title":"Remedy.Struct.Guild.Integration.enabled/0","type":"type"},{"doc":"Snowflake ID of the integration","ref":"Remedy.Struct.Guild.Integration.html#t:id/0","title":"Remedy.Struct.Guild.Integration.id/0","type":"type"},{"doc":"Name of the integration","ref":"Remedy.Struct.Guild.Integration.html#t:name/0","title":"Remedy.Struct.Guild.Integration.name/0","type":"type"},{"doc":"Represents a Guild integration","ref":"Remedy.Struct.Guild.Integration.html#t:t/0","title":"Remedy.Struct.Guild.Integration.t/0","type":"type"},{"doc":"Integration type (Twitch, YouTube or Discord)","ref":"Remedy.Struct.Guild.Integration.html#t:type/0","title":"Remedy.Struct.Guild.Integration.type/0","type":"type"},{"doc":"Struct representing a Discord guild's integration account.","ref":"Remedy.Struct.Guild.Integration.Account.html","title":"Remedy.Struct.Guild.Integration.Account","type":"module"},{"doc":"Struct representing a Discord guild member. A Remedy.Struct.Guild.Member stores a Remedy.Struct.User 's properties pertaining to a specific Remedy.Struct.Guild . Mentioning Members in Messages A Remedy.Struct.Guild.Member can be mentioned in message content using the String.Chars protocol or mention/1 . member = %Remedy.Struct.Guild.Member{user: Remedy.Struct.User{id: 120571255635181568}} Remedy.Api.create_message!(184046599834435585, &quot;\#{member}&quot;) %Remedy.Struct.Message{content: &quot;&lt;@120571255635181568&gt;&quot;} member = %Remedy.Struct.Guild.Member{user: Remedy.Struct.User{id: 89918932789497856}} Remedy.Api.create_message!(280085880452939778, &quot;\#{Remedy.Struct.Guild.Member.mention(member)}&quot;) %Remedy.Struct.Message{content: &quot;&lt;@89918932789497856&gt;&quot;}","ref":"Remedy.Struct.Guild.Member.html","title":"Remedy.Struct.Guild.Member","type":"module"},{"doc":"Returns a member's permissions in a guild channel, based on its Remedy.Struct.Overwrite s. Examples guild = Remedy.Cache.GuildCache.get!(279093381723062272) member = Map.get(guild.members, 177888205536886784) channel_id = 381889573426429952 Remedy.Struct.Guild.Member.guild_channel_permissions(member, guild, channel_id) #=&gt; [:manage_messages]","ref":"Remedy.Struct.Guild.Member.html#guild_channel_permissions/3","title":"Remedy.Struct.Guild.Member.guild_channel_permissions/3","type":"function"},{"doc":"Returns a member's guild permissions. Examples guild = Remedy.Cache.GuildCache.get!(279093381723062272) member = Map.get(guild.members, 177888205536886784) Remedy.Struct.Guild.Member.guild_permissions(member, guild) #=&gt; [:administrator]","ref":"Remedy.Struct.Guild.Member.html#guild_permissions/2","title":"Remedy.Struct.Guild.Member.guild_permissions/2","type":"function"},{"doc":"Formats a Remedy.Struct.Guild.Member into a mention. Examples iex&gt; member = %Remedy.Struct.Guild.Member{user: %Remedy.Struct.User{id: 177888205536886784}} ...&gt; Remedy.Struct.Guild.Member.mention(member) &quot;&lt;@177888205536886784&gt;&quot;","ref":"Remedy.Struct.Guild.Member.html#mention/1","title":"Remedy.Struct.Guild.Member.mention/1","type":"function"},{"doc":"Return the topmost role of the given member on the given guild. The topmost role is determined via t:Remedy.Struct.Guild.Role.position . Parameters member : The member whose top role to return. guild : The guild which the member belongs to. Return value The topmost role of the member on the given guild, if the member has roles assigned. Otherwise, nil is returned.","ref":"Remedy.Struct.Guild.Member.html#top_role/2","title":"Remedy.Struct.Guild.Member.top_role/2","type":"function"},{"doc":"Whether the user is deafened. If you dont request offline guild members this field will be nil for any members that come online.","ref":"Remedy.Struct.Guild.Member.html#t:deaf/0","title":"Remedy.Struct.Guild.Member.deaf/0","type":"type"},{"doc":"Date the user joined the guild. If you dont request offline guild members this field will be nil for any members that come online.","ref":"Remedy.Struct.Guild.Member.html#t:joined_at/0","title":"Remedy.Struct.Guild.Member.joined_at/0","type":"type"},{"doc":"Whether the user is muted. If you dont request offline guild members this field will be nil for any members that come online.","ref":"Remedy.Struct.Guild.Member.html#t:mute/0","title":"Remedy.Struct.Guild.Member.mute/0","type":"type"},{"doc":"The nickname of the user","ref":"Remedy.Struct.Guild.Member.html#t:nick/0","title":"Remedy.Struct.Guild.Member.nick/0","type":"type"},{"doc":"A list of role ids","ref":"Remedy.Struct.Guild.Member.html#t:roles/0","title":"Remedy.Struct.Guild.Member.roles/0","type":"type"},{"doc":"","ref":"Remedy.Struct.Guild.Member.html#t:t/0","title":"Remedy.Struct.Guild.Member.t/0","type":"type"},{"doc":"The user struct. This field can be nil if the Member struct came as a partial Member object included in a message received from a guild channel.","ref":"Remedy.Struct.Guild.Member.html#t:user/0","title":"Remedy.Struct.Guild.Member.user/0","type":"type"},{"doc":"Struct representing a Discord role. Mentioning Roles in Messages A Remedy.Struct.Guild.Role can be mentioned in message content using the String.Chars protocol or mention/1 . role = %Remedy.Struct.Guild.Role{id: 431886897539973131} Remedy.Api.create_message!(184046599834435585, &quot;\#{role}&quot;) %Remedy.Struct.Message{} role = %Remedy.Struct.Guild.Role{id: 431884023535632398} Remedy.Api.create_message!(280085880452939778, &quot;\#{Remedy.Struct.Guild.Role.mention(role)}&quot;) %Remedy.Struct.Message{}","ref":"Remedy.Struct.Guild.Role.html","title":"Remedy.Struct.Guild.Role","type":"module"},{"doc":"Formats an Remedy.Struct.Role into a mention. Examples iex&gt; role = %Remedy.Struct.Guild.Role{id: 431886639627763722} ...&gt; Remedy.Struct.Guild.Role.mention(role) &quot;&lt;@&amp;431886639627763722&gt;&quot;","ref":"Remedy.Struct.Guild.Role.html#mention/1","title":"Remedy.Struct.Guild.Role.mention/1","type":"function"},{"doc":"The hexadecimal color code","ref":"Remedy.Struct.Guild.Role.html#t:color/0","title":"Remedy.Struct.Guild.Role.color/0","type":"type"},{"doc":"Whether the role is pinned in the user listing","ref":"Remedy.Struct.Guild.Role.html#t:hoist/0","title":"Remedy.Struct.Guild.Role.hoist/0","type":"type"},{"doc":"The id of the role","ref":"Remedy.Struct.Guild.Role.html#t:id/0","title":"Remedy.Struct.Guild.Role.id/0","type":"type"},{"doc":"Whether the role is managed by an integration","ref":"Remedy.Struct.Guild.Role.html#t:managed/0","title":"Remedy.Struct.Guild.Role.managed/0","type":"type"},{"doc":"Whether the role is mentionable","ref":"Remedy.Struct.Guild.Role.html#t:mentionable/0","title":"Remedy.Struct.Guild.Role.mentionable/0","type":"type"},{"doc":"The name of the role","ref":"Remedy.Struct.Guild.Role.html#t:name/0","title":"Remedy.Struct.Guild.Role.name/0","type":"type"},{"doc":"The permission bit set","ref":"Remedy.Struct.Guild.Role.html#t:permissions/0","title":"Remedy.Struct.Guild.Role.permissions/0","type":"type"},{"doc":"The position of the role","ref":"Remedy.Struct.Guild.Role.html#t:position/0","title":"Remedy.Struct.Guild.Role.position/0","type":"type"},{"doc":"","ref":"Remedy.Struct.Guild.Role.html#t:t/0","title":"Remedy.Struct.Guild.Role.t/0","type":"type"},{"doc":"Struct representing an unavailable Discord guild.","ref":"Remedy.Struct.Guild.UnavailableGuild.html","title":"Remedy.Struct.Guild.UnavailableGuild","type":"module"},{"doc":"","ref":"Remedy.Struct.Guild.UnavailableGuild.html#to_struct/1","title":"Remedy.Struct.Guild.UnavailableGuild.to_struct/1","type":"function"},{"doc":"The guild's id","ref":"Remedy.Struct.Guild.UnavailableGuild.html#t:id/0","title":"Remedy.Struct.Guild.UnavailableGuild.id/0","type":"type"},{"doc":"","ref":"Remedy.Struct.Guild.UnavailableGuild.html#t:t/0","title":"Remedy.Struct.Guild.UnavailableGuild.t/0","type":"type"},{"doc":"Whether the guild is avaliable","ref":"Remedy.Struct.Guild.UnavailableGuild.html#t:unavailable/0","title":"Remedy.Struct.Guild.UnavailableGuild.unavailable/0","type":"type"},{"doc":"Slash command invocation struct.","ref":"Remedy.Struct.Interaction.html","title":"Remedy.Struct.Interaction","type":"module"},{"doc":"ID of the application that this interaction is for","ref":"Remedy.Struct.Interaction.html#t:application_id/0","title":"Remedy.Struct.Interaction.application_id/0","type":"type"},{"doc":"ID of the channel where the command was invoked","ref":"Remedy.Struct.Interaction.html#t:channel_id/0","title":"Remedy.Struct.Interaction.channel_id/0","type":"type"},{"doc":"Invocation data. Only present for ApplicationCommand interactions, that is, type=2 .","ref":"Remedy.Struct.Interaction.html#t:data/0","title":"Remedy.Struct.Interaction.data/0","type":"type"},{"doc":"ID of the guild where the command was invoked","ref":"Remedy.Struct.Interaction.html#t:guild_id/0","title":"Remedy.Struct.Interaction.guild_id/0","type":"type"},{"doc":"Interaction identifier","ref":"Remedy.Struct.Interaction.html#t:id/0","title":"Remedy.Struct.Interaction.id/0","type":"type"},{"doc":"Member information about the invoker, if invoked on a guild","ref":"Remedy.Struct.Interaction.html#t:member/0","title":"Remedy.Struct.Interaction.member/0","type":"type"},{"doc":"For components, the message they were attached to","ref":"Remedy.Struct.Interaction.html#t:message/0","title":"Remedy.Struct.Interaction.message/0","type":"type"},{"doc":"A command invocation for slash commands. Official reference: https://discord.com/developers/docs/interactions/slash-commands#interaction","ref":"Remedy.Struct.Interaction.html#t:t/0","title":"Remedy.Struct.Interaction.t/0","type":"type"},{"doc":"Continuation token for responses","ref":"Remedy.Struct.Interaction.html#t:token/0","title":"Remedy.Struct.Interaction.token/0","type":"type"},{"doc":"Interaction kind. 1 for Ping 2 for ApplicationCommand","ref":"Remedy.Struct.Interaction.html#t:type/0","title":"Remedy.Struct.Interaction.type/0","type":"type"},{"doc":"User object for the invoking user, if invoked via a DM","ref":"Remedy.Struct.Interaction.html#t:user/0","title":"Remedy.Struct.Interaction.user/0","type":"type"},{"doc":"Version identifier, always 1","ref":"Remedy.Struct.Interaction.html#t:version/0","title":"Remedy.Struct.Interaction.version/0","type":"type"},{"doc":"Struct representing a Discord invite.","ref":"Remedy.Struct.Invite.html","title":"Remedy.Struct.Invite","type":"module"},{"doc":"Approximate total member count of the guild this invite is for.","ref":"Remedy.Struct.Invite.html#t:approximate_member_count/0","title":"Remedy.Struct.Invite.approximate_member_count/0","type":"type"},{"doc":"Approximate online member count of the guild this invite is for.","ref":"Remedy.Struct.Invite.html#t:approximate_presence_count/0","title":"Remedy.Struct.Invite.approximate_presence_count/0","type":"type"},{"doc":"The channel this invite is for.","ref":"Remedy.Struct.Invite.html#t:channel/0","title":"Remedy.Struct.Invite.channel/0","type":"type"},{"doc":"The invite code (unique ID).","ref":"Remedy.Struct.Invite.html#t:code/0","title":"Remedy.Struct.Invite.code/0","type":"type"},{"doc":"When this invite was created.","ref":"Remedy.Struct.Invite.html#t:created_at/0","title":"Remedy.Struct.Invite.created_at/0","type":"type"},{"doc":"An invite with metadata.","ref":"Remedy.Struct.Invite.html#t:detailed_invite/0","title":"Remedy.Struct.Invite.detailed_invite/0","type":"type"},{"doc":"Partially populated guild struct of the guild this invite is for.","ref":"Remedy.Struct.Invite.html#t:guild/0","title":"Remedy.Struct.Invite.guild/0","type":"type"},{"doc":"The user who created this invite.","ref":"Remedy.Struct.Invite.html#t:inviter/0","title":"Remedy.Struct.Invite.inviter/0","type":"type"},{"doc":"Duration (in seconds) after which the invite expires.","ref":"Remedy.Struct.Invite.html#t:max_age/0","title":"Remedy.Struct.Invite.max_age/0","type":"type"},{"doc":"Max number of times this invite can be used.","ref":"Remedy.Struct.Invite.html#t:max_uses/0","title":"Remedy.Struct.Invite.max_uses/0","type":"type"},{"doc":"An invite without metadata.","ref":"Remedy.Struct.Invite.html#t:simple_invite/0","title":"Remedy.Struct.Invite.simple_invite/0","type":"type"},{"doc":"","ref":"Remedy.Struct.Invite.html#t:t/0","title":"Remedy.Struct.Invite.t/0","type":"type"},{"doc":"Partially populated user struct of the target user for this invite.","ref":"Remedy.Struct.Invite.html#t:target_user/0","title":"Remedy.Struct.Invite.target_user/0","type":"type"},{"doc":"The type of user target for this invite.","ref":"Remedy.Struct.Invite.html#t:target_user_type/0","title":"Remedy.Struct.Invite.target_user_type/0","type":"type"},{"doc":"Whether this invite only grants temporary membership.","ref":"Remedy.Struct.Invite.html#t:temporary/0","title":"Remedy.Struct.Invite.temporary/0","type":"type"},{"doc":"Number of times this invite has been used.","ref":"Remedy.Struct.Invite.html#t:uses/0","title":"Remedy.Struct.Invite.uses/0","type":"type"},{"doc":"Struct representing a Discord message.","ref":"Remedy.Struct.Message.html","title":"Remedy.Struct.Message","type":"module"},{"doc":"Takes the message and produces a URL that, when clicked from the user client, will jump them to that message, assuming they have access to the message and the message is valid.","ref":"Remedy.Struct.Message.html#to_url/1","title":"Remedy.Struct.Message.to_url/1","type":"function"},{"doc":"The activity of the message. Sent with Rich Presence-related chat embeds.","ref":"Remedy.Struct.Message.html#t:activity/0","title":"Remedy.Struct.Message.activity/0","type":"type"},{"doc":"The application of the message. Sent with Rich Presence-related chat embeds.","ref":"Remedy.Struct.Message.html#t:application/0","title":"Remedy.Struct.Message.application/0","type":"type"},{"doc":"List of attached files in the message","ref":"Remedy.Struct.Message.html#t:attachments/0","title":"Remedy.Struct.Message.attachments/0","type":"type"},{"doc":"The user struct of the author","ref":"Remedy.Struct.Message.html#t:author/0","title":"Remedy.Struct.Message.author/0","type":"type"},{"doc":"The id of the channel","ref":"Remedy.Struct.Message.html#t:channel_id/0","title":"Remedy.Struct.Message.channel_id/0","type":"type"},{"doc":"The content of the message","ref":"Remedy.Struct.Message.html#t:content/0","title":"Remedy.Struct.Message.content/0","type":"type"},{"doc":"When the message was edited","ref":"Remedy.Struct.Message.html#t:edited_timestamp/0","title":"Remedy.Struct.Message.edited_timestamp/0","type":"type"},{"doc":"List of embedded content in the message","ref":"Remedy.Struct.Message.html#t:embeds/0","title":"Remedy.Struct.Message.embeds/0","type":"type"},{"doc":"The id of the guild","ref":"Remedy.Struct.Message.html#t:guild_id/0","title":"Remedy.Struct.Message.guild_id/0","type":"type"},{"doc":"The id of the message","ref":"Remedy.Struct.Message.html#t:id/0","title":"Remedy.Struct.Message.id/0","type":"type"},{"doc":"Partial Guild Member object received with the Message Create event if message came from a guild channel.","ref":"Remedy.Struct.Message.html#t:member/0","title":"Remedy.Struct.Message.member/0","type":"type"},{"doc":"Whether this messsage mentions everyone","ref":"Remedy.Struct.Message.html#t:mention_everyone/0","title":"Remedy.Struct.Message.mention_everyone/0","type":"type"},{"doc":"List of roles ids mentioned in the message","ref":"Remedy.Struct.Message.html#t:mention_roles/0","title":"Remedy.Struct.Message.mention_roles/0","type":"type"},{"doc":"List of users mentioned in the message","ref":"Remedy.Struct.Message.html#t:mentions/0","title":"Remedy.Struct.Message.mentions/0","type":"type"},{"doc":"Reference data sent with crossposted messages and replies","ref":"Remedy.Struct.Message.html#t:message_reference/0","title":"Remedy.Struct.Message.message_reference/0","type":"type"},{"doc":"Validates if a message was sent","ref":"Remedy.Struct.Message.html#t:nonce/0","title":"Remedy.Struct.Message.nonce/0","type":"type"},{"doc":"Whether this message is pinned","ref":"Remedy.Struct.Message.html#t:pinned/0","title":"Remedy.Struct.Message.pinned/0","type":"type"},{"doc":"Reactions to the message.","ref":"Remedy.Struct.Message.html#t:reactions/0","title":"Remedy.Struct.Message.reactions/0","type":"type"},{"doc":"The message associated with the message_reference This field is only returned for messages with a type of 19 (REPLY). If the message is a reply but the referenced_message field is not present, the backend did not attempt to fetch the message that was being replied to, so its state is unknown. If the field exists but is null, the referenced message was deleted.","ref":"Remedy.Struct.Message.html#t:referenced_message/0","title":"Remedy.Struct.Message.referenced_message/0","type":"type"},{"doc":"","ref":"Remedy.Struct.Message.html#t:t/0","title":"Remedy.Struct.Message.t/0","type":"type"},{"doc":"When the message was sent","ref":"Remedy.Struct.Message.html#t:timestamp/0","title":"Remedy.Struct.Message.timestamp/0","type":"type"},{"doc":"Whether this was a TTS message","ref":"Remedy.Struct.Message.html#t:tts/0","title":"Remedy.Struct.Message.tts/0","type":"type"},{"doc":"Type of message .","ref":"Remedy.Struct.Message.html#t:type/0","title":"Remedy.Struct.Message.type/0","type":"type"},{"doc":"If the message is generated by a webhook, this is the webhook's id.","ref":"Remedy.Struct.Message.html#t:webhook_id/0","title":"Remedy.Struct.Message.webhook_id/0","type":"type"},{"doc":"Struct representing a Discord message activity.","ref":"Remedy.Struct.Message.Activity.html","title":"Remedy.Struct.Message.Activity","type":"module"},{"doc":"The party id from a rich presence event .","ref":"Remedy.Struct.Message.Activity.html#t:party_id/0","title":"Remedy.Struct.Message.Activity.party_id/0","type":"type"},{"doc":"","ref":"Remedy.Struct.Message.Activity.html#t:t/0","title":"Remedy.Struct.Message.Activity.t/0","type":"type"},{"doc":"Type of message activity .","ref":"Remedy.Struct.Message.Activity.html#t:type/0","title":"Remedy.Struct.Message.Activity.type/0","type":"type"},{"doc":"Struct representing a Discord message application.","ref":"Remedy.Struct.Message.Application.html","title":"Remedy.Struct.Message.Application","type":"module"},{"doc":"Id of the embed's image asset","ref":"Remedy.Struct.Message.Application.html#t:cover_image/0","title":"Remedy.Struct.Message.Application.cover_image/0","type":"type"},{"doc":"Application's description","ref":"Remedy.Struct.Message.Application.html#t:description/0","title":"Remedy.Struct.Message.Application.description/0","type":"type"},{"doc":"Id of the application's icon","ref":"Remedy.Struct.Message.Application.html#t:icon/0","title":"Remedy.Struct.Message.Application.icon/0","type":"type"},{"doc":"Id of the application","ref":"Remedy.Struct.Message.Application.html#t:id/0","title":"Remedy.Struct.Message.Application.id/0","type":"type"},{"doc":"Name of the application","ref":"Remedy.Struct.Message.Application.html#t:name/0","title":"Remedy.Struct.Message.Application.name/0","type":"type"},{"doc":"","ref":"Remedy.Struct.Message.Application.html#t:t/0","title":"Remedy.Struct.Message.Application.t/0","type":"type"},{"doc":"Struct representing a Discord message attachment.","ref":"Remedy.Struct.Message.Attachment.html","title":"Remedy.Struct.Message.Attachment","type":"module"},{"doc":"Name of attached file","ref":"Remedy.Struct.Message.Attachment.html#t:filename/0","title":"Remedy.Struct.Message.Attachment.filename/0","type":"type"},{"doc":"Height of the file (if image)","ref":"Remedy.Struct.Message.Attachment.html#t:height/0","title":"Remedy.Struct.Message.Attachment.height/0","type":"type"},{"doc":"Attachment id","ref":"Remedy.Struct.Message.Attachment.html#t:id/0","title":"Remedy.Struct.Message.Attachment.id/0","type":"type"},{"doc":"Proxy url of the file","ref":"Remedy.Struct.Message.Attachment.html#t:proxy_url/0","title":"Remedy.Struct.Message.Attachment.proxy_url/0","type":"type"},{"doc":"Size of the file in bytes","ref":"Remedy.Struct.Message.Attachment.html#t:size/0","title":"Remedy.Struct.Message.Attachment.size/0","type":"type"},{"doc":"","ref":"Remedy.Struct.Message.Attachment.html#t:t/0","title":"Remedy.Struct.Message.Attachment.t/0","type":"type"},{"doc":"Source url of the file","ref":"Remedy.Struct.Message.Attachment.html#t:url/0","title":"Remedy.Struct.Message.Attachment.url/0","type":"type"},{"doc":"Width of the file (if image)","ref":"Remedy.Struct.Message.Attachment.html#t:width/0","title":"Remedy.Struct.Message.Attachment.width/0","type":"type"},{"doc":"Struct representing a Discord message reaction.","ref":"Remedy.Struct.Message.Reaction.html","title":"Remedy.Struct.Message.Reaction","type":"module"},{"doc":"Times this emoji has been used to react","ref":"Remedy.Struct.Message.Reaction.html#t:count/0","title":"Remedy.Struct.Message.Reaction.count/0","type":"type"},{"doc":"Emoji information","ref":"Remedy.Struct.Message.Reaction.html#t:emoji/0","title":"Remedy.Struct.Message.Reaction.emoji/0","type":"type"},{"doc":"Whether the current user is the one who reacted","ref":"Remedy.Struct.Message.Reaction.html#t:me/0","title":"Remedy.Struct.Message.Reaction.me/0","type":"type"},{"doc":"","ref":"Remedy.Struct.Message.Reaction.html#t:t/0","title":"Remedy.Struct.Message.Reaction.t/0","type":"type"},{"doc":"Struct representing a discord message reference.","ref":"Remedy.Struct.Message.Reference.html","title":"Remedy.Struct.Message.Reference","type":"module"},{"doc":"Id of the originating message's channel","ref":"Remedy.Struct.Message.Reference.html#t:channel_id/0","title":"Remedy.Struct.Message.Reference.channel_id/0","type":"type"},{"doc":"Id of the originating message's guild","ref":"Remedy.Struct.Message.Reference.html#t:guild_id/0","title":"Remedy.Struct.Message.Reference.guild_id/0","type":"type"},{"doc":"Id of the originating message","ref":"Remedy.Struct.Message.Reference.html#t:message_id/0","title":"Remedy.Struct.Message.Reference.message_id/0","type":"type"},{"doc":"","ref":"Remedy.Struct.Message.Reference.html#t:t/0","title":"Remedy.Struct.Message.Reference.t/0","type":"type"},{"doc":"Struct representing a Discord overwrite.","ref":"Remedy.Struct.Overwrite.html","title":"Remedy.Struct.Overwrite","type":"module"},{"doc":"Permission bit set","ref":"Remedy.Struct.Overwrite.html#t:allow/0","title":"Remedy.Struct.Overwrite.allow/0","type":"type"},{"doc":"Permission bit set","ref":"Remedy.Struct.Overwrite.html#t:deny/0","title":"Remedy.Struct.Overwrite.deny/0","type":"type"},{"doc":"Role or User id","ref":"Remedy.Struct.Overwrite.html#t:id/0","title":"Remedy.Struct.Overwrite.id/0","type":"type"},{"doc":"","ref":"Remedy.Struct.Overwrite.html#t:t/0","title":"Remedy.Struct.Overwrite.t/0","type":"type"},{"doc":"Either 'role' or 'member'","ref":"Remedy.Struct.Overwrite.html#t:type/0","title":"Remedy.Struct.Overwrite.type/0","type":"type"},{"doc":"Struct representing a Discord user. Mentioning Users in Messages A Remedy.Struct.User can be mentioned in message content using the String.Chars protocol or mention/1 . user = %Remedy.Struct.User{id: 120571255635181568} Remedy.Api.create_message!(184046599834435585, &quot;\#{user}&quot;) %Remedy.Struct.Message{content: &quot;&lt;@120571255635181568&gt;&quot;} user = %Remedy.Struct.User{id: 89918932789497856} Remedy.Api.create_message!(280085880452939778, &quot;\#{Remedy.Struct.User.mention(user)}&quot;) %Remedy.Struct.Message{content: &quot;&lt;@89918932789497856&gt;&quot;} User vs. Member A user contains only general information about that user such as a username and an avatar . A member has everything that a user has, but also additional information on a per guild basis. This includes things like a nickname and a list of roles .","ref":"Remedy.Struct.User.html","title":"Remedy.Struct.User","type":"module"},{"doc":"Returns the URL of a user's display avatar. If :avatar is nil , the default avatar url is returned. Supported image formats are PNG, JPEG, WebP, and GIF. Examples iex&gt; user = %Remedy.Struct.User{avatar: &quot;8342729096ea3675442027381ff50dfe&quot;, ...&gt; id: 80351110224678912} iex&gt; Remedy.Struct.User.avatar_url(user) &quot;https://cdn.discordapp.com/avatars/80351110224678912/8342729096ea3675442027381ff50dfe.webp&quot; iex&gt; Remedy.Struct.User.avatar_url(user, &quot;png&quot;) &quot;https://cdn.discordapp.com/avatars/80351110224678912/8342729096ea3675442027381ff50dfe.png&quot; iex&gt; user = %Remedy.Struct.User{avatar: nil, ...&gt; discriminator: &quot;1337&quot;} iex&gt; Remedy.Struct.User.avatar_url(user) &quot;https://cdn.discordapp.com/embed/avatars/2.png&quot;","ref":"Remedy.Struct.User.html#avatar_url/2","title":"Remedy.Struct.User.avatar_url/2","type":"function"},{"doc":"Returns a user's :username and :discriminator separated by a hashtag. Examples iex&gt; user = %Remedy.Struct.User{username: &quot;b1nzy&quot;, ...&gt; discriminator: &quot;0852&quot;} iex&gt; Remedy.Struct.User.full_name(user) &quot;b1nzy#0852&quot;","ref":"Remedy.Struct.User.html#full_name/1","title":"Remedy.Struct.User.full_name/1","type":"function"},{"doc":"Formats an Remedy.Struct.User into a mention. Examples iex&gt; user = %Remedy.Struct.User{id: 177888205536886784} ...&gt; Remedy.Struct.User.mention(user) &quot;&lt;@177888205536886784&gt;&quot;","ref":"Remedy.Struct.User.html#mention/1","title":"Remedy.Struct.User.mention/1","type":"function"},{"doc":"User's avatar hash","ref":"Remedy.Struct.User.html#t:avatar/0","title":"Remedy.Struct.User.avatar/0","type":"type"},{"doc":"Whether the user is a bot","ref":"Remedy.Struct.User.html#t:bot/0","title":"Remedy.Struct.User.bot/0","type":"type"},{"doc":"The user's 4--digit discord-tag","ref":"Remedy.Struct.User.html#t:discriminator/0","title":"Remedy.Struct.User.discriminator/0","type":"type"},{"doc":"The user's email","ref":"Remedy.Struct.User.html#t:email/0","title":"Remedy.Struct.User.email/0","type":"type"},{"doc":"The user's id","ref":"Remedy.Struct.User.html#t:id/0","title":"Remedy.Struct.User.id/0","type":"type"},{"doc":"Whether the user has two factor enabled","ref":"Remedy.Struct.User.html#t:mfa_enabled/0","title":"Remedy.Struct.User.mfa_enabled/0","type":"type"},{"doc":"The user's public flags","ref":"Remedy.Struct.User.html#t:public_flags/0","title":"Remedy.Struct.User.public_flags/0","type":"type"},{"doc":"","ref":"Remedy.Struct.User.html#t:t/0","title":"Remedy.Struct.User.t/0","type":"type"},{"doc":"The user's username","ref":"Remedy.Struct.User.html#t:username/0","title":"Remedy.Struct.User.username/0","type":"type"},{"doc":"Whether the email on the account has been verified","ref":"Remedy.Struct.User.html#t:verified/0","title":"Remedy.Struct.User.verified/0","type":"type"},{"doc":"Struct representing a Discord User's connections","ref":"Remedy.Struct.User.Connection.html","title":"Remedy.Struct.User.Connection","type":"module"},{"doc":"Struct representing the flags a user account can have","ref":"Remedy.Struct.User.Flags.html","title":"Remedy.Struct.User.Flags","type":"module"},{"doc":"Constructs a flag struct based on an integer from the Discord API (either public_flags or flags). Examples iex&gt; Remedy.Struct.User.Flags . from_integer ( 131842 ) % Remedy.Struct.User.Flags { bug_hunter_level_1 : false , bug_hunter_level_2 : false , early_supporter : true , hypesquad_balance : true , hypesquad_bravery : false , hypesquad_brilliance : false , hypesquad_events : false , partner : true , staff : false , system : false , team_user : false , verified_bot : false , verified_developer : true }","ref":"Remedy.Struct.User.Flags.html#from_integer/1","title":"Remedy.Struct.User.Flags.from_integer/1","type":"function"},{"doc":"Convert a flag struct to an integer value. Examples iex&gt; my_flags = % Remedy.Struct.User.Flags { ...&gt; bug_hunter_level_1 : false , ...&gt; bug_hunter_level_2 : false , ...&gt; early_supporter : true , ...&gt; hypesquad_balance : true , ...&gt; hypesquad_bravery : false , ...&gt; hypesquad_brilliance : false , ...&gt; hypesquad_events : false , ...&gt; partner : true , ...&gt; staff : false , ...&gt; system : false , ...&gt; team_user : false , ...&gt; verified_bot : false , ...&gt; verified_developer : true ...&gt; } iex&gt; Remedy.Struct.User.Flags . to_integer ( my_flags ) 131842","ref":"Remedy.Struct.User.Flags.html#to_integer/1","title":"Remedy.Struct.User.Flags.to_integer/1","type":"function"},{"doc":"Bug Hunter (Level 1)","ref":"Remedy.Struct.User.Flags.html#t:bug_hunter_level_1/0","title":"Remedy.Struct.User.Flags.bug_hunter_level_1/0","type":"type"},{"doc":"Bug Hunter (Level 2)","ref":"Remedy.Struct.User.Flags.html#t:bug_hunter_level_2/0","title":"Remedy.Struct.User.Flags.bug_hunter_level_2/0","type":"type"},{"doc":"Early Supporter","ref":"Remedy.Struct.User.Flags.html#t:early_supporter/0","title":"Remedy.Struct.User.Flags.early_supporter/0","type":"type"},{"doc":"","ref":"Remedy.Struct.User.Flags.html#t:flags/0","title":"Remedy.Struct.User.Flags.flags/0","type":"type"},{"doc":"HypeSquad Balance","ref":"Remedy.Struct.User.Flags.html#t:hypesquad_balance/0","title":"Remedy.Struct.User.Flags.hypesquad_balance/0","type":"type"},{"doc":"HypeSquad Bravery","ref":"Remedy.Struct.User.Flags.html#t:hypesquad_bravery/0","title":"Remedy.Struct.User.Flags.hypesquad_bravery/0","type":"type"},{"doc":"HypeSquad Brilliance","ref":"Remedy.Struct.User.Flags.html#t:hypesquad_brilliance/0","title":"Remedy.Struct.User.Flags.hypesquad_brilliance/0","type":"type"},{"doc":"HypeSquad Events","ref":"Remedy.Struct.User.Flags.html#t:hypesquad_events/0","title":"Remedy.Struct.User.Flags.hypesquad_events/0","type":"type"},{"doc":"Discord Partner","ref":"Remedy.Struct.User.Flags.html#t:partner/0","title":"Remedy.Struct.User.Flags.partner/0","type":"type"},{"doc":"Discord Employee","ref":"Remedy.Struct.User.Flags.html#t:staff/0","title":"Remedy.Struct.User.Flags.staff/0","type":"type"},{"doc":"System user","ref":"Remedy.Struct.User.Flags.html#t:system/0","title":"Remedy.Struct.User.Flags.system/0","type":"type"},{"doc":"","ref":"Remedy.Struct.User.Flags.html#t:t/0","title":"Remedy.Struct.User.Flags.t/0","type":"type"},{"doc":"Team User","ref":"Remedy.Struct.User.Flags.html#t:team_user/0","title":"Remedy.Struct.User.Flags.team_user/0","type":"type"},{"doc":"Verified bot","ref":"Remedy.Struct.User.Flags.html#t:verified_bot/0","title":"Remedy.Struct.User.Flags.verified_bot/0","type":"type"},{"doc":"Verified developer","ref":"Remedy.Struct.User.Flags.html#t:verified_developer/0","title":"Remedy.Struct.User.Flags.verified_developer/0","type":"type"},{"doc":"Struct representing a Discord voice region.","ref":"Remedy.Struct.VoiceRegion.html","title":"Remedy.Struct.VoiceRegion","type":"module"},{"doc":"","ref":"Remedy.Struct.VoiceRegion.html#t:t/0","title":"Remedy.Struct.VoiceRegion.t/0","type":"type"},{"doc":"Struct representing the current Voice WS state.","ref":"Remedy.Struct.VoiceWSState.html","title":"Remedy.Struct.VoiceWSState","type":"module"},{"doc":"PID of the :gun worker connected to the websocket","ref":"Remedy.Struct.VoiceWSState.html#t:conn/0","title":"Remedy.Struct.VoiceWSState.conn/0","type":"type"},{"doc":"PID of the connection process","ref":"Remedy.Struct.VoiceWSState.html#t:conn_pid/0","title":"Remedy.Struct.VoiceWSState.conn_pid/0","type":"type"},{"doc":"Gateway URL","ref":"Remedy.Struct.VoiceWSState.html#t:gateway/0","title":"Remedy.Struct.VoiceWSState.gateway/0","type":"type"},{"doc":"The guild id that this voice websocket state applies to","ref":"Remedy.Struct.VoiceWSState.html#t:guild_id/0","title":"Remedy.Struct.VoiceWSState.guild_id/0","type":"type"},{"doc":"Whether or not the last hearbeat sent was ACK'd","ref":"Remedy.Struct.VoiceWSState.html#t:heartbeat_ack/0","title":"Remedy.Struct.VoiceWSState.heartbeat_ack/0","type":"type"},{"doc":"Interval at which heartbeats are sent","ref":"Remedy.Struct.VoiceWSState.html#t:heartbeat_interval/0","title":"Remedy.Struct.VoiceWSState.heartbeat_interval/0","type":"type"},{"doc":"Time ref for the heartbeat","ref":"Remedy.Struct.VoiceWSState.html#t:heartbeat_ref/0","title":"Remedy.Struct.VoiceWSState.heartbeat_ref/0","type":"type"},{"doc":"Whether the session has been identified","ref":"Remedy.Struct.VoiceWSState.html#t:identified/0","title":"Remedy.Struct.VoiceWSState.identified/0","type":"type"},{"doc":"The time the last heartbeat was acknowledged, will be nil if a heartbeat hasn't been ACK'd yet","ref":"Remedy.Struct.VoiceWSState.html#t:last_heartbeat_ack/0","title":"Remedy.Struct.VoiceWSState.last_heartbeat_ack/0","type":"type"},{"doc":"The time the last heartbeat was sent, if a heartbeat hasn't been sent it will be the time the websocket process was started","ref":"Remedy.Struct.VoiceWSState.html#t:last_heartbeat_send/0","title":"Remedy.Struct.VoiceWSState.last_heartbeat_send/0","type":"type"},{"doc":"The session id","ref":"Remedy.Struct.VoiceWSState.html#t:session/0","title":"Remedy.Struct.VoiceWSState.session/0","type":"type"},{"doc":"Stream reference for :gun","ref":"Remedy.Struct.VoiceWSState.html#t:stream/0","title":"Remedy.Struct.VoiceWSState.stream/0","type":"type"},{"doc":"","ref":"Remedy.Struct.VoiceWSState.html#t:t/0","title":"Remedy.Struct.VoiceWSState.t/0","type":"type"},{"doc":"The session token","ref":"Remedy.Struct.VoiceWSState.html#t:token/0","title":"Remedy.Struct.VoiceWSState.token/0","type":"type"},{"doc":"Struct representing the current WS state.","ref":"Remedy.Struct.WSState.html","title":"Remedy.Struct.WSState","type":"module"},{"doc":"PID of the :gun worker connected to the websocket","ref":"Remedy.Struct.WSState.html#t:conn/0","title":"Remedy.Struct.WSState.conn/0","type":"type"},{"doc":"PID of the connection process","ref":"Remedy.Struct.WSState.html#t:conn_pid/0","title":"Remedy.Struct.WSState.conn_pid/0","type":"type"},{"doc":"Gateway URL","ref":"Remedy.Struct.WSState.html#t:gateway/0","title":"Remedy.Struct.WSState.gateway/0","type":"type"},{"doc":"Whether or not the last hearbeat sent was ACK'd","ref":"Remedy.Struct.WSState.html#t:heartbeat_ack/0","title":"Remedy.Struct.WSState.heartbeat_ack/0","type":"type"},{"doc":"Interval at which heartbeats are sent","ref":"Remedy.Struct.WSState.html#t:heartbeat_interval/0","title":"Remedy.Struct.WSState.heartbeat_interval/0","type":"type"},{"doc":"Time ref for the heartbeat","ref":"Remedy.Struct.WSState.html#t:heartbeat_ref/0","title":"Remedy.Struct.WSState.heartbeat_ref/0","type":"type"},{"doc":"The time the last heartbeat was acknowledged, will be nil if a heartbeat hasn't been ACK'd yet","ref":"Remedy.Struct.WSState.html#t:last_heartbeat_ack/0","title":"Remedy.Struct.WSState.last_heartbeat_ack/0","type":"type"},{"doc":"The time the last heartbeat was sent, if a heartbeat hasn't been sent it will be the time the websocket process was started","ref":"Remedy.Struct.WSState.html#t:last_heartbeat_send/0","title":"Remedy.Struct.WSState.last_heartbeat_send/0","type":"type"},{"doc":"The sequence number of the last event","ref":"Remedy.Struct.WSState.html#t:seq/0","title":"Remedy.Struct.WSState.seq/0","type":"type"},{"doc":"The session id","ref":"Remedy.Struct.WSState.html#t:session/0","title":"Remedy.Struct.WSState.session/0","type":"type"},{"doc":"The shard number","ref":"Remedy.Struct.WSState.html#t:shard_num/0","title":"Remedy.Struct.WSState.shard_num/0","type":"type"},{"doc":"PID of the shard containing this state","ref":"Remedy.Struct.WSState.html#t:shard_pid/0","title":"Remedy.Struct.WSState.shard_pid/0","type":"type"},{"doc":"Stream reference for :gun","ref":"Remedy.Struct.WSState.html#t:stream/0","title":"Remedy.Struct.WSState.stream/0","type":"type"},{"doc":"","ref":"Remedy.Struct.WSState.html#t:t/0","title":"Remedy.Struct.WSState.t/0","type":"type"},{"doc":"Reference to the current zlib context","ref":"Remedy.Struct.WSState.html#t:zlib_ctx/0","title":"Remedy.Struct.WSState.zlib_ctx/0","type":"type"},{"doc":"Struct representing a Discord webhook.","ref":"Remedy.Struct.Webhook.html","title":"Remedy.Struct.Webhook","type":"module"},{"doc":"Default avatar of the webhook","ref":"Remedy.Struct.Webhook.html#t:avatar/0","title":"Remedy.Struct.Webhook.avatar/0","type":"type"},{"doc":"Channel the webhook is for","ref":"Remedy.Struct.Webhook.html#t:channel_id/0","title":"Remedy.Struct.Webhook.channel_id/0","type":"type"},{"doc":"Guild the webhook is for","ref":"Remedy.Struct.Webhook.html#t:guild_id/0","title":"Remedy.Struct.Webhook.guild_id/0","type":"type"},{"doc":"Id of the webhook","ref":"Remedy.Struct.Webhook.html#t:id/0","title":"Remedy.Struct.Webhook.id/0","type":"type"},{"doc":"Default name of the webhook","ref":"Remedy.Struct.Webhook.html#t:name/0","title":"Remedy.Struct.Webhook.name/0","type":"type"},{"doc":"","ref":"Remedy.Struct.Webhook.html#t:t/0","title":"Remedy.Struct.Webhook.t/0","type":"type"},{"doc":"Secure token of the webhook","ref":"Remedy.Struct.Webhook.html#t:token/0","title":"Remedy.Struct.Webhook.token/0","type":"type"},{"doc":"User who created the webhook","ref":"Remedy.Struct.Webhook.html#t:user/0","title":"Remedy.Struct.Webhook.user/0","type":"type"},{"doc":"Utility functions","ref":"Remedy.Util.html","title":"Remedy.Util","type":"module"},{"doc":"","ref":"Remedy.Util.html#enum_to_struct/2","title":"Remedy.Util.enum_to_struct/2","type":"function"},{"doc":"Returns the gateway url and shard count for current websocket connections. If by chance no gateway connection has been made, will fetch the url to use and store it for future use.","ref":"Remedy.Util.html#gateway/0","title":"Remedy.Util.gateway/0","type":"function"},{"doc":"Gets the latencies of all shard connections. Calls get_shard_latency/1 on all shards and returns a map whose keys are shard nums and whose values are latencies in milliseconds.","ref":"Remedy.Util.html#get_all_shard_latencies/0","title":"Remedy.Util.get_all_shard_latencies/0","type":"function"},{"doc":"Gets the latency of the shard connection from a Remedy.Struct.WSState.t() struct. Returns the latency in milliseconds as an integer, returning nil if unknown.","ref":"Remedy.Util.html#get_shard_latency/1","title":"Remedy.Util.get_shard_latency/1","type":"function"},{"doc":"Attempts to convert a string to an atom. Binary token s that consist of digits are assumed to be snowflakes, and will be parsed as such. If atom does not currently exist, will warn that we're doing an unsafe conversion.","ref":"Remedy.Util.html#maybe_to_atom/1","title":"Remedy.Util.maybe_to_atom/1","type":"function"},{"doc":"Returns the number of milliseconds since unix epoch.","ref":"Remedy.Util.html#now/0","title":"Remedy.Util.now/0","type":"function"},{"doc":"Returns the current date as an ISO formatted string.","ref":"Remedy.Util.html#now_iso/0","title":"Remedy.Util.now_iso/0","type":"function"},{"doc":"Returns the number of shards. This is not the number of currently active shards, but the number of shards specified in your config.","ref":"Remedy.Util.html#num_shards/0","title":"Remedy.Util.num_shards/0","type":"function"},{"doc":"Helper for defining all the methods used for struct and encoding transformations. Example Remedy.Util.remedy_struct(%{ author: User, mentions: [User], mention_roles: [User], embeds: [Embed] })","ref":"Remedy.Util.html#remedy_struct/1","title":"Remedy.Util.remedy_struct/1","type":"macro"},{"doc":"Converts a map into an atom-keyed map. Given a map with variable type keys, returns the same map with all keys as atoms . To support maps keyed with integers (such as in Discord's interaction data), binaries that appear to be integers will be parsed as such. This function will attempt to convert keys to an existing atom, and if that fails will default to creating a new atom while displaying a warning. The idea here is that we should be able to see if any results from Discord are giving variable keys. Since we will define all types of objects returned by Discord, the amount of new atoms created SHOULD be 0. 👀","ref":"Remedy.Util.html#safe_atom_map/1","title":"Remedy.Util.safe_atom_map/1","type":"function"},{"doc":"Since we're being sacrilegious and converting strings to atoms from the WS, there will be some atoms that we see that aren't defined in any Discord structs. This method mainly serves as a means to define those atoms once so the user isn't warned about them in the Remedy.Util.maybe_to_atom/1 function when they are in fact harmless.","ref":"Remedy.Util.html#unused_atoms/0","title":"Remedy.Util.unused_atoms/0","type":"function"},{"doc":"Returns the number of microseconds since unix epoch.","ref":"Remedy.Util.html#usec_now/0","title":"Remedy.Util.usec_now/0","type":"function"},{"doc":"Interface for playing audio through Discord's voice channels. Using Discord Voice Channels To play sound in Discord with Remedy, you'll need ffmpeg to be installed. If you don't have the executable ffmpeg in the path, the absolute path may be configured through config keys :remedy, :ffmpeg . If you don't want to use ffmpeg, read on to the next section. A bot may be connected to at most one voice channel per guild. For this reason, most of the functions in this module take a guild id, and the resulting action will be performed in the given guild's voice channel that the bot is connected to. The primary Discord gateway responsible for all text based communication relies on one websocket connection per shard, where small bots typically only have one shard. The Discord voice gateways work by establishing a websocket connection per guild/channel. After some handshaking on this connection, audio data can be sent over UDP/RTP. Behind the scenes the voice websocket connections are implemented nearly the same way the main shard websocket connections are, and require no developer intervention. Voice Without FFmpeg If you wish to BYOE (Bring Your Own Encoder), there are a few options. Use :raw as type for Remedy.Voice.play/4 Provide the complete list of opus frames as the input Use :raw_s as type for Remedy.Voice.play/4 Provide a stateful enumerable of opus frames as input (think GenServer wrapped in Stream.unfold/2 ) Use lower level functions to send opus frames at your leisure Send packets on your own time using Remedy.Voice.send_frames/2","ref":"Remedy.Voice.html","title":"Remedy.Voice","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Remedy.Voice.html#child_spec/1","title":"Remedy.Voice.child_spec/1","type":"function"},{"doc":"Low-level. Manually connect to voice websockets gateway. This function should only be called if config option :voice_auto_connect is set to false . By default Remedy will automatically create a voice gateway when joining a channel.","ref":"Remedy.Voice.html#connect_to_gateway/1","title":"Remedy.Voice.connect_to_gateway/1","type":"function"},{"doc":"Gets the id of the voice channel that the bot is connected to. Parameters guild_id - ID of guild that the resultant channel belongs to. Returns the channel_id for the channel the bot is connected to, otherwise nil . Examples iex&gt; Remedy.Voice.join_channel(123456789, 420691337) iex&gt; Remedy.Voice.get_channel(123456789) 420691337 iex&gt; Remedy.Voice.leave_channel(123456789) iex&gt; Remedy.Voice.get_channel(123456789) nil","ref":"Remedy.Voice.html#get_channel_id/1","title":"Remedy.Voice.get_channel_id/1","type":"function"},{"doc":"Joins or moves the bot to a voice channel. This function is equivalent to Remedy.Api.update_voice_state/4 .","ref":"Remedy.Voice.html#join_channel/4","title":"Remedy.Voice.join_channel/4","type":"function"},{"doc":"Leaves the voice channel of the given guild id. This function is equivalent to calling Remedy.Api.update_voice_state(guild_id, nil) .","ref":"Remedy.Voice.html#leave_channel/1","title":"Remedy.Voice.leave_channel/1","type":"function"},{"doc":"Listen for incoming voice RTP packets. Parameters guild_id - ID of guild that the bot is listening to. num_packets - Number of packets to wait for. Returns a list of 2-element tuples in the form {rtp_header, opus_frame} . This function will block until the specified number of packets is received.","ref":"Remedy.Voice.html#listen/2","title":"Remedy.Voice.listen/2","type":"function"},{"doc":"Pauses the current sound being played in a voice channel. The bot must be connected to a voice channel in the guild specified. Parameters guild_id - ID of guild whose voice channel the sound will be paused in. Returns {:error, reason} if unable to pause or no sound is playing, else :ok . This function is similar to stop/1 , except that the sound may be resumed after being paused. Examples iex&gt; Remedy.Voice.join_channel(123456789, 420691337) iex&gt; Remedy.Voice.play(123456789, &quot;~/files/twelve_hour_loop_of_waterfall_sounds.mp3&quot;) iex&gt; Remedy.Voice.pause(123456789)","ref":"Remedy.Voice.html#pause/1","title":"Remedy.Voice.pause/1","type":"function"},{"doc":"Plays sound in the voice channel the bot is in. The bot must be connected to a voice channel in the guild specified. Parameters guild_id - ID of guild whose voice channel the sound will be played in. input - Audio to be played. Type of input determined by type parameter. type - Type of input (defaults to :url ). :url Input will be any url that ffmpeg can read . :pipe Input will be data that is piped to stdin of ffmpeg . :ytdl Input will be url for youtube-dl , which gets automatically piped to ffmpeg . :stream Input will be livestream url for streamlink , which gets automatically piped to ffmpeg . :raw Input will be an enumarable of raw opus frames. This bypasses ffmpeg and all options. :raw_s Same as :raw but input must be stateful, i.e. calling Enum.take/2 on input is not idempotent. options - See options section below. Returns {:error, reason} if unable to play or a sound is playing, else :ok . Options :start_pos (string) - The start position of the audio to be played. Defaults to beginning. :duration (string) - The duration to of the audio to be played . Defaults to entire duration. :realtime (boolean) - Make ffmpeg process the input in realtime instead of as fast as possible. Defaults to true. :volume (number) - The output volume of the audio. Default volume is 1.0. :filter (string) - Filter(s) to be applied to the audio. No filters applied by default. The values of :start_pos and :duration can be any time duration that ffmpeg can read . The :filter can be used multiple times in a single call (see examples). The values of :filter can be any audio filters that ffmpeg can read . Filters will be applied in order and can be as complex as you want. The world is your oyster! Note that using the :volume option is shortcut for the &quot;volume&quot; filter, and will be added to the end of the filter chain, acting as a master volume. Volume values between 0.0 and 1.0 act as standard oparating range where 0 is off and 1 is max. Values greater than 1.0 will add saturation and distortion to the audio. Negative values act the same as their position but reverse the polarity of the waveform. Having all the ffmpeg audio filters available is extremely powerful so it may be worth learning some of them for your use cases. If you use any filters to increase the playback speed of your audio, it's recommended to set the :realtime option to false because realtime processing is relative to the original playback speed. Examples iex&gt; Remedy.Voice.join_channel(123456789, 420691337) iex&gt; Remedy.Voice.play(123456789, &quot;~/music/FavoriteSong.mp3&quot;, :url) iex&gt; Remedy.Voice.play(123456789, &quot;~/music/NotFavoriteButStillGoodSong.mp3&quot;, :url, volume: 0.5) iex&gt; Remedy.Voice.play(123456789, &quot;~/music/ThisWillBeHeavilyDistorted.mp3&quot;, :url, volume: 1000) iex&gt; Remedy.Voice.join_channel(123456789, 420691337) iex&gt; raw_data = File.read!(&quot;~/music/sound_effect.wav&quot;) iex&gt; Remedy.Voice.play(123456789, raw_data, :pipe) iex&gt; Remedy.Voice.join_channel(123456789, 420691337) iex&gt; Remedy.Voice.play(123456789, &quot;https://www.youtube.com/watch?v=b4RJ-QGOtw4&quot;, :ytdl, ...&gt; realtime: true, start_pos: &quot;0:17&quot;, duration: &quot;30&quot;) iex&gt; Remedy.Voice.play(123456789, &quot;https://www.youtube.com/watch?v=0ngcL_5ekXo&quot;, :ytdl, ...&gt; filter: &quot;lowpass=f=1200&quot;, filter: &quot;highpass=f=300&quot;, filter: &quot;asetrate=44100*0.5&quot;) iex&gt; Remedy.Voice.join_channel(123456789, 420691337) iex&gt; Remedy.Voice.play(123456789, &quot;https://www.twitch.tv/pestily&quot;, :stream) iex&gt; Remedy.Voice.play(123456789, &quot;https://youtu.be/LN4r-K8ZP5Q&quot;, :stream)","ref":"Remedy.Voice.html#play/4","title":"Remedy.Voice.play/4","type":"function"},{"doc":"Checks if the bot is playing sound in a voice channel. Parameters guild_id - ID of guild to check if audio being played. Returns true if the bot is currently being played in a voice channel, otherwise false . Examples iex&gt; Remedy.Voice.join_channel(123456789, 420691337) iex&gt; Remedy.Voice.play(123456789, &quot;https://a-real-site.biz/RickRoll.m4a&quot;) iex&gt; Remedy.Voice.playing?(123456789) true iex&gt; Remedy.Voice.pause(123456789) iex&gt; Remedy.Voice.playing?(123456789) false","ref":"Remedy.Voice.html#playing?/1","title":"Remedy.Voice.playing?/1","type":"function"},{"doc":"Checks if the connection is up and ready to play audio. Parameters guild_id - ID of guild to check if voice connection is up. Returns true if the bot is connected to a voice channel, otherwise false . This function does not check if audio is already playing. For that, use playing?/1 . Examples iex&gt; Remedy.Voice.join_channel(123456789, 420691337) iex&gt; Remedy.Voice.ready?(123456789) true iex&gt; Remedy.Voice.leave_channel(123456789) iex&gt; Remedy.Voice.ready?(123456789) false","ref":"Remedy.Voice.html#ready?/1","title":"Remedy.Voice.ready?/1","type":"function"},{"doc":"Resumes playing the current paused sound in a voice channel. The bot must be connected to a voice channel in the guild specified. Parameters guild_id - ID of guild whose voice channel the sound will be resumed in. Returns {:error, reason} if unable to resume or no sound has been paused, otherwise returns :ok . This function is used to resume a sound that had previously been paused. Examples iex&gt; Remedy.Voice.join_channel(123456789, 420691337) iex&gt; Remedy.Voice.play(123456789, &quot;~/stuff/Toto - Africa (Bass Boosted)&quot;) iex&gt; Remedy.Voice.pause(123456789) iex&gt; Remedy.Voice.resume(123456789)","ref":"Remedy.Voice.html#resume/1","title":"Remedy.Voice.resume/1","type":"function"},{"doc":"Low-level. Send pre-encoded audio packets directly. Speaking should be set to true via Remedy.Voice.set_is_speaking/2 before sending frames. Opus frames will be encrypted and prefixed with the appropriate RTP header and sent immediately. The length of frames depends on how often you wish to send a sequence of frames. A single frame contains 20ms of audio. Sending more than 50 frames (1 second of audio) in a single function call may result in inconsistent playback rates. Remedy.Voice.playing?/1 will not return accurate values when using send_frames/2 instead of Remedy.Voice.play/4","ref":"Remedy.Voice.html#send_frames/2","title":"Remedy.Voice.send_frames/2","type":"function"},{"doc":"Low-level. Set speaking flag in voice channel. This function does not need to be called unless you are sending audio frames directly using Remedy.Voice.send_frames/2 .","ref":"Remedy.Voice.html#set_is_speaking/2","title":"Remedy.Voice.set_is_speaking/2","type":"function"},{"doc":"Stops the current sound being played in a voice channel. The bot must be connected to a voice channel in the guild specified. Parameters guild_id - ID of guild whose voice channel the sound will be stopped in. Returns {:error, reason} if unable to stop or no sound is playing, else :ok . If a sound has finished playing, this function does not need to be called to start playing another sound. Examples iex&gt; Remedy.Voice.join_channel(123456789, 420691337) iex&gt; Remedy.Voice.play(123456789, &quot;http://brandthill.com/files/weird_dubstep_noises.mp3&quot;) iex&gt; Remedy.Voice.stop(123456789)","ref":"Remedy.Voice.html#stop/1","title":"Remedy.Voice.stop/1","type":"function"},{"doc":"Voice Event","ref":"Remedy.Voice.Event.html","title":"Remedy.Voice.Event","type":"module"},{"doc":"","ref":"Remedy.Voice.Event.html#handle/3","title":"Remedy.Voice.Event.handle/3","type":"function"},{"doc":"Represents a failed response from the API. This occurs when hackney or HTTPoison fail, or when the API doesn't respond with 200 or 204 . This should only occur when using the banged API methods. Check the Format","ref":"Remedy.Error.ApiError.html","title":"Remedy.Error.ApiError","type":"exception"},{"doc":"","ref":"Remedy.Error.ApiError.html#t:detailed_error/0","title":"Remedy.Error.ApiError.detailed_error/0","type":"type"},{"doc":"","ref":"Remedy.Error.ApiError.html#t:discord_status_code/0","title":"Remedy.Error.ApiError.discord_status_code/0","type":"type"},{"doc":"","ref":"Remedy.Error.ApiError.html#t:error/0","title":"Remedy.Error.ApiError.error/0","type":"type"},{"doc":"","ref":"Remedy.Error.ApiError.html#t:error_list_map/0","title":"Remedy.Error.ApiError.error_list_map/0","type":"type"},{"doc":"","ref":"Remedy.Error.ApiError.html#t:errors/0","title":"Remedy.Error.ApiError.errors/0","type":"type"},{"doc":"","ref":"Remedy.Error.ApiError.html#t:response/0","title":"Remedy.Error.ApiError.response/0","type":"type"},{"doc":"","ref":"Remedy.Error.ApiError.html#t:status_code/0","title":"Remedy.Error.ApiError.status_code/0","type":"type"},{"doc":"","ref":"Remedy.Error.ApiError.html#t:t/0","title":"Remedy.Error.ApiError.t/0","type":"type"},{"doc":"Represents an error when interacting with the cache. This likely occurs because a specified item could not be found in the cache, or your were searching for something invalid. This should only occur when using the banged cache methods.","ref":"Remedy.Error.CacheError.html","title":"Remedy.Error.CacheError","type":"exception"},{"doc":"Represents an error when playing sound through voice channels. This occurs when attempting to play audio and Porcelain can't find either the ffmpeg executable or the youtube-dl executable.","ref":"Remedy.Error.VoiceError.html","title":"Remedy.Error.VoiceError","type":"exception"},{"doc":"Remedy Playground fork of Nostrum discord library. I am still using Nostrum for my bots and I recommend you do the same. This is just a playground.","ref":"introduction.html","title":"Remedy","type":"extras"},{"doc":"Gun 2.0 Separate applicable components into their own packages. Organise types - Timestamp / Snowflake Convert structs to schema to... Make the casting easier. Make storing them in a db easier. Prevent the end user re modelling these things for their own db. Convert cache to Etso. integrate nicely with new schema. Generalize cache. Choose what to cache. eg i only want to cache user presence and message embeds... Make it an actual cache, aka invisible and if the resource is not in cache, we should fetch it and return it as required. Testing Supply a bot secret thru workflow to enable actual testing on a real server. without exposing secrets (prob too hard) Bang functions?!? Remove all the bloaty manual stuff. Include a generic unsafe.","ref":"introduction.html#goals","title":"Remedy - Goals","type":"extras"},{"doc":"I have extracted various components from the codebase which in my opinion are cluttering the code with static helpers at various layers of abstraction. You are welcome to use them and submit any improvements you find. Sunbake For easy types. Timestamp and Snowflake currently included. Battle Standard Clean up all those manual flag helpers. just use BattleStandard","ref":"introduction.html#packages","title":"Remedy - Packages","type":"extras"}]